      DOUBLE PRECISION AA(200,200),A(201,200),B(200),X(200)             00010000
      DOUBLE PRECISION TIME(8,6),CRAY,OPS,TOTAL,NORMA,NORMX             00020000
      DOUBLE PRECISION RESID,RESIDN,EPS,EPSLON                          00030000
      INTEGER IPVT(200)                                                 00040000
	CALL PEPA_START
      LDA = 201                                                         00050000
      LDAA = 200                                                        00060000
C                                                                       00070000
      N = 100                                                           00080000
      CRAY = .056                                                       00090000
      WRITE(6,1)                                                        00100000
    1 FORMAT(' PLEASE SEND THE RESULTS OF THIS RUN TO:'//               00110000
     \       ' JACK J. DONGARRA'/                                       00120000
     \       ' MATHEMATICS AND COMPUTER SCIENCE DIVISION'/              00130000
     \       ' ARGONNE NATIONAL LABORATORY'/                            00140000
     \       ' ARGONNE, ILLINOIS 60439'//                               00150000
     \       ' TELEPHONE: 312-972-7246'//                               00160000
     \       ' ARPANET: DONGARRA@ANL-MCS'/)                             00170000
      OPS = (2.0D0*N**3)/3.0D0 + 2.0D0*N**2                             00180000
C                                                                       00190000
         CALL MATGEN(A,LDA,N,B,NORMA)                                   00200000
         T1 = SECOND(DUMMY)                                             00210000
         CALL DGEFA(A,LDA,N,IPVT,INFO)                                  00220000
         TIME(1,1) = SECOND(DUMMY) - T1                                 00230000
         T1 = SECOND(DUMMY)                                             00240000
         CALL DGESL(A,LDA,N,IPVT,B,0)                                   00250000
         TIME(1,2) = SECOND(DUMMY) - T1                                 00260000
         TOTAL = TIME(1,1) + TIME(1,2)                                  00270000
C                                                                       00280000
C     COMPUTE A RESIDUAL TO VERIFY RESULTS.                             00290000
C                                                                       00300000
         DO 10 I = 1,N                                                  00310000
            X(I) = B(I)                                                 00320000
   10    CONTINUE                                                       00330000
         CALL MATGEN(A,LDA,N,B,NORMA)                                   00340000
         DO 20 I = 1,N                                                  00350000
            B(I) = -B(I)                                                00360000
   20    CONTINUE                                                       00370000
         CALL DMXPY(N,B,N,LDA,X,A)                                      00380000
         RESID = 0.0                                                    00390000
         NORMX = 0.0                                                    00400000
         DO 30 I = 1,N                                                  00410000
            RESID = DMAX1( RESID, DABS(B(I)) )                          00420000
            NORMX = DMAX1( NORMX, DABS(X(I)) )                          00430000
   30    CONTINUE                                                       00440000
         EPS = EPSLON(1.0D0)                                            00450000
         RESIDN = RESID/( N*NORMA*NORMX*EPS )                           00460000
         WRITE(6,40)                                                    00470000
   40    FORMAT('     NORM. RESID      RESID           MACHEP',         00480000
     \          '         X(1)          X(N)')                          00490000
         WRITE(6,50) RESIDN,RESID,EPS,X(1),X(N)                         00500000
   50    FORMAT(1P5E16.8)                                               00510000
C                                                                       00520000
         WRITE(6,60) N                                                  00530000
   60    FORMAT(//'    TIMES ARE REPORTED FOR MATRICES OF ORDER ',I5)   00540000
         WRITE(6,70)                                                    00550000
   70    FORMAT(6X,'DGEFA',6X,'DGESL',6X,'TOTAL',5X,'MFLOPS',7X,'UNIT', 00560000
     \         6X,'RATIO')                                              00570000
C                                                                       00580000
         TIME(1,3) = TOTAL                                              00590000
         TIME(1,4) = OPS/(1.0D6*TOTAL)                                  00600000
         TIME(1,5) = 2.0D0/TIME(1,4)                                    00610000
         TIME(1,6) = TOTAL/CRAY                                         00620000
         WRITE(6,80) LDA                                                00630000
   80    FORMAT(' TIMES FOR ARRAY WITH LEADING DIMENSION OF',I4)        00640000
         WRITE(6,110) (TIME(1,I),I=1,6)                                 00650000
C                                                                       00660000
         CALL MATGEN(A,LDA,N,B,NORMA)                                   00670000
         T1 = SECOND(DUMMY)                                             00680000
         CALL DGEFA(A,LDA,N,IPVT,INFO)                                  00690000
         TIME(2,1) = SECOND(DUMMY) - T1                                 00700000
         T1 = SECOND(DUMMY)                                             00710000
         CALL DGESL(A,LDA,N,IPVT,B,0)                                   00720000
         TIME(2,2) = SECOND(DUMMY) - T1                                 00730000
         TOTAL = TIME(2,1) + TIME(2,2)                                  00740000
         TIME(2,3) = TOTAL                                              00750000
         TIME(2,4) = OPS/(1.0D6*TOTAL)                                  00760000
         TIME(2,5) = 2.0D0/TIME(2,4)                                    00770000
         TIME(2,6) = TOTAL/CRAY                                         00780000
C                                                                       00790000
         CALL MATGEN(A,LDA,N,B,NORMA)                                   00800000
         T1 = SECOND(DUMMY)                                             00810000
         CALL DGEFA(A,LDA,N,IPVT,INFO)                                  00820000
         TIME(3,1) = SECOND(DUMMY) - T1                                 00830000
         T1 = SECOND(DUMMY)                                             00840000
         CALL DGESL(A,LDA,N,IPVT,B,0)                                   00850000
         TIME(3,2) = SECOND(DUMMY) - T1                                 00860000
         TOTAL = TIME(3,1) + TIME(3,2)                                  00870000
         TIME(3,3) = TOTAL                                              00880000
         TIME(3,4) = OPS/(1.0D6*TOTAL)                                  00890000
         TIME(3,5) = 2.0D0/TIME(3,4)                                    00900000
         TIME(3,6) = TOTAL/CRAY                                         00910000
C                                                                       00920000
         NTIMES = 10                                                    00930000
         TM2 = 0                                                        00940000
         T1 = SECOND(DUMMY)                                             00950000
         DO 90 I = 1,NTIMES                                             00960000
            TM = SECOND(DUMMY)                                          00970000
            CALL MATGEN(A,LDA,N,B,NORMA)                                00980000
            TM2 = TM2 + SECOND(DUMMY) - TM                              00990000
            CALL DGEFA(A,LDA,N,IPVT,INFO)                               01000000
   90    CONTINUE                                                       01010000
         TIME(4,1) = (SECOND(DUMMY) - T1 - TM2)/NTIMES                  01020000
         T1 = SECOND(DUMMY)                                             01030000
         DO 100 I = 1,NTIMES                                            01040000
            CALL DGESL(A,LDA,N,IPVT,B,0)                                01050000
  100    CONTINUE                                                       01060000
         TIME(4,2) = (SECOND(DUMMY) - T1)/NTIMES                        01070000
         TOTAL = TIME(4,1) + TIME(4,2)                                  01080000
         TIME(4,3) = TOTAL                                              01090000
         TIME(4,4) = OPS/(1.0D6*TOTAL)                                  01100000
         TIME(4,5) = 2.0D0/TIME(4,4)                                    01110000
         TIME(4,6) = TOTAL/CRAY                                         01120000
C                                                                       01130000
         WRITE(6,110) (TIME(2,I),I=1,6)                                 01140000
         WRITE(6,110) (TIME(3,I),I=1,6)                                 01150000
         WRITE(6,110) (TIME(4,I),I=1,6)                                 01160000
  110    FORMAT(6(1PE11.3))                                             01170000
C                                                                       01180000
         CALL MATGEN(AA,LDAA,N,B,NORMA)                                 01190000
         T1 = SECOND(DUMMY)                                             01200000
         CALL DGEFA(AA,LDAA,N,IPVT,INFO)                                01210000
         TIME(5,1) = SECOND(DUMMY) - T1                                 01220000
         T1 = SECOND(DUMMY)                                             01230000
         CALL DGESL(AA,LDAA,N,IPVT,B,0)                                 01240000
         TIME(5,2) = SECOND(DUMMY) - T1                                 01250000
         TOTAL = TIME(5,1) + TIME(5,2)                                  01260000
         TIME(5,3) = TOTAL                                              01270000
         TIME(5,4) = OPS/(1.0D6*TOTAL)                                  01280000
         TIME(5,5) = 2.0D0/TIME(5,4)                                    01290000
         TIME(5,6) = TOTAL/CRAY                                         01300000
C                                                                       01310000
         CALL MATGEN(AA,LDAA,N,B,NORMA)                                 01320000
         T1 = SECOND(DUMMY)                                             01330000
         CALL DGEFA(AA,LDAA,N,IPVT,INFO)                                01340000
         TIME(6,1) = SECOND(DUMMY) - T1                                 01350000
         T1 = SECOND(DUMMY)                                             01360000
         CALL DGESL(AA,LDAA,N,IPVT,B,0)                                 01370000
         TIME(6,2) = SECOND(DUMMY) - T1                                 01380000
         TOTAL = TIME(6,1) + TIME(6,2)                                  01390000
         TIME(6,3) = TOTAL                                              01400000
         TIME(6,4) = OPS/(1.0D6*TOTAL)                                  01410000
         TIME(6,5) = 2.0D0/TIME(6,4)                                    01420000
         TIME(6,6) = TOTAL/CRAY                                         01430000
C                                                                       01440000
         CALL MATGEN(AA,LDAA,N,B,NORMA)                                 01450000
         T1 = SECOND(DUMMY)                                             01460000
         CALL DGEFA(AA,LDAA,N,IPVT,INFO)                                01470000
         TIME(7,1) = SECOND(DUMMY) - T1                                 01480000
         T1 = SECOND(DUMMY)                                             01490000
         CALL DGESL(AA,LDAA,N,IPVT,B,0)                                 01500000
         TIME(7,2) = SECOND(DUMMY) - T1                                 01510000
         TOTAL = TIME(7,1) + TIME(7,2)                                  01520000
         TIME(7,3) = TOTAL                                              01530000
         TIME(7,4) = OPS/(1.0D6*TOTAL)                                  01540000
         TIME(7,5) = 2.0D0/TIME(7,4)                                    01550000
         TIME(7,6) = TOTAL/CRAY                                         01560000
C                                                                       01570000
         NTIMES = 10                                                    01580000
         TM2 = 0                                                        01590000
         T1 = SECOND(DUMMY)                                             01600000
         DO 120 I = 1,NTIMES                                            01610000
            TM = SECOND(DUMMY)                                          01620000
            CALL MATGEN(AA,LDAA,N,B,NORMA)                              01630000
            TM2 = TM2 + SECOND(DUMMY) - TM                              01640000
            CALL DGEFA(AA,LDAA,N,IPVT,INFO)                             01650000
  120    CONTINUE                                                       01660000
         TIME(8,1) = (SECOND(DUMMY) - T1 - TM2)/NTIMES                  01670000
         T1 = SECOND(DUMMY)                                             01680000
         DO 130 I = 1,NTIMES                                            01690000
            CALL DGESL(AA,LDAA,N,IPVT,B,0)                              01700000
  130    CONTINUE                                                       01710000
         TIME(8,2) = (SECOND(DUMMY) - T1)/NTIMES                        01720000
         TOTAL = TIME(8,1) + TIME(8,2)                                  01730000
         TIME(8,3) = TOTAL                                              01740000
         TIME(8,4) = OPS/(1.0D6*TOTAL)                                  01750000
         TIME(8,5) = 2.0D0/TIME(8,4)                                    01760000
         TIME(8,6) = TOTAL/CRAY                                         01770000
C                                                                       01780000
         WRITE(6,140) LDAA                                              01790000
  140    FORMAT(/' TIMES FOR ARRAY WITH LEADING DIMENSION OF',I4)       01800000
         WRITE(6,110) (TIME(5,I),I=1,6)                                 01810000
         WRITE(6,110) (TIME(6,I),I=1,6)                                 01820000
         WRITE(6,110) (TIME(7,I),I=1,6)                                 01830000
         WRITE(6,110) (TIME(8,I),I=1,6)                                 01840000
	CALL PEPA_STOP
      STOP                                                              01850000
      END                                                               01860000
      SUBROUTINE MATGEN(A,LDA,N,B,NORMA)                                01870000
      DOUBLE PRECISION A(LDA,1),B(1),NORMA                              01880000
C                                                                       01890000
      INIT = 1325                                                       01900000
      NORMA = 0.0                                                       01910000
      DO 30 J = 1,N                                                     01920000
         DO 20 I = 1,N                                                  01930000
            INIT = MOD(3125*INIT,65536)                                 01940000
            A(I,J) = (INIT - 32768.0)/16384.0                           01950000
            NORMA = DMAX1(A(I,J), NORMA)                                01960000
   20    CONTINUE                                                       01970000
   30 CONTINUE                                                          01980000
      DO 35 I = 1,N                                                     01990000
          B(I) = 0.0                                                    02000000
   35 CONTINUE                                                          02010000
      DO 50 J = 1,N                                                     02020000
         DO 40 I = 1,N                                                  02030000
            B(I) = B(I) + A(I,J)                                        02040000
   40    CONTINUE                                                       02050000
   50 CONTINUE                                                          02060000
      RETURN                                                            02070000
      END                                                               02080000
      SUBROUTINE DGEFA(A,LDA,N,IPVT,INFO)                               02090000
      INTEGER LDA,N,IPVT(1),INFO                                        02100000
      DOUBLE PRECISION A(LDA,1)                                         02110000
C                                                                       02120000
C     DGEFA FACTORS A DOUBLE PRECISION MATRIX BY GAUSSIAN ELIMINATION.  02130000
C                                                                       02140000
C     DGEFA IS USUALLY CALLED BY DGECO, BUT IT CAN BE CALLED            02150000
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.          02160000
C     (TIME FOR DGECO) = (1 + 9/N)*(TIME FOR DGEFA) .                   02170000
C                                                                       02180000
C     ON ENTRY                                                          02190000
C                                                                       02200000
C        A       DOUBLE PRECISION(LDA, N)                               02210000
C                THE MATRIX TO BE FACTORED.                             02220000
C                                                                       02230000
C        LDA     INTEGER                                                02240000
C                THE LEADING DIMENSION OF THE ARRAY  A .                02250000
C                                                                       02260000
C        N       INTEGER                                                02270000
C                THE ORDER OF THE MATRIX  A .                           02280000
C                                                                       02290000
C     ON RETURN                                                         02300000
C                                                                       02310000
C        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS         02320000
C                WHICH WERE USED TO OBTAIN IT.                          02330000
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE       02340000
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER          02350000
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.       02360000
C                                                                       02370000
C        IPVT    INTEGER(N)                                             02380000
C                AN INTEGER VECTOR OF PIVOT INDICES.                    02390000
C                                                                       02400000
C        INFO    INTEGER                                                02410000
C                = 0  NORMAL VALUE.                                     02420000
C                = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR       02430000
C                     CONDITION FOR THIS SUBROUTINE, BUT IT DOES        02440000
C                     INDICATE THAT DGESL OR DGEDI WILL DIVIDE BY ZERO  02450000
C                     IF CALLED.  USE  RCOND  IN DGECO FOR A RELIABLE   02460000
C                     INDICATION OF SINGULARITY.                        02470000
C                                                                       02480000
C     LINPACK. THIS VERSION DATED 08/14/78 .                            02490000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      02500000
C                                                                       02510000
C     SUBROUTINES AND FUNCTIONS                                         02520000
C                                                                       02530000
C     BLAS DAXPY,DSCAL,IDAMAX                                           02540000
C                                                                       02550000
C     INTERNAL VARIABLES                                                02560000
C                                                                       02570000
      DOUBLE PRECISION T                                                02580000
      INTEGER IDAMAX,J,K,KP1,L,NM1                                      02590000
C                                                                       02600000
C                                                                       02610000
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING                        02620000
C                                                                       02630000
      INFO = 0                                                          02640000
      NM1 = N - 1                                                       02650000
      IF (NM1 .LT. 1) GO TO 70                                          02660000
      DO 60 K = 1, NM1                                                  02670000
         KP1 = K + 1                                                    02680000
C                                                                       02690000
C        FIND L = PIVOT INDEX                                           02700000
C                                                                       02710000
         L = IDAMAX(N-K+1,A(K,K),1) + K - 1                             02720000
         IPVT(K) = L                                                    02730000
C                                                                       02740000
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED          02750000
C                                                                       02760000
         IF (A(L,K) .EQ. 0.0D0) GO TO 40                                02770000
C                                                                       02780000
C           INTERCHANGE IF NECESSARY                                    02790000
C                                                                       02800000
            IF (L .EQ. K) GO TO 10                                      02810000
               T = A(L,K)                                               02820000
               A(L,K) = A(K,K)                                          02830000
               A(K,K) = T                                               02840000
   10       CONTINUE                                                    02850000
C                                                                       02860000
C           COMPUTE MULTIPLIERS                                         02870000
C                                                                       02880000
            T = -1.0D0/A(K,K)                                           02890000
            CALL DSCAL(N-K,T,A(K+1,K),1)                                02900000
C                                                                       02910000
C           ROW ELIMINATION WITH COLUMN INDEXING                        02920000
C                                                                       02930000
            DO 30 J = KP1, N                                            02940000
               T = A(L,J)                                               02950000
               IF (L .EQ. K) GO TO 20                                   02960000
                  A(L,J) = A(K,J)                                       02970000
                  A(K,J) = T                                            02980000
   20          CONTINUE                                                 02990000
               CALL DAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)                  03000000
   30       CONTINUE                                                    03010000
         GO TO 50                                                       03020000
   40    CONTINUE                                                       03030000
            INFO = K                                                    03040000
   50    CONTINUE                                                       03050000
   60 CONTINUE                                                          03060000
   70 CONTINUE                                                          03070000
      IPVT(N) = N                                                       03080000
      IF (A(N,N) .EQ. 0.0D0) INFO = N                                   03090000
      RETURN                                                            03100000
      END                                                               03110000
      SUBROUTINE DGESL(A,LDA,N,IPVT,B,JOB)                              03120000
      INTEGER LDA,N,IPVT(1),JOB                                         03130000
      DOUBLE PRECISION A(LDA,1),B(1)                                    03140000
C                                                                       03150000
C     DGESL SOLVES THE DOUBLE PRECISION SYSTEM                          03160000
C     A * X = B  OR  TRANS(A) * X = B                                   03170000
C     USING THE FACTORS COMPUTED BY DGECO OR DGEFA.                     03180000
C                                                                       03190000
C     ON ENTRY                                                          03200000
C                                                                       03210000
C        A       DOUBLE PRECISION(LDA, N)                               03220000
C                THE OUTPUT FROM DGECO OR DGEFA.                        03230000
C                                                                       03240000
C        LDA     INTEGER                                                03250000
C                THE LEADING DIMENSION OF THE ARRAY  A .                03260000
C                                                                       03270000
C        N       INTEGER                                                03280000
C                THE ORDER OF THE MATRIX  A .                           03290000
C                                                                       03300000
C        IPVT    INTEGER(N)                                             03310000
C                THE PIVOT VECTOR FROM DGECO OR DGEFA.                  03320000
C                                                                       03330000
C        B       DOUBLE PRECISION(N)                                    03340000
C                THE RIGHT HAND SIDE VECTOR.                            03350000
C                                                                       03360000
C        JOB     INTEGER                                                03370000
C                = 0         TO SOLVE  A*X = B ,                        03380000
C                = NONZERO   TO SOLVE  TRANS(A)*X = B  WHERE            03390000
C                            TRANS(A)  IS THE TRANSPOSE.                03400000
C                                                                       03410000
C     ON RETURN                                                         03420000
C                                                                       03430000
C        B       THE SOLUTION VECTOR  X .                               03440000
C                                                                       03450000
C     ERROR CONDITION                                                   03460000
C                                                                       03470000
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A   03480000
C        ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES SINGULARITY  03490000
C        BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER       03500000
C        SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE     03510000
C        CALLED CORRECTLY AND IF DGECO HAS SET RCOND .GT. 0.0           03520000
C        OR DGEFA HAS SET INFO .EQ. 0 .                                 03530000
C                                                                       03540000
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX                 03550000
C     WITH  P  COLUMNS                                                  03560000
C           CALL DGECO(A,LDA,N,IPVT,RCOND,Z)                            03570000
C           IF (RCOND IS TOO SMALL) GO TO ...                           03580000
C           DO 10 J = 1, P                                              03590000
C              CALL DGESL(A,LDA,N,IPVT,C(1,J),0)                        03600000
C        10 CONTINUE                                                    03610000
C                                                                       03620000
C     LINPACK. THIS VERSION DATED 08/14/78 .                            03630000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      03640000
C                                                                       03650000
C     SUBROUTINES AND FUNCTIONS                                         03660000
C                                                                       03670000
C     BLAS DAXPY,DDOT                                                   03680000
C                                                                       03690000
C     INTERNAL VARIABLES                                                03700000
C                                                                       03710000
      DOUBLE PRECISION DDOT,T                                           03720000
      INTEGER K,KB,L,NM1                                                03730000
C                                                                       03740000
      NM1 = N - 1                                                       03750000
      IF (JOB .NE. 0) GO TO 50                                          03760000
C                                                                       03770000
C        JOB = 0 , SOLVE  A * X = B                                     03780000
C        FIRST SOLVE  L*Y = B                                           03790000
C                                                                       03800000
         IF (NM1 .LT. 1) GO TO 30                                       03810000
         DO 20 K = 1, NM1                                               03820000
            L = IPVT(K)                                                 03830000
            T = B(L)                                                    03840000
            IF (L .EQ. K) GO TO 10                                      03850000
               B(L) = B(K)                                              03860000
               B(K) = T                                                 03870000
   10       CONTINUE                                                    03880000
            CALL DAXPY(N-K,T,A(K+1,K),1,B(K+1),1)                       03890000
   20    CONTINUE                                                       03900000
   30    CONTINUE                                                       03910000
C                                                                       03920000
C        NOW SOLVE  U*X = Y                                             03930000
C                                                                       03940000
         DO 40 KB = 1, N                                                03950000
            K = N + 1 - KB                                              03960000
            B(K) = B(K)/A(K,K)                                          03970000
            T = -B(K)                                                   03980000
            CALL DAXPY(K-1,T,A(1,K),1,B(1),1)                           03990000
   40    CONTINUE                                                       04000000
      GO TO 100                                                         04010000
   50 CONTINUE                                                          04020000
C                                                                       04030000
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B                         04040000
C        FIRST SOLVE  TRANS(U)*Y = B                                    04050000
C                                                                       04060000
         DO 60 K = 1, N                                                 04070000
            T = DDOT(K-1,A(1,K),1,B(1),1)                               04080000
            B(K) = (B(K) - T)/A(K,K)                                    04090000
   60    CONTINUE                                                       04100000
C                                                                       04110000
C        NOW SOLVE TRANS(L)*X = Y                                       04120000
C                                                                       04130000
         IF (NM1 .LT. 1) GO TO 90                                       04140000
         DO 80 KB = 1, NM1                                              04150000
            K = N - KB                                                  04160000
            B(K) = B(K) + DDOT(N-K,A(K+1,K),1,B(K+1),1)                 04170000
            L = IPVT(K)                                                 04180000
            IF (L .EQ. K) GO TO 70                                      04190000
               T = B(L)                                                 04200000
               B(L) = B(K)                                              04210000
               B(K) = T                                                 04220000
   70       CONTINUE                                                    04230000
   80    CONTINUE                                                       04240000
   90    CONTINUE                                                       04250000
  100 CONTINUE                                                          04260000
      RETURN                                                            04270000
      END                                                               04280000
      SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)                            04290000
C                                                                       04300000
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.                            04310000
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  04320000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  04330000
C                                                                       04340000
      DOUBLE PRECISION DX(1),DY(1),DA                                   04350000
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 04360000
C                                                                       04370000
      IF(N.LE.0)RETURN                                                  04380000
      IF (DA .EQ. 0.0D0) RETURN                                         04390000
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               04400000
C                                                                       04410000
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                04420000
C          NOT EQUAL TO 1                                               04430000
C                                                                       04440000
      IX = 1                                                            04450000
      IY = 1                                                            04460000
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 04470000
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 04480000
      DO 10 I = 1,N                                                     04490000
        DY(IY) = DY(IY) + DA*DX(IX)                                     04500000
        IX = IX + INCX                                                  04510000
        IY = IY + INCY                                                  04520000
   10 CONTINUE                                                          04530000
      RETURN                                                            04540000
C                                                                       04550000
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            04560000
C                                                                       04570000
C                                                                       04580000
C        CLEAN-UP LOOP                                                  04590000
C                                                                       04600000
   20 M = MOD(N,4)                                                      04610000
      IF( M .EQ. 0 ) GO TO 40                                           04620000
      DO 30 I = 1,M                                                     04630000
        DY(I) = DY(I) + DA*DX(I)                                        04640000
   30 CONTINUE                                                          04650000
      IF( N .LT. 4 ) RETURN                                             04660000
   40 MP1 = M + 1                                                       04670000
      DO 50 I = MP1,N,4                                                 04680000
        DY(I) = DY(I) + DA*DX(I)                                        04690000
        DY(I + 1) = DY(I + 1) + DA*DX(I + 1)                            04700000
        DY(I + 2) = DY(I + 2) + DA*DX(I + 2)                            04710000
        DY(I + 3) = DY(I + 3) + DA*DX(I + 3)                            04720000
   50 CONTINUE                                                          04730000
      RETURN                                                            04740000
      END                                                               04750000
      DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)                 04760000
C                                                                       04770000
C     FORMS THE DOT PRODUCT OF TWO VECTORS.                             04780000
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  04790000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  04800000
C                                                                       04810000
      DOUBLE PRECISION DX(1),DY(1),DTEMP                                04820000
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 04830000
C                                                                       04840000
      DDOT = 0.0D0                                                      04850000
      DTEMP = 0.0D0                                                     04860000
      IF(N.LE.0)RETURN                                                  04870000
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               04880000
C                                                                       04890000
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                04900000
C          NOT EQUAL TO 1                                               04910000
C                                                                       04920000
      IX = 1                                                            04930000
      IY = 1                                                            04940000
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 04950000
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 04960000
      DO 10 I = 1,N                                                     04970000
        DTEMP = DTEMP + DX(IX)*DY(IY)                                   04980000
        IX = IX + INCX                                                  04990000
        IY = IY + INCY                                                  05000000
   10 CONTINUE                                                          05010000
      DDOT = DTEMP                                                      05020000
      RETURN                                                            05030000
C                                                                       05040000
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            05050000
C                                                                       05060000
C                                                                       05070000
C        CLEAN-UP LOOP                                                  05080000
C                                                                       05090000
   20 M = MOD(N,5)                                                      05100000
      IF( M .EQ. 0 ) GO TO 40                                           05110000
      DO 30 I = 1,M                                                     05120000
        DTEMP = DTEMP + DX(I)*DY(I)                                     05130000
   30 CONTINUE                                                          05140000
      IF( N .LT. 5 ) GO TO 60                                           05150000
   40 MP1 = M + 1                                                       05160000
      DO 50 I = MP1,N,5                                                 05170000
        DTEMP = DTEMP + DX(I)*DY(I) + DX(I + 1)*DY(I + 1) +             05180000
     *   DX(I + 2)*DY(I + 2) + DX(I + 3)*DY(I + 3) + DX(I + 4)*DY(I + 4)05190000
   50 CONTINUE                                                          05200000
   60 DDOT = DTEMP                                                      05210000
      RETURN                                                            05220000
      END                                                               05230000
      SUBROUTINE  DSCAL(N,DA,DX,INCX)                                   05240000
C                                                                       05250000
C     SCALES A VECTOR BY A CONSTANT.                                    05260000
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.                   05270000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  05280000
C                                                                       05290000
      DOUBLE PRECISION DA,DX(1)                                         05300000
      INTEGER I,INCX,M,MP1,N,NINCX                                      05310000
C                                                                       05320000
      IF(N.LE.0)RETURN                                                  05330000
      IF(INCX.EQ.1)GO TO 20                                             05340000
C                                                                       05350000
C        CODE FOR INCREMENT NOT EQUAL TO 1                              05360000
C                                                                       05370000
      NINCX = N*INCX                                                    05380000
      DO 10 I = 1,NINCX,INCX                                            05390000
        DX(I) = DA*DX(I)                                                05400000
   10 CONTINUE                                                          05410000
      RETURN                                                            05420000
C                                                                       05430000
C        CODE FOR INCREMENT EQUAL TO 1                                  05440000
C                                                                       05450000
C                                                                       05460000
C        CLEAN-UP LOOP                                                  05470000
C                                                                       05480000
   20 M = MOD(N,5)                                                      05490000
      IF( M .EQ. 0 ) GO TO 40                                           05500000
      DO 30 I = 1,M                                                     05510000
        DX(I) = DA*DX(I)                                                05520000
   30 CONTINUE                                                          05530000
      IF( N .LT. 5 ) RETURN                                             05540000
   40 MP1 = M + 1                                                       05550000
      DO 50 I = MP1,N,5                                                 05560000
        DX(I) = DA*DX(I)                                                05570000
        DX(I + 1) = DA*DX(I + 1)                                        05580000
        DX(I + 2) = DA*DX(I + 2)                                        05590000
        DX(I + 3) = DA*DX(I + 3)                                        05600000
        DX(I + 4) = DA*DX(I + 4)                                        05610000
   50 CONTINUE                                                          05620000
      RETURN                                                            05630000
      END                                                               05640000
      INTEGER FUNCTION IDAMAX(N,DX,INCX)                                05650000
C                                                                       05660000
C     FINDS THE INDEX OF ELEMENT HAVING MAX. DABSOLUTE VALUE.           05670000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  05680000
C                                                                       05690000
      DOUBLE PRECISION DX(1),DMAX                                       05700000
      INTEGER I,INCX,IX,N                                               05710000
C                                                                       05720000
      IDAMAX = 0                                                        05730000
      IF( N .LT. 1 ) RETURN                                             05740000
      IDAMAX = 1                                                        05750000
      IF(N.EQ.1)RETURN                                                  05760000
      IF(INCX.EQ.1)GO TO 20                                             05770000
C                                                                       05780000
C        CODE FOR INCREMENT NOT EQUAL TO 1                              05790000
C                                                                       05800000
      IX = 1                                                            05810000
      DMAX = DABS(DX(1))                                                05820000
      IX = IX + INCX                                                    05830000
      DO 10 I = 2,N                                                     05840000
         IF(DABS(DX(IX)).LE.DMAX) GO TO 5                               05850000
         IDAMAX = I                                                     05860000
         DMAX = DABS(DX(IX))                                            05870000
    5    IX = IX + INCX                                                 05880000
   10 CONTINUE                                                          05890000
      RETURN                                                            05900000
C                                                                       05910000
C        CODE FOR INCREMENT EQUAL TO 1                                  05920000
C                                                                       05930000
   20 DMAX = DABS(DX(1))                                                05940000
      DO 30 I = 2,N                                                     05950000
         IF(DABS(DX(I)).LE.DMAX) GO TO 30                               05960000
         IDAMAX = I                                                     05970000
         DMAX = DABS(DX(I))                                             05980000
   30 CONTINUE                                                          05990000
      RETURN                                                            06000000
      END                                                               06010000
      DOUBLE PRECISION FUNCTION EPSLON (X)                              06020000
      DOUBLE PRECISION X                                                06030000
C                                                                       06040000
C     ESTIMATE UNIT ROUNDOFF IN QUANTITIES OF SIZE X.                   06050000
C                                                                       06060000
      DOUBLE PRECISION A,B,C,EPS                                        06070000
C                                                                       06080000
C     THIS PROGRAM SHOULD FUNCTION PROPERLY ON ALL SYSTEMS              06090000
C     SATISFYING THE FOLLOWING TWO ASSUMPTIONS,                         06100000
C        1.  THE BASE USED IN REPRESENTING DFLOATING POINT              06110000
C            NUMBERS IS NOT A POWER OF THREE.                           06120000
C        2.  THE QUANTITY  A  IN STATEMENT 10 IS REPRESENTED TO         06130000
C            THE ACCURACY USED IN DFLOATING POINT VARIABLES             06140000
C            THAT ARE STORED IN MEMORY.                                 06150000
C     THE STATEMENT NUMBER 10 AND THE GO TO 10 ARE INTENDED TO          06160000
C     FORCE OPTIMIZING COMPILERS TO GENERATE CODE SATISFYING            06170000
C     ASSUMPTION 2.                                                     06180000
C     UNDER THESE ASSUMPTIONS, IT SHOULD BE TRUE THAT,                  06190000
C            A  IS NOT EXACTLY EQUAL TO FOUR-THIRDS,                    06200000
C            B  HAS A ZERO FOR ITS LAST BIT OR DIGIT,                   06210000
C            C  IS NOT EXACTLY EQUAL TO ONE,                            06220000
C            EPS  MEASURES THE SEPARATION OF 1.0 FROM                   06230000
C                 THE NEXT LARGER DFLOATING POINT NUMBER.               06240000
C     THE DEVELOPERS OF EISPACK WOULD APPRECIATE BEING INFORMED         06250000
C     ABOUT ANY SYSTEMS WHERE THESE ASSUMPTIONS DO NOT HOLD.            06260000
C                                                                       06270000
C     ***************************************************************** 06280000
C     THIS ROUTINE IS ONE OF THE AUXILIARY ROUTINES USED BY EISPACK III 06290000
C     TO AVOID MACHINE DEPENDENCIES.                                    06300000
C     ***************************************************************** 06310000
C                                                                       06320000
C     THIS VERSION DATED 4/6/83.                                        06330000
C                                                                       06340000
      A = 4.0D0/3.0D0                                                   06350000
   10 B = A - 1.0D0                                                     06360000
      C = B + B + B                                                     06370000
      EPS = DABS(C-1.0D0)                                               06380000
      IF (EPS .EQ. 0.0D0) GO TO 10                                      06390000
      EPSLON = EPS*DABS(X)                                              06400000
      RETURN                                                            06410000
      END                                                               06420000
      SUBROUTINE MM (A, LDA, N1, N3, B, LDB, N2, C, LDC)                06430000
      DOUBLE PRECISION A(LDA,*), B(LDB,*), C(LDC,*)                     06440000
C                                                                       06450000
C   PURPOSE:                                                            06460000
C     MULTIPLY MATRIX B TIMES MATRIX C AND STORE THE RESULT IN MATRIX A.06470000
C                                                                       06480000
C   PARAMETERS:                                                         06490000
C                                                                       06500000
C     A DOUBLE PRECISION(LDA,N3), MATRIX OF N1 ROWS AND N3 COLUMNS      06510000
C                                                                       06520000
C     LDA INTEGER, LEADING DIMENSION OF ARRAY A                         06530000
C                                                                       06540000
C     N1 INTEGER, NUMBER OF ROWS IN MATRICES A AND B                    06550000
C                                                                       06560000
C     N3 INTEGER, NUMBER OF COLUMNS IN MATRICES A AND C                 06570000
C                                                                       06580000
C     B DOUBLE PRECISION(LDB,N2), MATRIX OF N1 ROWS AND N2 COLUMNS      06590000
C                                                                       06600000
C     LDB INTEGER, LEADING DIMENSION OF ARRAY B                         06610000
C                                                                       06620000
C     N2 INTEGER, NUMBER OF COLUMNS IN MATRIX B, AND NUMBER OF ROWS IN  06630000
C         MATRIX C                                                      06640000
C                                                                       06650000
C     C DOUBLE PRECISION(LDC,N3), MATRIX OF N2 ROWS AND N3 COLUMNS      06660000
C                                                                       06670000
C     LDC INTEGER, LEADING DIMENSION OF ARRAY C                         06680000
C                                                                       06690000
C ----------------------------------------------------------------------06700000
C                                                                       06710000
      DO 20 J = 1, N3                                                   06720000
         DO 10 I = 1, N1                                                06730000
            A(I,J) = 0.0                                                06740000
   10    CONTINUE                                                       06750000
         CALL DMXPY (N2,A(1,J),N1,LDB,C(1,J),B)                         06760000
   20 CONTINUE                                                          06770000
C                                                                       06780000
      RETURN                                                            06790000
      END                                                               06800000
      SUBROUTINE DMXPY (N1, Y, N2, LDM, X, M)                           06810000
      DOUBLE PRECISION Y(*), X(*), M(LDM,*)                             06820000
C                                                                       06830000
C   PURPOSE:                                                            06840000
C     MULTIPLY MATRIX M TIMES VECTOR X AND ADD THE RESULT TO VECTOR Y.  06850000
C                                                                       06860000
C   PARAMETERS:                                                         06870000
C                                                                       06880000
C     N1 INTEGER, NUMBER OF ELEMENTS IN VECTOR Y, AND NUMBER OF ROWS IN 06890000
C         MATRIX M                                                      06900000
C                                                                       06910000
C     Y DOUBLE PRECISION(N1), VECTOR OF LENGTH N1 TO WHICH IS ADDED     06920000
C         THE PRODUCT M*X                                               06930000
C                                                                       06940000
C     N2 INTEGER, NUMBER OF ELEMENTS IN VECTOR X, AND NUMBER OF COLUMNS 06950000
C         IN MATRIX M                                                   06960000
C                                                                       06970000
C     LDM INTEGER, LEADING DIMENSION OF ARRAY M                         06980000
C                                                                       06990000
C     X DOUBLE PRECISION(N2), VECTOR OF LENGTH N2                       07000000
C                                                                       07010000
C     M DOUBLE PRECISION(LDM,N2), MATRIX OF N1 ROWS AND N2 COLUMNS      07020000
C                                                                       07030000
C ----------------------------------------------------------------------07040000
C                                                                       07050000
C   CLEANUP ODD VECTOR                                                  07060000
C                                                                       07070000
      J = MOD(N2,2)                                                     07080000
      IF (J .GE. 1) THEN                                                07090000
         DO 10 I = 1, N1                                                07100000
            Y(I) = (Y(I)) + X(J)*M(I,J)                                 07110000
   10    CONTINUE                                                       07120000
      ENDIF                                                             07130000
C                                                                       07140000
C   CLEANUP ODD GROUP OF TWO VECTORS                                    07150000
C                                                                       07160000
      J = MOD(N2,4)                                                     07170000
      IF (J .GE. 2) THEN                                                07180000
         DO 20 I = 1, N1                                                07190000
            Y(I) = ( (Y(I))                                             07200000
     \             + X(J-1)*M(I,J-1)) + X(J)*M(I,J)                     07210000
   20    CONTINUE                                                       07220000
      ENDIF                                                             07230000
C                                                                       07240000
C   CLEANUP ODD GROUP OF FOUR VECTORS                                   07250000
C                                                                       07260000
      J = MOD(N2,8)                                                     07270000
      IF (J .GE. 4) THEN                                                07280000
         DO 30 I = 1, N1                                                07290000
            Y(I) = ((( (Y(I))                                           07300000
     \             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))                07310000
     \             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)                   07320000
   30    CONTINUE                                                       07330000
      ENDIF                                                             07340000
C                                                                       07350000
C   CLEANUP ODD GROUP OF EIGHT VECTORS                                  07360000
C                                                                       07370000
      J = MOD(N2,16)                                                    07380000
      IF (J .GE. 8) THEN                                                07390000
         DO 40 I = 1, N1                                                07400000
            Y(I) = ((((((( (Y(I))                                       07410000
     \             + X(J-7)*M(I,J-7)) + X(J-6)*M(I,J-6))                07420000
     \             + X(J-5)*M(I,J-5)) + X(J-4)*M(I,J-4))                07430000
     \             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))                07440000
     \             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)                   07450000
   40    CONTINUE                                                       07460000
      ENDIF                                                             07470000
C                                                                       07480000
C   MAIN LOOP - GROUPS OF SIXTEEN VECTORS                               07490000
C                                                                       07500000
      JMIN = J+16                                                       07510000
      DO 60 J = JMIN, N2, 16                                            07520000
         DO 50 I = 1, N1                                                07530000
            Y(I) = ((((((((((((((( (Y(I))                               07540000
     \             + X(J-15)*M(I,J-15)) + X(J-14)*M(I,J-14))            07550000
     \             + X(J-13)*M(I,J-13)) + X(J-12)*M(I,J-12))            07560000
     \             + X(J-11)*M(I,J-11)) + X(J-10)*M(I,J-10))            07570000
     \             + X(J- 9)*M(I,J- 9)) + X(J- 8)*M(I,J- 8))            07580000
     \             + X(J- 7)*M(I,J- 7)) + X(J- 6)*M(I,J- 6))            07590000
     \             + X(J- 5)*M(I,J- 5)) + X(J- 4)*M(I,J- 4))            07600000
     \             + X(J- 3)*M(I,J- 3)) + X(J- 2)*M(I,J- 2))            07610000
     \             + X(J- 1)*M(I,J- 1)) + X(J)   *M(I,J)                07620000
   50    CONTINUE                                                       07630000
   60 CONTINUE                                                          07640000
      RETURN                                                            07650000
      END                                                               07660000
      FUNCTION SECOND(TIME)                                             07670000
C     CALL CLOCK(TIME,0,1)                                              07680000
      SECOND=CLOCK()                                                    07690000
      RETURN                                                            07700000
      END                                                               07710000
