      DOUBLE PRECISION A(301,300),X(301),B(301),MFLOPS                  00010000
      DOUBLE PRECISION EMAX                                             00020000
      INTEGER IPVT(300)                                                 00030000
C                                                                       00040000
      LDA = 301                                                         00050000
C                                                                       00060000
      WRITE(6,40)                                                       00070000
   40 FORMAT('  LU DECOMPOSITION TIMING')                               00080000
      DO 200 N = 50,300,50                                              00090000
         CALL MATGEN(A,LDA,N,B)                                         00100000
         WRITE(6,50)LDA,N                                               00110000
   50    FORMAT(/' DP SIZE OF THE ARRAYS',I5,' AND ORDER IS ',I5/)      00120000
C                                                                       00130000
         T1 = SECOND(T)                                                 00140000
         CALL LU1(A,LDA,N,IPVT,IERR)                                    00150000
         T2 = SECOND(T) - T1                                            00160000
         CALL LUS(A,LDA,N,IPVT,X,B)                                     00170000
         MFLOPS = (FLOAT(N*(5+N*(-3+N*4)))/(6.0*T2))/1.0E6              00180000
         EMAX = 0.0                                                     00190000
         DO 73 I = 1,N                                                  00200000
            EMAX = DMAX1(EMAX,ABS(X(I)))                                00210000
   73    CONTINUE                                                       00220000
         WRITE(6,80) T2,MFLOPS,EMAX                                     00230000
   80    FORMAT(' UNROLLING DEPTH 1  TIME = ',E12.3,' MFLOPS = ',F9.4,  00240000
     \          ' CHECK = ',E12.3)                                      00250000
C                                                                       00260000
         CALL MATGEN(A,LDA,N,B)                                         00270000
         T1 = SECOND(T)                                                 00280000
         CALL LU2(A,LDA,N,IPVT,IERR)                                    00290000
         T2 = SECOND(T) - T1                                            00300000
         CALL LUS(A,LDA,N,IPVT,X,B)                                     00310000
         MFLOPS = (FLOAT(N*(5+N*(-3+N*4)))/(6.0*T2))/1.0E6              00320000
         EMAX = 0.0                                                     00330000
         DO 81 I = 1,N                                                  00340000
            EMAX = DMAX1(EMAX,ABS(X(I)))                                00350000
   81    CONTINUE                                                       00360000
         WRITE(6,90) T2,MFLOPS,EMAX                                     00370000
   90    FORMAT(' UNROLLING DEPTH 2  TIME = ',E12.3,' MFLOPS = ',F9.4,  00380000
     \          ' CHECK = ',E12.3)                                      00390000
C                                                                       00400000
         CALL MATGEN(A,LDA,N,B)                                         00410000
         T1 = SECOND(T)                                                 00420000
         CALL LU4(A,LDA,N,IPVT,IERR)                                    00430000
         T2 = SECOND(T) - T1                                            00440000
         CALL LUS(A,LDA,N,IPVT,X,B)                                     00450000
         MFLOPS = (FLOAT(N*(5+N*(-3+N*4)))/(6.0*T2))/1.0E6              00460000
         EMAX = 0.0                                                     00470000
         DO 91 I = 1,N                                                  00480000
            EMAX = DMAX1(EMAX,ABS(X(I)))                                00490000
   91    CONTINUE                                                       00500000
         WRITE(6,100) T2,MFLOPS,EMAX                                    00510000
  100    FORMAT(' UNROLLING DEPTH 4  TIME = ',E12.3,' MFLOPS = ',F9.4,  00520000
     \          ' CHECK = ',E12.3)                                      00530000
C                                                                       00540000
         CALL MATGEN(A,LDA,N,B)                                         00550000
         T1 = SECOND(T)                                                 00560000
         CALL LU8(A,LDA,N,IPVT,IERR)                                    00570000
         T2 = SECOND(T) - T1                                            00580000
         CALL LUS(A,LDA,N,IPVT,X,B)                                     00590000
         MFLOPS = (FLOAT(N*(5+N*(-3+N*4)))/(6.0*T2))/1.0E6              00600000
         EMAX = 0.0                                                     00610000
         DO 101 I = 1,N                                                 00620000
            EMAX = DMAX1(EMAX,ABS(X(I)))                                00630000
  101    CONTINUE                                                       00640000
         WRITE(6,110) T2,MFLOPS,EMAX                                    00650000
  110    FORMAT(' UNROLLING DEPTH 8  TIME = ',E12.3,' MFLOPS = ',F9.4,  00660000
     \          ' CHECK = ',E12.3)                                      00670000
C                                                                       00680000
         CALL MATGEN(A,LDA,N,B)                                         00690000
         T1 = SECOND(T)                                                 00700000
         CALL LUX(A,LDA,N,IPVT,IERR)                                    00710000
         T2 = SECOND(T) - T1                                            00720000
         CALL LUS(A,LDA,N,IPVT,X,B)                                     00730000
         MFLOPS = (FLOAT(N*(5+N*(-3+N*4)))/(6.0*T2))/1.0E6              00740000
         EMAX = 0.0                                                     00750000
         DO 111 I = 1,N                                                 00760000
            EMAX = DMAX1(EMAX,ABS(X(I)))                                00770000
  111    CONTINUE                                                       00780000
         WRITE(6,120) T2,MFLOPS,EMAX                                    00790000
  120    FORMAT(' UNROLLING DEPTH 16 TIME = ',E12.3,' MFLOPS = ',F9.4,  00800000
     \          ' CHECK = ',E12.3)                                      00810000
C                                                                       00820000
  200 CONTINUE                                                          00830000
      STOP                                                              00840000
      END                                                               00850000
      SUBROUTINE MATGEN(A,LDA,N,B)                                      00860000
      DOUBLE PRECISION A(LDA,1),B(1)                                    00870000
C                                                                       00880000
      INIT = 1325                                                       00890000
      DO 30 J = 1,N                                                     00900000
         DO 20 I = 1,N                                                  00910000
            INIT = MOD(3125*INIT,65536)                                 00920000
            A(I,J) = (INIT - 32768.0)/16384.0                           00930000
   20    CONTINUE                                                       00940000
   30 CONTINUE                                                          00950000
      DO 35 I = 1,N                                                     00960000
          B(I) = 0.0                                                    00970000
   35 CONTINUE                                                          00980000
      DO 50 J = 1,N                                                     00990000
         DO 40 I = 1,N                                                  01000000
            B(I) = B(I) + A(I,J)                                        01010000
   40    CONTINUE                                                       01020000
   50 CONTINUE                                                          01030000
      RETURN                                                            01040000
      END                                                               01050000
      SUBROUTINE LUS (A,LDA,N,IPVT,X,B)                                 01060000
      INTEGER IPVT(*)                                                   01070000
      DOUBLE PRECISION A(LDA,*), X(*), B(*), XK                         01080000
C                                                                       01090000
C   PURPOSE:                                                            01100000
C     SOLVE THE LINEAR SYSTEM AX = B GIVEN THE LU FACTORIZATION OF A (AS01110000
C     COMPUTED IN LU).                                                  01120000
C                                                                       01130000
C   ADDITIONAL PARAMETERS (NOT PARAMETERS OF LU):                       01140000
C                                                                       01150000
C     X DOUBLE PRECISION(N), SOLUTION OF LINEAR SYSTEM                  01160000
C                                                                       01170000
C     B DOUBLE PRECISION(N), RIGHT-HAND-SIDE OF LINEAR SYSTEM           01180000
C                                                                       01190000
C ----------------------------------------------------------------------01200000
C                                                                       01210000
      DO 10 K = 1, N                                                    01220000
       X(K) = B(K)                                                      01230000
   10 CONTINUE                                                          01240000
C                                                                       01250000
      DO 20 K = 1, N                                                    01260000
       L = IPVT(K)                                                      01270000
       XK = X(L)                                                        01280000
       X(L) = X(K)                                                      01290000
       X(K) = XK                                                        01300000
   20 CONTINUE                                                          01310000
C                                                                       01320000
      DO 40 K = 1, N                                                    01330000
       XK = X(K)*A(K,K)                                                 01340000
       DO 30 I = K+1, N                                                 01350000
          X(I) = X(I) - A(I,K)*XK                                       01360000
   30    CONTINUE                                                       01370000
       X(K) = XK                                                        01380000
   40 CONTINUE                                                          01390000
C                                                                       01400000
      DO 60 K = N, 1, -1                                                01410000
       XK = X(K)                                                        01420000
       DO 50 I = 1, K-1                                                 01430000
          X(I) = X(I) + A(I,K)*XK                                       01440000
   50    CONTINUE                                                       01450000
   60 CONTINUE                                                          01460000
C                                                                       01470000
      RETURN                                                            01480000
      END                                                               01490000
      SUBROUTINE LU1(A,LDA,N,IPVT,INFO)                                 01500000
C ** LU.F -- LU DECOMPOSITION                                           01510000
C                                                                       01520000
C                                                                       01530000
      INTEGER LDA,N,IPVT(N),INFO                                        01540000
      DOUBLE PRECISION A(LDA,1),T                                       01550000
C                                                                       01560000
      INFO = 0                                                          01570000
      DO 40 J = 1, N                                                    01580000
C                                                                       01590000
C       FORM J-TH COLUMN OF L                                           01600000
C                                                                       01610000
         CALL DMXPY1(N-J+1,A(J,J),J-1,LDA,A(1,J),A(J,1))                01620000
C                                                                       01630000
C       SEARCH FOR PIVOT                                                01640000
C                                                                       01650000
         T = ABS(A(J,J))                                                01660000
         K = J                                                          01670000
         DO 10 I = J+1, N                                               01680000
            IF (ABS(A(I,J)) .GT. T) THEN                                01690000
               T = ABS(A(I,J))                                          01700000
               K = I                                                    01710000
            END IF                                                      01720000
   10    CONTINUE                                                       01730000
         IPVT(J) = K                                                    01740000
C                                                                       01750000
C       TEST FOR ZERO PIVOT                                             01760000
C                                                                       01770000
         IF (T .EQ. 0) THEN                                             01780000
            INFO = J                                                    01790000
            GO TO 50                                                    01800000
         ENDIF                                                          01810000
C                                                                       01820000
C       INTERCHANGE ROWS                                                01830000
C                                                                       01840000
         DO 20 I = 1, N                                                 01850000
            T = A(J,I)                                                  01860000
            A(J,I) = A(K,I)                                             01870000
            A(K,I) = T                                                  01880000
   20    CONTINUE                                                       01890000
C                                                                       01900000
C       FORM J-TH ROW OF U                                              01910000
C                                                                       01920000
         A(J,J) = 1/A(J,J)                                              01930000
         CALL DXMPY1(N-J,LDA,A(J,J+1),J-1,LDA,A(J,1),LDA,A(1,J+1))      01940000
         T = -A(J,J)                                                    01950000
         DO 30 I = J+1, N                                               01960000
            A(J,I) = T*A(J,I)                                           01970000
   30    CONTINUE                                                       01980000
   40 CONTINUE                                                          01990000
   50 RETURN                                                            02000000
      END                                                               02010000
      SUBROUTINE LU2(A,LDA,N,IPVT,INFO)                                 02020000
C ** LU.F -- LU DECOMPOSITION                                           02030000
C                                                                       02040000
C                                                                       02050000
      INTEGER LDA,N,IPVT(N),INFO                                        02060000
      DOUBLE PRECISION A(LDA,1),T                                       02070000
C                                                                       02080000
      INFO = 0                                                          02090000
      DO 40 J = 1, N                                                    02100000
C                                                                       02110000
C       FORM J-TH COLUMN OF L                                           02120000
C                                                                       02130000
         CALL DMXPY2(N-J+1,A(J,J),J-1,LDA,A(1,J),A(J,1))                02140000
C                                                                       02150000
C       SEARCH FOR PIVOT                                                02160000
C                                                                       02170000
         T = ABS(A(J,J))                                                02180000
         K = J                                                          02190000
         DO 10 I = J+1, N                                               02200000
            IF (ABS(A(I,J)) .GT. T) THEN                                02210000
               T = ABS(A(I,J))                                          02220000
               K = I                                                    02230000
            END IF                                                      02240000
   10    CONTINUE                                                       02250000
         IPVT(J) = K                                                    02260000
C                                                                       02270000
C       TEST FOR ZERO PIVOT                                             02280000
C                                                                       02290000
         IF (T .EQ. 0) THEN                                             02300000
            INFO = J                                                    02310000
            GO TO 50                                                    02320000
         ENDIF                                                          02330000
C                                                                       02340000
C       INTERCHANGE ROWS                                                02350000
C                                                                       02360000
         DO 20 I = 1, N                                                 02370000
            T = A(J,I)                                                  02380000
            A(J,I) = A(K,I)                                             02390000
            A(K,I) = T                                                  02400000
   20    CONTINUE                                                       02410000
C                                                                       02420000
C       FORM J-TH ROW OF U                                              02430000
C                                                                       02440000
         A(J,J) = 1/A(J,J)                                              02450000
         CALL DXMPY2(N-J,LDA,A(J,J+1),J-1,LDA,A(J,1),LDA,A(1,J+1))      02460000
         T = -A(J,J)                                                    02470000
         DO 30 I = J+1, N                                               02480000
            A(J,I) = T*A(J,I)                                           02490000
   30    CONTINUE                                                       02500000
   40 CONTINUE                                                          02510000
   50 RETURN                                                            02520000
      END                                                               02530000
      SUBROUTINE LU4(A,LDA,N,IPVT,INFO)                                 02540000
C ** LU.F -- LU DECOMPOSITION                                           02550000
C                                                                       02560000
C                                                                       02570000
      INTEGER LDA,N,IPVT(N),INFO                                        02580000
      DOUBLE PRECISION A(LDA,1),T                                       02590000
C                                                                       02600000
      INFO = 0                                                          02610000
      DO 40 J = 1, N                                                    02620000
C                                                                       02630000
C       FORM J-TH COLUMN OF L                                           02640000
C                                                                       02650000
         CALL DMXPY4(N-J+1,A(J,J),J-1,LDA,A(1,J),A(J,1))                02660000
C                                                                       02670000
C       SEARCH FOR PIVOT                                                02680000
C                                                                       02690000
         T = ABS(A(J,J))                                                02700000
         K = J                                                          02710000
         DO 10 I = J+1, N                                               02720000
            IF (ABS(A(I,J)) .GT. T) THEN                                02730000
               T = ABS(A(I,J))                                          02740000
               K = I                                                    02750000
            END IF                                                      02760000
   10    CONTINUE                                                       02770000
         IPVT(J) = K                                                    02780000
C                                                                       02790000
C       TEST FOR ZERO PIVOT                                             02800000
C                                                                       02810000
         IF (T .EQ. 0) THEN                                             02820000
            INFO = J                                                    02830000
            GO TO 50                                                    02840000
         ENDIF                                                          02850000
C                                                                       02860000
C       INTERCHANGE ROWS                                                02870000
C                                                                       02880000
         DO 20 I = 1, N                                                 02890000
            T = A(J,I)                                                  02900000
            A(J,I) = A(K,I)                                             02910000
            A(K,I) = T                                                  02920000
   20    CONTINUE                                                       02930000
C                                                                       02940000
C       FORM J-TH ROW OF U                                              02950000
C                                                                       02960000
         A(J,J) = 1/A(J,J)                                              02970000
         CALL DXMPY4(N-J,LDA,A(J,J+1),J-1,LDA,A(J,1),LDA,A(1,J+1))      02980000
         T = -A(J,J)                                                    02990000
         DO 30 I = J+1, N                                               03000000
            A(J,I) = T*A(J,I)                                           03010000
   30    CONTINUE                                                       03020000
   40 CONTINUE                                                          03030000
   50 RETURN                                                            03040000
      END                                                               03050000
      SUBROUTINE LU8(A,LDA,N,IPVT,INFO)                                 03060000
C ** LU.F -- LU DECOMPOSITION                                           03070000
C                                                                       03080000
C                                                                       03090000
      INTEGER LDA,N,IPVT(N),INFO                                        03100000
      DOUBLE PRECISION A(LDA,1),T                                       03110000
C                                                                       03120000
      INFO = 0                                                          03130000
      DO 40 J = 1, N                                                    03140000
C                                                                       03150000
C       FORM J-TH COLUMN OF L                                           03160000
C                                                                       03170000
         CALL DMXPY8(N-J+1,A(J,J),J-1,LDA,A(1,J),A(J,1))                03180000
C                                                                       03190000
C       SEARCH FOR PIVOT                                                03200000
C                                                                       03210000
         T = ABS(A(J,J))                                                03220000
         K = J                                                          03230000
         DO 10 I = J+1, N                                               03240000
            IF (ABS(A(I,J)) .GT. T) THEN                                03250000
               T = ABS(A(I,J))                                          03260000
               K = I                                                    03270000
            END IF                                                      03280000
   10    CONTINUE                                                       03290000
         IPVT(J) = K                                                    03300000
C                                                                       03310000
C       TEST FOR ZERO PIVOT                                             03320000
C                                                                       03330000
         IF (T .EQ. 0) THEN                                             03340000
            INFO = J                                                    03350000
            GO TO 50                                                    03360000
         ENDIF                                                          03370000
C                                                                       03380000
C       INTERCHANGE ROWS                                                03390000
C                                                                       03400000
         DO 20 I = 1, N                                                 03410000
            T = A(J,I)                                                  03420000
            A(J,I) = A(K,I)                                             03430000
            A(K,I) = T                                                  03440000
   20    CONTINUE                                                       03450000
C                                                                       03460000
C       FORM J-TH ROW OF U                                              03470000
C                                                                       03480000
         A(J,J) = 1/A(J,J)                                              03490000
         CALL DXMPY8(N-J,LDA,A(J,J+1),J-1,LDA,A(J,1),LDA,A(1,J+1))      03500000
         T = -A(J,J)                                                    03510000
         DO 30 I = J+1, N                                               03520000
            A(J,I) = T*A(J,I)                                           03530000
   30    CONTINUE                                                       03540000
   40 CONTINUE                                                          03550000
   50 RETURN                                                            03560000
      END                                                               03570000
      SUBROUTINE LUX(A,LDA,N,IPVT,INFO)                                 03580000
C ** LU.F -- LU DECOMPOSITION                                           03590000
C                                                                       03600000
C                                                                       03610000
      INTEGER LDA,N,IPVT(N),INFO                                        03620000
      DOUBLE PRECISION A(LDA,1),T                                       03630000
C                                                                       03640000
      INFO = 0                                                          03650000
      DO 40 J = 1, N                                                    03660000
C                                                                       03670000
C       FORM J-TH COLUMN OF L                                           03680000
C                                                                       03690000
         CALL DMXPYX(N-J+1,A(J,J),J-1,LDA,A(1,J),A(J,1))                03700000
C                                                                       03710000
C       SEARCH FOR PIVOT                                                03720000
C                                                                       03730000
         T = ABS(A(J,J))                                                03740000
         K = J                                                          03750000
         DO 10 I = J+1, N                                               03760000
            IF (ABS(A(I,J)) .GT. T) THEN                                03770000
               T = ABS(A(I,J))                                          03780000
               K = I                                                    03790000
            END IF                                                      03800000
   10    CONTINUE                                                       03810000
         IPVT(J) = K                                                    03820000
C                                                                       03830000
C       TEST FOR ZERO PIVOT                                             03840000
C                                                                       03850000
         IF (T .EQ. 0) THEN                                             03860000
            INFO = J                                                    03870000
            GO TO 50                                                    03880000
         ENDIF                                                          03890000
C                                                                       03900000
C       INTERCHANGE ROWS                                                03910000
C                                                                       03920000
         DO 20 I = 1, N                                                 03930000
            T = A(J,I)                                                  03940000
            A(J,I) = A(K,I)                                             03950000
            A(K,I) = T                                                  03960000
   20    CONTINUE                                                       03970000
C                                                                       03980000
C       FORM J-TH ROW OF U                                              03990000
C                                                                       04000000
         A(J,J) = 1/A(J,J)                                              04010000
         CALL DXMPYX(N-J,LDA,A(J,J+1),J-1,LDA,A(J,1),LDA,A(1,J+1))      04020000
         T = -A(J,J)                                                    04030000
         DO 30 I = J+1, N                                               04040000
            A(J,I) = T*A(J,I)                                           04050000
   30    CONTINUE                                                       04060000
   40 CONTINUE                                                          04070000
   50 RETURN                                                            04080000
      END                                                               04090000
      SUBROUTINE DMXPY1 (N1,Y,N2,LDM,X,M)                               04100000
C ** DMXPY01.F -- DMXPY UNROLLED TO A DEPTH OF 1                        04110000
C                                                                       04120000
      INTEGER LDM,N1,N2                                                 04130000
      DOUBLE PRECISION Y(N1),X(N2),M(LDM,N2)                            04140000
C                                                                       04150000
      DO 20 J = 1, N2                                                   04160000
         DO 10 I = 1, N1                                                04170000
            Y(I) = (Y(I)) + X(J)*M(I,J)                                 04180000
   10    CONTINUE                                                       04190000
   20 CONTINUE                                                          04200000
      RETURN                                                            04210000
      END                                                               04220000
      SUBROUTINE DMXPY2(N1,Y,N2,LDM,X,M)                                04230000
C ** DMXPY02.F -- DMXPY UNROLLED TO A DEPTH OF 2                        04240000
C                                                                       04250000
      INTEGER LDM,N1,N2                                                 04260000
      DOUBLE PRECISION Y(N1),X(N2),M(LDM,N2)                            04270000
C                                                                       04280000
C   CLEANUP ODD VECTOR                                                  04290000
C                                                                       04300000
      J = MOD(N2,2)                                                     04310000
      IF (J .GE. 1) THEN                                                04320000
         DO 10 I = 1, N1                                                04330000
            Y(I) = (Y(I)) + X(J)*M(I,J)                                 04340000
   10    CONTINUE                                                       04350000
      ENDIF                                                             04360000
C                                                                       04370000
C   MAIN LOOP - GROUPS OF TWO VECTORS                                   04380000
C                                                                       04390000
      JMIN = J+2                                                        04400000
      DO 30 J = JMIN, N2, 2                                             04410000
         DO 20 I = 1, N1                                                04420000
            Y(I) = ( (Y(I))                                             04430000
     \             + X(J-1)*M(I,J-1)) + X(J)*M(I,J)                     04440000
   20    CONTINUE                                                       04450000
   30 CONTINUE                                                          04460000
      RETURN                                                            04470000
      END                                                               04480000
      SUBROUTINE DMXPY4(N1,Y,N2,LDM,X,M)                                04490000
C ** DMXPY04.F -- DMXPY UNROLLED TO A DEPTH OF 4                        04500000
C                                                                       04510000
      INTEGER LDM,N1,N2                                                 04520000
      DOUBLE PRECISION Y(N1),X(N2),M(LDM,N2)                            04530000
C                                                                       04540000
C   CLEANUP ODD VECTOR                                                  04550000
C                                                                       04560000
      J = MOD(N2,2)                                                     04570000
      IF (J .GE. 1) THEN                                                04580000
         DO 10 I = 1, N1                                                04590000
            Y(I) = (Y(I)) + X(J)*M(I,J)                                 04600000
   10    CONTINUE                                                       04610000
      ENDIF                                                             04620000
C                                                                       04630000
C   CLEANUP ODD GROUP OF TWO VECTORS                                    04640000
C                                                                       04650000
      J = MOD(N2,4)                                                     04660000
      IF (J .GE. 2) THEN                                                04670000
         DO 20 I = 1, N1                                                04680000
            Y(I) = ( (Y(I))                                             04690000
     \             + X(J-1)*M(I,J-1)) + X(J)*M(I,J)                     04700000
   20    CONTINUE                                                       04710000
      ENDIF                                                             04720000
C                                                                       04730000
C   MAIN LOOP - GROUPS OF FOUR VECTORS                                  04740000
C                                                                       04750000
      JMIN = J+4                                                        04760000
      DO 40 J = JMIN, N2, 4                                             04770000
         DO 30 I = 1, N1                                                04780000
            Y(I) = ((( (Y(I))                                           04790000
     \             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))                04800000
     \             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)                   04810000
   30    CONTINUE                                                       04820000
   40 CONTINUE                                                          04830000
      RETURN                                                            04840000
      END                                                               04850000
      SUBROUTINE DMXPY8(N1,Y,N2,LDM,X,M)                                04860000
C ** DMXPY08.F -- DMXPY UNROLLED TO A DEPTH OF 8                        04870000
C                                                                       04880000
      INTEGER LDM,N1,N2                                                 04890000
      DOUBLE PRECISION Y(N1),X(N2),M(LDM,N2)                            04900000
C                                                                       04910000
C   CLEANUP ODD VECTOR                                                  04920000
C                                                                       04930000
      J = MOD(N2,2)                                                     04940000
      IF (J .GE. 1) THEN                                                04950000
         DO 10 I = 1, N1                                                04960000
            Y(I) = (Y(I)) + X(J)*M(I,J)                                 04970000
   10    CONTINUE                                                       04980000
      ENDIF                                                             04990000
C                                                                       05000000
C   CLEANUP ODD GROUP OF TWO VECTORS                                    05010000
C                                                                       05020000
      J = MOD(N2,4)                                                     05030000
      IF (J .GE. 2) THEN                                                05040000
         DO 20 I = 1, N1                                                05050000
            Y(I) = ( (Y(I))                                             05060000
     \             + X(J-1)*M(I,J-1)) + X(J)*M(I,J)                     05070000
   20    CONTINUE                                                       05080000
      ENDIF                                                             05090000
C                                                                       05100000
C   CLEANUP ODD GROUP OF FOUR VECTORS                                   05110000
C                                                                       05120000
      J = MOD(N2,8)                                                     05130000
      IF (J .GE. 4) THEN                                                05140000
         DO 30 I = 1, N1                                                05150000
            Y(I) = ((( (Y(I))                                           05160000
     \             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))                05170000
     \             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)                   05180000
   30    CONTINUE                                                       05190000
      ENDIF                                                             05200000
C                                                                       05210000
C   MAIN LOOP - GROUPS OF EIGHT VECTORS                                 05220000
C                                                                       05230000
      JMIN = J+8                                                        05240000
      DO 50 J = JMIN, N2, 8                                             05250000
         DO 40 I = 1, N1                                                05260000
            Y(I) = ((((((( (Y(I))                                       05270000
     \             + X(J-7)*M(I,J-7)) + X(J-6)*M(I,J-6))                05280000
     \             + X(J-5)*M(I,J-5)) + X(J-4)*M(I,J-4))                05290000
     \             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))                05300000
     \             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)                   05310000
   40    CONTINUE                                                       05320000
   50 CONTINUE                                                          05330000
      RETURN                                                            05340000
      END                                                               05350000
      SUBROUTINE DMXPYX(N1,Y,N2,LDM,X,M)                                05360000
C ** DMXPY16.F -- DMXPY UNROLLED TO A DEPTH OF 16                       05370000
C                                                                       05380000
      INTEGER LDM,N1,N2                                                 05390000
      DOUBLE PRECISION Y(N1),X(N2),M(LDM,N2)                            05400000
C                                                                       05410000
C   CLEANUP ODD VECTOR                                                  05420000
C                                                                       05430000
      J = MOD(N2,2)                                                     05440000
      IF (J .GE. 1) THEN                                                05450000
         DO 10 I = 1, N1                                                05460000
            Y(I) = (Y(I)) + X(J)*M(I,J)                                 05470000
   10    CONTINUE                                                       05480000
      ENDIF                                                             05490000
C                                                                       05500000
C   CLEANUP ODD GROUP OF TWO VECTORS                                    05510000
C                                                                       05520000
      J = MOD(N2,4)                                                     05530000
      IF (J .GE. 2) THEN                                                05540000
         DO 20 I = 1, N1                                                05550000
            Y(I) = ( (Y(I))                                             05560000
     \             + X(J-1)*M(I,J-1)) + X(J)*M(I,J)                     05570000
   20    CONTINUE                                                       05580000
      ENDIF                                                             05590000
C                                                                       05600000
C   CLEANUP ODD GROUP OF FOUR VECTORS                                   05610000
C                                                                       05620000
      J = MOD(N2,8)                                                     05630000
      IF (J .GE. 4) THEN                                                05640000
         DO 30 I = 1, N1                                                05650000
            Y(I) = ((( (Y(I))                                           05660000
     \             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))                05670000
     \             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)                   05680000
   30    CONTINUE                                                       05690000
      ENDIF                                                             05700000
C                                                                       05710000
C   CLEANUP ODD GROUP OF EIGHT VECTORS                                  05720000
C                                                                       05730000
      J = MOD(N2,16)                                                    05740000
      IF (J .GE. 8) THEN                                                05750000
         DO 40 I = 1, N1                                                05760000
            Y(I) = ((((((( (Y(I))                                       05770000
     \             + X(J-7)*M(I,J-7)) + X(J-6)*M(I,J-6))                05780000
     \             + X(J-5)*M(I,J-5)) + X(J-4)*M(I,J-4))                05790000
     \             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))                05800000
     \             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)                   05810000
   40    CONTINUE                                                       05820000
      ENDIF                                                             05830000
C                                                                       05840000
C   MAIN LOOP - GROUPS OF SIXTEEN VECTORS                               05850000
C                                                                       05860000
      JMIN = J+16                                                       05870000
      DO 60 J = JMIN, N2, 16                                            05880000
         DO 50 I = 1, N1                                                05890000
            Y(I) = ((((((((((((((( (Y(I))                               05900000
     \             + X(J-15)*M(I,J-15)) + X(J-14)*M(I,J-14))            05910000
     \             + X(J-13)*M(I,J-13)) + X(J-12)*M(I,J-12))            05920000
     \             + X(J-11)*M(I,J-11)) + X(J-10)*M(I,J-10))            05930000
     \             + X(J- 9)*M(I,J- 9)) + X(J- 8)*M(I,J- 8))            05940000
     \             + X(J- 7)*M(I,J- 7)) + X(J- 6)*M(I,J- 6))            05950000
     \             + X(J- 5)*M(I,J- 5)) + X(J- 4)*M(I,J- 4))            05960000
     \             + X(J- 3)*M(I,J- 3)) + X(J- 2)*M(I,J- 2))            05970000
     \             + X(J- 1)*M(I,J- 1)) + X(J)   *M(I,J)                05980000
   50    CONTINUE                                                       05990000
   60 CONTINUE                                                          06000000
      RETURN                                                            06010000
      END                                                               06020000
      SUBROUTINE DXMPY1(N1,LDY,Y,N2,LDX,X,LDM,M)                        06030000
C ** DXMPY01.F -- DXMPY UNROLLED TO A DEPTH OF 1                        06040000
C                                                                       06050000
      INTEGER N1,LDY,N2,LDX,LDM                                         06060000
      DOUBLE PRECISION Y(LDY,N1),X(LDX,N2),M(LDM,N1)                    06070000
C                                                                       06080000
      DO 20 J = 1, N2                                                   06090000
         DO 10 I = 1, N1                                                06100000
            Y(1,I) = (Y(1,I)) + X(1,J)*M(J,I)                           06110000
   10    CONTINUE                                                       06120000
   20 CONTINUE                                                          06130000
      RETURN                                                            06140000
      END                                                               06150000
      SUBROUTINE DXMPY2(N1,LDY,Y,N2,LDX,X,LDM,M)                        06160000
C ** DXMPY02.F -- DXMPY UNROLLED TO A DEPTH OF 2                        06170000
C                                                                       06180000
      INTEGER N1,LDY,N2,LDX,LDM                                         06190000
      DOUBLE PRECISION Y(LDY,N1),X(LDX,N2),M(LDM,N1)                    06200000
C                                                                       06210000
C   CLEANUP ODD VECTOR                                                  06220000
C                                                                       06230000
      J = MOD(N2,2)                                                     06240000
      IF (J .GE. 1) THEN                                                06250000
         DO 10 I = 1, N1                                                06260000
            Y(1,I) = (Y(1,I)) + X(1,J)*M(J,I)                           06270000
   10    CONTINUE                                                       06280000
      ENDIF                                                             06290000
C                                                                       06300000
C   MAIN LOOP - GROUPS OF TWO VECTORS                                   06310000
C                                                                       06320000
      JMIN = J+2                                                        06330000
      DO 30 J = JMIN, N2, 2                                             06340000
         DO 20 I = 1, N1                                                06350000
            Y(1,I) = ( (Y(1,I))                                         06360000
     \             + X(1,J-1)*M(J-1,I)) + X(1,J)*M(J,I)                 06370000
   20    CONTINUE                                                       06380000
   30 CONTINUE                                                          06390000
      RETURN                                                            06400000
      END                                                               06410000
      SUBROUTINE DXMPY4(N1,LDY,Y,N2,LDX,X,LDM,M)                        06420000
C ** DXMPY04.F -- DXMPY UNROLLED TO A DEPTH OF 4                        06430000
C                                                                       06440000
      INTEGER N1,LDY,N2,LDX,LDM                                         06450000
      DOUBLE PRECISION Y(LDY,N1),X(LDX,N2),M(LDM,N1)                    06460000
C                                                                       06470000
C   CLEANUP ODD VECTOR                                                  06480000
C                                                                       06490000
      J = MOD(N2,2)                                                     06500000
      IF (J .GE. 1) THEN                                                06510000
         DO 10 I = 1, N1                                                06520000
            Y(1,I) = (Y(1,I)) + X(1,J)*M(J,I)                           06530000
   10    CONTINUE                                                       06540000
      ENDIF                                                             06550000
C                                                                       06560000
C   CLEANUP ODD GROUP OF TWO VECTORS                                    06570000
C                                                                       06580000
      J = MOD(N2,4)                                                     06590000
      IF (J .GE. 2) THEN                                                06600000
         DO 20 I = 1, N1                                                06610000
            Y(1,I) = ( (Y(1,I))                                         06620000
     \               + X(1,J-1)*M(J-1,I)) + X(1,J)*M(J,I)               06630000
   20    CONTINUE                                                       06640000
      ENDIF                                                             06650000
C                                                                       06660000
C   MAIN LOOP - GROUPS OF FOUR VECTORS                                  06670000
C                                                                       06680000
      JMIN = J+4                                                        06690000
      DO 40 J = JMIN, N2, 4                                             06700000
         DO 30 I = 1, N1                                                06710000
            Y(1,I) = ((( (Y(1,I))                                       06720000
     \               + X(1,J-3)*M(J-3,I)) + X(1,J-2)*M(J-2,I))          06730000
     \               + X(1,J-1)*M(J-1,I)) + X(1,J)  *M(J,I)             06740000
   30    CONTINUE                                                       06750000
   40 CONTINUE                                                          06760000
      RETURN                                                            06770000
      END                                                               06780000
      SUBROUTINE DXMPY8(N1,LDY,Y,N2,LDX,X,LDM,M)                        06790000
C ** DXMPY08.F -- DXMPY UNROLLED TO A DEPTH OF 8                        06800000
C                                                                       06810000
      INTEGER N1,LDY,N2,LDX,LDM                                         06820000
      DOUBLE PRECISION Y(LDY,N1),X(LDX,N2),M(LDM,N1)                    06830000
C                                                                       06840000
C   CLEANUP ODD VECTOR                                                  06850000
C                                                                       06860000
      J = MOD(N2,2)                                                     06870000
      IF (J .GE. 1) THEN                                                06880000
         DO 10 I = 1, N1                                                06890000
            Y(1,I) = (Y(1,I)) + X(1,J)*M(J,I)                           06900000
   10    CONTINUE                                                       06910000
      ENDIF                                                             06920000
C                                                                       06930000
C   CLEANUP ODD GROUP OF TWO VECTORS                                    06940000
C                                                                       06950000
      J = MOD(N2,4)                                                     06960000
      IF (J .GE. 2) THEN                                                06970000
         DO 20 I = 1, N1                                                06980000
            Y(1,I) = ( (Y(1,I))                                         06990000
     \               + X(1,J-1)*M(J-1,I)) + X(1,J)*M(J,I)               07000000
   20    CONTINUE                                                       07010000
      ENDIF                                                             07020000
C                                                                       07030000
C   CLEANUP ODD GROUP OF FOUR VECTORS                                   07040000
C                                                                       07050000
      J = MOD(N2,8)                                                     07060000
      IF (J .GE. 4) THEN                                                07070000
         DO 30 I = 1, N1                                                07080000
            Y(1,I) = ((( (Y(1,I))                                       07090000
     \               + X(1,J-3)*M(J-3,I)) + X(1,J-2)*M(J-2,I))          07100000
     \               + X(1,J-1)*M(J-1,I)) + X(1,J)  *M(J,I)             07110000
   30    CONTINUE                                                       07120000
      ENDIF                                                             07130000
C                                                                       07140000
C   MAIN LOOP - GROUPS OF EIGHT VECTORS                                 07150000
C                                                                       07160000
      JMIN = J+8                                                        07170000
      DO 50 J = JMIN, N2, 8                                             07180000
         DO 40 I = 1, N1                                                07190000
            Y(1,I) = ((((((( (Y(1,I))                                   07200000
     \               + X(1,J-7)*M(J-7,I)) + X(1,J-6)*M(J-6,I))          07210000
     \               + X(1,J-5)*M(J-5,I)) + X(1,J-4)*M(J-4,I))          07220000
     \               + X(1,J-3)*M(J-3,I)) + X(1,J-2)*M(J-2,I))          07230000
     \               + X(1,J-1)*M(J-1,I)) + X(1,J)  *M(J,I)             07240000
   40    CONTINUE                                                       07250000
   50 CONTINUE                                                          07260000
      RETURN                                                            07270000
      END                                                               07280000
      SUBROUTINE DXMPYX(N1,LDY,Y,N2,LDX,X,LDM,M)                        07290000
C ** DXMPY16.F -- DXMPY UNROLLED TO A DEPTH OF 16                       07300000
C                                                                       07310000
      INTEGER N1,LDY,N2,LDX,LDM                                         07320000
      DOUBLE PRECISION Y(LDY,N1),X(LDX,N2),M(LDM,N1)                    07330000
C                                                                       07340000
C   CLEANUP ODD VECTOR                                                  07350000
C                                                                       07360000
      J = MOD(N2,2)                                                     07370000
      IF (J .GE. 1) THEN                                                07380000
         DO 10 I = 1, N1                                                07390000
            Y(1,I) = (Y(1,I)) + X(1,J)*M(J,I)                           07400000
   10    CONTINUE                                                       07410000
      ENDIF                                                             07420000
C                                                                       07430000
C   CLEANUP ODD GROUP OF TWO VECTORS                                    07440000
C                                                                       07450000
      J = MOD(N2,4)                                                     07460000
      IF (J .GE. 2) THEN                                                07470000
         DO 20 I = 1, N1                                                07480000
            Y(1,I) = ( (Y(1,I))                                         07490000
     \               + X(1,J-1)*M(J-1,I)) + X(1,J)*M(J,I)               07500000
   20    CONTINUE                                                       07510000
      ENDIF                                                             07520000
C                                                                       07530000
C   CLEANUP ODD GROUP OF FOUR VECTORS                                   07540000
C                                                                       07550000
      J = MOD(N2,8)                                                     07560000
      IF (J .GE. 4) THEN                                                07570000
         DO 30 I = 1, N1                                                07580000
            Y(1,I) = ((( (Y(1,I))                                       07590000
     \               + X(1,J-3)*M(J-3,I)) + X(1,J-2)*M(J-2,I))          07600000
     \               + X(1,J-1)*M(J-1,I)) + X(1,J)  *M(J,I)             07610000
   30    CONTINUE                                                       07620000
      ENDIF                                                             07630000
C                                                                       07640000
C   CLEANUP ODD GROUP OF EIGHT VECTORS                                  07650000
C                                                                       07660000
      J = MOD(N2,16)                                                    07670000
      IF (J .GE. 8) THEN                                                07680000
         DO 40 I = 1, N1                                                07690000
            Y(1,I) = ((((((( (Y(1,I))                                   07700000
     \               + X(1,J-7)*M(J-7,I)) + X(1,J-6)*M(J-6,I))          07710000
     \               + X(1,J-5)*M(J-5,I)) + X(1,J-4)*M(J-4,I))          07720000
     \               + X(1,J-3)*M(J-3,I)) + X(1,J-2)*M(J-2,I))          07730000
     \               + X(1,J-1)*M(J-1,I)) + X(1,J)  *M(J,I)             07740000
   40    CONTINUE                                                       07750000
      ENDIF                                                             07760000
C                                                                       07770000
C   MAIN LOOP - GROUPS OF SIXTEEN VECTORS                               07780000
C                                                                       07790000
      JMIN = J+16                                                       07800000
      DO 60 J = JMIN, N2, 16                                            07810000
         DO 50 I = 1, N1                                                07820000
            Y(1,I) = ((((((((((((((( (Y(1,I))                           07830000
     \               + X(1,J-15)*M(J-15,I)) + X(1,J-14)*M(J-14,I))      07840000
     \               + X(1,J-13)*M(J-13,I)) + X(1,J-12)*M(J-12,I))      07850000
     \               + X(1,J-11)*M(J-11,I)) + X(1,J-10)*M(J-10,I))      07860000
     \               + X(1,J- 9)*M(J- 9,I)) + X(1,J- 8)*M(J- 8,I))      07870000
     \               + X(1,J- 7)*M(J- 7,I)) + X(1,J- 6)*M(J- 6,I))      07880000
     \               + X(1,J- 5)*M(J- 5,I)) + X(1,J- 4)*M(J- 4,I))      07890000
     \               + X(1,J- 3)*M(J- 3,I)) + X(1,J- 2)*M(J- 2,I))      07900000
     \               + X(1,J- 1)*M(J- 1,I)) + X(1,J)   *M(J,I)          07910000
   50    CONTINUE                                                       07920000
   60 CONTINUE                                                          07930000
      RETURN                                                            07940000
      END                                                               07950000
      FUNCTION SECOND(TIME)                                             07960000
      CALL CLOCK(TIME,0,1)                                              07970000
      SECOND=TIME                                                       07980000
      RETURN                                                            07990000
      END                                                               08000000
