!   Livermore Loop for TaChyon assm                  
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Loop 1.   Hydoro Excerpt                         
!
	.text
	.align 8

	.global _startup
_startup:
	jmp	gr3

        .global _terminate
_terminate:
        jmp     gr3

	.global _main
_main:
	brnc     true, GC1               ! Get clock

        seti     10000, gr31

loop:   seti     400 , gr01              ! Set VL   value
	seti     Base, gr02              ! Set Base      
	addli5   gr02,    8, gr03        ! Get R addr    
	addli25  gr02,   16, gr04        ! Get T addr    
	addli25  gr02,   24, gr05        ! Get Q addr    
	addli25  gr02, 6608, gr08        ! Get X addr    
	ld.d     gr02, gr00, fr03        ! Zero          
	st.d     fr03, gr05, gr00        ! Set Q value  
!
!                X(K) = Q+Y(K)*(R*Z(K+10)+T*Z(K+11))     
!
	vpt          
VWT1:	brcs      es0,VWT1               ! VWT(VU) 
VWT2:	brcs     asam,VWT2               ! VWT(SU) 

        vlvl     gr01

        ld.d     gr03, gr00, fr01            ! get  R value   
	ld.d     gr04, gr00, fr02            ! get  T value   
	addli25  gr02, 3232, gr07            ! Get Z addr    
	addli25  gr07,  72 , gr09            ! get  Z(K+10) address
	vld      gr09, gr00,vr000, mr000     ! load Z(k+10)...
	addli25  gr07,  80 , gr10            ! get  Z(K+11) address
	vld      gr10, gr00,vr008, mr000     ! load Z(k+11)...
	addli25  gr02,   32, gr06            ! Get  Y addr    
	vld      gr06, gr00,vr040, mr000     ! load Y(k)      
	vmsd     fr01,vr000,vr016, mr000     ! Multiply       
	vmsd     fr02,vr008,vr024, mr000     !                
	vad     vr016,vr024,vr032, mr000     ! Add            
	vmd     vr032,vr040,vr048, mr000     !                
	vasd     fr03,vr048,vr056, mr000     ! 
	vstd    vr056, gr08, gr00, mr000     ! 

	vpt          
        subli25  gr31,    1, gr31
VWT3:	brcs      es0,VWT3                   ! VWT(VU) 

        brnc   iccp.z, loop                   ! Get clock

	brnc     true,NEND                   ! End of Job     

NEND:	brc	true,_exit

GC1:	.int 3,1,0,0
GC2:	.int 3,1,0,0

!       Data Division

	.data      
Base:	.double   0.0e+00               ! set ZERO value
R:	.double   2.0e+00               ! set R value
T:	.double   3.0e+00               ! set T value
Q:	.double   4.0e+00               ! set Q value
Y:	.double   1,2,3,4,5,6,7,8,9,10  ! 
	.fill     390,8,0               ! 
Z:	.fill      10,8,0               ! 
	.double   1,2,3,4,5,6,7,8,9,10  ! 
	.fill     402,8,0               ! 
X:	.fill     400,8,0               ! 
