!   Livermore Loop for TaChyon assm                  
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Loop 3.   Inner Prod                             
!
	.text
	.align 8

	.global _startup
_startup:
	jmp	gr3

        .global _terminate
_terminate:
        jmp     gr3

	.global _main
_main:
!
!
CLOCK1: brnc     true, GC1
!
        seti     10000, gr31

loop:   seti     1000, gr01          ! set VL value
	seti     BASE, gr02          ! set X(BASE) address 
        addli25 gr02,0x3e88,gr12          ! set ZERO address
	ld.d    gr12, gr00, fr01          ! 
        addli25 gr02,0x3e80,gr11          ! set Q  address
	st.d    fr01, gr11, gr00          ! set 0 to Q 
!
        vpt
!
!                Q = Q + Z(K) * X(K)
!
VWT1:   brcs     es0,VWT1                 ! VWT(VU)	
VWT2:   brcs    asam,VWT2                 ! VWT(SU)
!
        vlvl    gr01                      ! VL=1000
        vld     gr02, gr00,vr000, mr00    ! LOAD X(1000)
        addli25 gr02,0x1f40,gr10          ! set Z  address	
	vld     gr10, gr00,vr016, mr00    ! LOAD Z(1000)
	vmd    vr000,vr016,vr032, mr00    ! X(1000)*Z(1000)
	vsmd   vr032, fr02, mr00          ! SUM(X(1000)*Z(1000))
	fadd.d  fr01, fr02, fr03          ! Q=Q+SUM
	st.d    fr03, gr11, gr00          ! SAVE Q
!
        vpt
        subli25 gr31,   1, gr31
VWT3:   brcs     es0,VWT3                 ! VWT(VU)	
!
CLOCK2: brnc  iccp.z, loop
!
	brnc    true,NEND                 ! End of Job
!
NEND:	brc	true,_exit
!
GC1:    .int      3,1,0,0
GC2:    .int      3,1,0,0
!
!       Data Division
!
	.data
BASE:
X:	.double   1.0e+00,2.0E+00,3.0E+00
        .fill     997,8,0                 ! set X value
Z:	.double   2.0e+00,3.0e+00,4.0e+00
        .fill     997,8,0                 ! set Z value
Q:	.double   1.0e+00                 ! set Q value
ZERO:	.double   0.0e+00                 !
ANS:    .double   2.0e+01                 ! Answer
