!   Livermore Loop for TaChyon assm                  
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Loop 4.   Banded Linear Equations                
!
	.text
	.align 8

	.global _startup
_startup:
	jmp	gr3

        .global _terminate
_terminate:
        jmp     gr3

	.global _main
_main:
!
!
!   +-->  L = 7  , 107 , 50
!   | +-> J = 30 , 870 , 5
!   | |  X(L-1) = X(L-1) - X(LW)*Y(J)
!   | +- LW = LW + 1
!   |    X(L-1) = Y(5)*X(L-1)
!   +---
!

	brnc     true,GC1                     ! Get clock

        seti   10000 , gr31

loop:	seti     169 , gr01                   ! Set VL value
	seti     Base, gr02                   ! Get Base = (X)
	addli25  gr02, 7280, gr03             ! Get Y addr    
	seti       3 , gr04                   ! Out of loop count
	seti       7 , gr05                   ! Init value   
	seti     232 , gr06                   ! Set Diplacement (Y)
	seti     40  , gr07                   ! set Distance    
	seti     48  , gr12                   !

	vpt
VWT1:	brcs      es0,VWT1                    ! VWT(VU) 
VWT2:	brcs     asam,VWT2                    ! VWT(SU) 

        vlvl     gr01

        addl     gr00, gr06, gr08             !
	vld      gr03, gr08,vr000,mr0         ! Load Y  (GVT)

A:
	vpt


	subli5   gr04,    1, gr09             ! -1
	sll      gr09,    3, gr10             ! *8
	add      gr02, gr10, gr11             !

VWT3:	brcs      es0,VWT3               ! VWT(VU) 
VWT4:	brcs     asam,VWT4               ! VWT(SU) 

	vlvl     gr01                         ! 

	vld      gr11, gr00,vr004,mr000       ! Load X(LW)
	vmd     vr000,vr004,vr008,mr000       ! L(LW) * Y(J)
	vsmd    vr008, fr01,mr000             ! X(L-1) = X(L-1) - ..

	ld.d     gr02, gr12, fr02             ! X(L-1)
	fsub.d   fr01, fr02, fr03             !

	ld.d     gr03,   32, fr04             ! Load Y(5)
	fmul.d   fr03, fr04, fr03             ! 
	st.d     fr03, gr02, gr12             ! Store X(L-1)

	addi25   gr05,   50, gr05             ! +50 
	addi25   gr12,  400, gr12
	subli5   gr04,    1, gr04             ! 
	brnc     iccp.z    , A

        vpt   
        subli25  gr31,    1,gr31
        brcs     es1       ,.

	brnc     iccp.z , loop                   !

	brnc     true , NEND                  !

NEND:	brc	true,_exit

GC1:	.int 3,1,0,0
GC2:    .int 3,1,0,0

	.data          
Base:
X:      .fill 6,8,0    
	.double 2,3,4,5
	.fill 900,8,0  
Y:      .fill 29,8,0   
	.double 3.0e+00
	.fill 900,8,0  





