!   Livermore Loop for TaChyon assm                  
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Loop 10.  Difference Predicotors                 
!
	.text
	.align 8

	.global _startup
_startup:
	jmp	gr3

        .global _terminate
_terminate:
        jmp     gr3

	.global _main
_main:

	brnc      true, GC1

        seti   10000 , gr31

loop:   seti      100 , gr01                ! Set VL value 
	seti      Base, gr02                ! Get Base (CX)
	addli25   gr02,12040, gr03          ! Get PX addr  
	seti      120 , gr04                ! Set Dist.   

	vpt          
VWT1:	brcs      es0,VWT1               ! VWT(VU) 
VWT2:	brcs     asam,VWT2               ! VWT(SU) 

        vlvl      gr01                     !

        addli25   gr02,   32, gr05          ! CX(5,i)
	vld       gr05, gr04,vr000,mr000    ! Load    CX(5,i)
	addli25   gr03,   32, gr06          ! PX(5,i)
	vld       gr06, gr04,vr002,mr000    ! Load    PX(5,i)
	vsd      vr000,vr004,vr006,mr000    ! 

	addli25   gr03,   40, gr15          ! PX(6,i)
	vld       gr15, gr04,vr008,mr000    ! Load    PX(6,i)
	vsd      vr006,vr008,vr010,mr000    ! 

	addli25   gr03,   48, gr07          ! PX(7,i)
	vld       gr07, gr04,vr012,mr000    ! Load    PX(7,i)
	vsd      vr010,vr012,vr014,mr000    ! 

	addli25   gr03,   56, gr08          ! PX(8,i) 
	vld       gr08, gr04,vr016,mr000    ! Load    PX(8,i)
	vsd      vr014,vr016,vr018,mr000    ! 

	addli25   gr03,   64, gr09          ! PX(9,i) 
	vld       gr09, gr04,vr020,mr000    ! Load    PX(9,i)
	vsd      vr018,vr020,vr022,mr000    ! 

	addli25   gr03,   72, gr10          ! PX(10,i) 
	vld       gr10, gr04,vr024,mr000    ! Load    PX(10,i)
	vsd      vr022,vr024,vr026,mr000    ! 

	addli25   gr03,   80, gr11          ! PX(11,i) 
	vld       gr11, gr04,vr028,mr000    ! Load    PX(11,i)
	vsd      vr026,vr028,vr030,mr000    ! 

	addli25   gr03,   88, gr12          ! PX(12,i) 
	vld       gr12, gr04,vr032,mr000    ! Load    PX(12,i)
	vsd      vr030,vr032,vr034,mr000    ! 

	addli25   gr03,   96, gr13          ! PX(13,i) 
	vld       gr13, gr04,vr036,mr000    ! Load    PX(13,i)
	vsd      vr034,vr036,vr038,mr000    ! 

	vstd     vr000, gr06, gr04,mr000    ! Store PX(5,i)
	vstd     vr006, gr05, gr04,mr000    ! Store PX(6,i)
	vstd     vr010, gr07, gr04,mr000    ! Store PX(7,i)
	vstd     vr014, gr08, gr04,mr000    ! Store PX(8,i)
	vstd     vr018, gr09, gr04,mr000    ! Store PX(9,i)
	vstd     vr022, gr10, gr04,mr000    ! Store PX(10,i)
	vstd     vr026, gr11, gr04,mr000    ! Store PX(11,i)
	vstd     vr030, gr12, gr04,mr000    ! Store PX(12,i)
	vstd     vr034, gr13, gr04,mr000    ! Store PX(13,i)
	addli25   gr03,  104, gr14          ! PX(14,i)
	vstd     vr038, gr14, gr04,mr000    ! Store PX(14,i)

	vpt          
        subli25   gr31,    1, gr31
VWT3:	brcs      es0,VWT3                  ! VWT(VU) 

	brnc     iccp.z , loop

	brnc     true , NEND
NEND:	brc	true,_exit

GC1:	.int     3,1,0,0
GC2:	.int     3,1,0,0

	.data

Base:
CX:	.fill    400,8,0
	.double  1,2,3,4,5
	.fill    1100,8,0 
PX:	.fill    400,8,0
	.double  1,2,3,4,5
	.fill    1100,8,0 

