#ident  "@(#)dtu.mk	1.2 12/21/92 22:25:04 - FUJITSU UXP/VPP"

ROOT =
INC = $(ROOT)/usr/include
INS=install
MKBOOT = mkboot
BOOTDIR = .
MASTERD = .
KBASE = ../..

DASHO = -O
DEFLIST =
PFLAGS = -I$(KBASE) -D_KERNEL $(MORECPP)
CFLAGS = $(DASHO) $(PFLAGS)
FRC =

DFILES = dc.o oc.o udtu.o bar.o dtuerrord.o
DFILE  = dtu.o

.c.o:
	$(CC) $(DEFLIST) $(CFLAGS) -c $*.c


all:	$(BOOTDIR)/DTU

$(BOOTDIR)/DTU:   $(DFILES) $(MASTERD)/dtu.cf
	$(LD) -r -o $(DFILE) $(DFILES) ; \
	$(MKBOOT) -m $(MASTERD) -d $(BOOTDIR) $(DFILE)

clean:
	-rm -f $(DFILES)

clobber:	clean
	-rm -f $(BOOTDIR)/DTU
FRC:

headinstall: \
	$(KBASE)/io/dtu/dc.h \
	$(KBASE)/io/dtu/oc.h \
	$(KBASE)/io/dtu/usr_dtu.h \
	$(KBASE)/io/dtu/bar.h \
	$(FRC)
	$(INS) -f $(INC)/sys -m 644 -u bin -g bin $(KBASE)/io/dtu/usr_dtu.h
	$(INS) -f $(INC)/sys -m 644 -u bin -g bin $(KBASE)/io/dtu/bar.h

head: \
	$(KBASE)/io/dtu/usr_dtu.h \
	$(KBASE)/io/dtu/bar.h \
	$(FRC)
	cp -p $(KBASE)/io/dtu/usr_dtu.h /home/usr3/DTU/KAI/xinc/sys/usr_dtu.h 
	cp -p $(KBASE)/io/dtu/bar.h     /home/usr3/DTU/KAI/xinc/sys/bar.h 
#
# Header dependencies
#

dc.o:	dc.c \
	$(KBASE)/util/types.h \
	$(KBASE)/util/param.h \
	$(KBASE)/io/dtu/dc.h \
	$(KBASE)/util/mcr_field.h \
	$(KBASE)/util/mcr.h \
	$(FRC)

oc.o:	oc.c \
	$(KBASE)/util/types.h \
	$(KBASE)/util/param.h \
	$(KBASE)/util/cmn_err.h \
	$(KBASE)/mem/immu.h \
	$(KBASE)/mem/page.h \
	$(KBASE)/mem/kmem.h \
	$(KBASE)/mem/kaidep.h \
	$(KBASE)/proc/proc.h \
	$(KBASE)/util/mcr_field.h \
	$(KBASE)/util/mcr.h \
	$(KBASE)/io/dtu/oc.h \
	$(KBASE)/io/dtu/dc.h \
	$(FRC)

udtu.o: udtu.c \
	$(KBASE)/util/types.h \
	$(KBASE)/util/mcr.h \
	$(KBASE)/util/cmn_err.h \
	$(KBASE)/util/vp_param.h \
	$(KBASE)/mem/kmem.h \
	$(KBASE)/mem/as.h \
	$(KBASE)/mem/seg.h \
	$(KBASE)/mem/seg_vp.h \
	$(KBASE)/mem/px_gs.h \
	$(KBASE)/proc/user.h \
	$(KBASE)/proc/proc.h \
	$(KBASE)/proc/sched.h \
	$(KBASE)/proc/signal.h \
	$(KBASE)/proc/siginfo.h \
	$(KBASE)/proc/pms/partition.h \
	$(KBASE)/svc/todr.h \
	$(KBASE)/svc/errno.h \
	$(KBASE)/io/dtu/usr_dtu.h \
	$(KBASE)/io/dtu/dc.h \
	$(KBASE)/io/dtu/oc.h \
	$(FRC)

bar.o: bar.c \
	$(KBASE)/util/types.h \
	$(KBASE)/util/mcr.h \
	$(KBASE)/util/cmn_err.h \
	$(KBASE)/proc/user.h \
	$(KBASE)/proc/proc.h \
	$(KBASE)/proc/sched.h \
	$(KBASE)/proc/pms/partition.h \
	$(KBASE)/io/dtu/bar.h \
	$(KBASE)/io/dtu/usr_dtu.h \
	$(KBASE)/svc/todr.h \
	$(KBASE)/svc/errno.h \
	$(FRC)

dtuerrord.o: dtuerrord.c \
	$(KBASE)/util/types.h \
	$(KBASE)/util/param.h \
	$(KBASE)/util/sysmacros.h \
	$(KBASE)/util/bootinfo.h \
	$(KBASE)/mem/immu.h \
	$(KBASE)/mem/page.h \
	$(KBASE)/mem/kmem.h \
	$(KBASE)/mem/kaidep.h \
	$(KBASE)/proc/proc.h \
	$(KBASE)/util/cmn_err.h \
	$(KBASE)/util/mcr.h \
	$(KBASE)/util/mcr_field.h \
	$(KBASE)/io/dtu/dc.h \
	$(FRC)
