/* @(#)prkai.c	1.9 1/30/93 */

#define NULL 0
char buf[1024];
int  bufp;
int  arg_dim[6];
int  argp;
int  cols;
int  sign;

startup()
{
        simsetup();
        dapfsetup();
        pasetup();
}

terminate()
{
	paterminate();
}

pepa_start()
{
	asm("st.mcr gr0,gr0,0x39c8");
	asm("pepa_start_asa:brc asa,pepa_start_asa");
}

pepa_stop()
{
	asm("st.mcr gr0,gr0,0x39d0");
	asm("pepa_stop_asa:brc asa,pepa_stop_asa");
}

scanf(fmt,a,b,c,d,e,f,g) char *fmt; int *a,*b,*c,*d,*e,*f,*g;
{
	ext_scanf(fmt,a,b,c,d,e,f,g);
}

sprintf(buf,fmt,a,b,c,d,e,f,g) char *buf,*fmt; int a,b,c,d,e,f,g;
{
	oprintf(buf,fmt,a,b,c,d,e,f);
}

printf(fmt,a,b,c,d,e,f,g) char *fmt; int a,b,c,d,e,f,g;
{
  int len;
  extern int _opsr0;

  oprintf(buf+bufp, fmt, a, b, c, d, e, f);
  len = strlen(buf);
  if (buf[len-1] != '\n') {
    bufp = len;
  }
  else {
    ext_printf("%s", buf);
    a2e1024(buf, len);
    if (_opsr0 == 0)
      dapf(buf, len);
    bufp = 0;
  }
}

unsigned
div(a, b) unsigned a, b;
{
  int i;
  unsigned b0, b1;
  unsigned c = 0;

  b1 = (b & 1) ? 0x80000000 : 0;
  b0 = b >> 1;

  for (i=0; i<32; i++) {
    if (b0) {
      c <<= 1;
    }
    else if (a >= b1) {
      a -= b1;
      c = (c << 1) + 1;
    }
    else {
      c <<= 1;
    }

    b1 = (b1 >> 1) | ((b0 & 1) ? 0x80000000 : 0);
    b0 >>= 1;
  }
  return(c);
}

_printf_dec(p,q) char **p; int q;
{
  char ascii[20];
  int i;

  if (q == 0) {
    *(*p)++ = '0';
    return;
  }

  if (q < 0) {
    *(*p)++ = '-';
    q = -q;
  }
  else if (sign == '+') {
    *(*p)++ = '+';
  }
  
  for (i = 0; q;) {
    ascii[i++] = '0' + (q % 10);
    q = q / 10;
  }

  for (i--; i >= 0 ; i--)
    *(*p)++ = ascii[i];
}

_printf_udec(p,q) char **p; unsigned int q;
{
  char ascii[20];
  int i;

  if (q == 0) {
    *(*p)++ = '0';
    return;
  }

  for (i = 0; q;) {
    ascii[i++] = '0' + (q - div(q,10) * 10);
    q = div(q,10);
  }

  for (i--; i >= 0 ; i--)
    *(*p)++ = ascii[i];
}

_printf_uoct(p,q) char **p; unsigned int q;
{
  char ascii[20];
  int i;

  if (q == 0) {
    *(*p)++ = '0';
    return;
  }

  for (i = 0; q;) {
    ascii[i++] = '0' + (q & 7);
    q = q >> 3;
  }

  for (i--; i >= 0 ; i--)
    *(*p)++ = ascii[i];
}

_printf_uhex(p,q) char **p; unsigned int q;
{
  unsigned u, l;
  int i;

  for (i=0; i<4; i++) {
    u = *((unsigned char*)&q+i) >> 4;
    l = *((unsigned char*)&q+i) & 15;
    *(*p)++ = u < 10 ? '0' + u : 'A' + u - 10;
    *(*p)++ = l < 10 ? '0' + l : 'A' + l - 10;
  }
}

_printf_double_f(p,q) char **p; double q;
{
  int x;

  if (q == 0.0) {
    *(*p)++ = '0';
    *(*p)++ = '.';
    for (; cols; cols--)
      *(*p)++ = '0';
    return;
  }

  if (q < 0.0) {
    *(*p)++ = '-';
    q = -q;
  }
  else if (sign == '+') {
    *(*p)++ = '+';
  }

  if (q >= 1.0) {
    for (x=0; q >= 10.0; x++)
      q = q / 10.0;
    for (; x >= 0; x--) {
      *(*p)++ = (int)q + '0';
      q = q - (int)q;
      q = q * 10.0;
    }
    *(*p)++ = '.';
    for (; cols; cols--) {
      *(*p)++ = (int)q + '0';
      q = q - (int)q;
      q = q * 10.0;
    }
  }
  else {
    for (x=1; q < 1.0; x--)
      q = q * 10.0;
    *(*p)++ = '0';
    *(*p)++ = '.';
    for (; x < 0 && cols; x++,cols--) {
      *(*p)++ = '0';
    }
    for (; cols ; cols--) {
      *(*p)++ = (int)q + '0';
      q = q - (int)q;
      q = q * 10.0;
    }
  }
}

_printf_double_e(p,q) char **p; double q;
{
  int x;

  if (q == 0.0) {
    *(*p)++ = '0';
    *(*p)++ = '.';
    for (; cols; cols--)
      *(*p)++ = '0';
    *(*p)++ = 'E';
    *(*p)++ = '+';
    *(*p)++ = '0';
    *(*p)++ = '0';
    return;
  }

  if (q < 0.0) {
    *(*p)++ = '-';
    q = -q;
  }
  else if (sign == '+') {
    *(*p)++ = '+';
  }

  if (q >= 1.0) {
    for (x=0; q >= 10.0; x++)
      q = q / 10.0;
  }
  else {
    for (x=0; q < 1.0; x--)
      q = q * 10.0;
  }
  *(*p)++ = (int)q + '0';
  *(*p)++ = '.';
  for (; cols; cols--) {
    q = q - (int)q;
    q = q * 10.0;
    *(*p)++ = (int)q + '0';
  }
  *(*p)++ = 'E';
  *(*p)++ = x >= 0 ? '+' : '-';
  x = x >= 0 ? x : -x;
  *(*p)++ = (x / 10) + '0';
  *(*p)++ = (x % 10) + '0';
}

char *
parse_format(p)
char *p;
{
  for (p++; *p; p++) {
    switch (*p) {
    case '*':
	cols = arg_dim[argp++];
	break;
    case '+':
	sign = '+';
	break;
    case '-':
    case ' ':
    case '#':
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case 'h':
    case 'l':
    case 'L':
    case '.':
	break;
    default: 
	return p;
    }
  }

  return p;
}

oprintf(buf,fmt,a,b,c,d,e,f)
char *buf;
char *fmt;
int  a,b,c,d,e,f;
{
  char     *p;
  int      len;
  double   df;
  int      si;
  unsigned usi;
  
  argp = 0;

  arg_dim[0] = a;
  arg_dim[1] = b;
  arg_dim[2] = c;
  arg_dim[3] = d;
  arg_dim[4] = e;
  arg_dim[5] = f;

  for(p = fmt; *p; p++) {
    cols = 10;
    sign = ' ';
    if ((char) *p != '%')
      *buf++ = *p;
    else {    
      p = parse_format(p);

      switch (*p) {
       case '%':
	*buf++ = '%';
	break;

       case 'd':
       case 'i':
	si = arg_dim[argp++];
	_printf_dec(&buf, si);
	break;

       case 'u':
	usi = arg_dim[argp++];
	_printf_udec(&buf, usi);
	break;

       case 'o':
	usi = arg_dim[argp++];
	_printf_uoct(&buf, usi);
	break;

       case 'p':
       case 'x':
       case 'X':
	usi = arg_dim[argp++];
	_printf_uhex(&buf,usi);
	break;

       case 'f':
	* (int*)&df    = arg_dim[argp++];
	*((int*)&df+1) = arg_dim[argp++]; 
	_printf_double_f(&buf, df);
	break;

       case 'e':
       case 'E':
       case 'g':
       case 'G':
	* (int*)&df    = arg_dim[argp++];
	*((int*)&df+1) = arg_dim[argp++]; 
	_printf_double_e(&buf, df);
	break;

       case 'c':
	*buf++ = arg_dim[argp++];
	break;

       case 's':
        len = strlen(arg_dim[argp]);
	strcpy(buf, arg_dim[argp]);
	argp++;
	buf += len;
	break;

       default:
	break;
      }
    }
  }
  *buf = NULL;
  return(strlen(buf));
}

static char ebcdic[] =
{
 0x00, 0x01, 0x02, 0x03, 0x37, 0x2d, 0x2e, 0x2f,
 0x16, 0x05, 0x15, 0x0b, 0x00, 0x0d, 0x0e, 0x0f,
 0x10, 0x11, 0x12, 0x13, 0x3c, 0x3d, 0x32, 0x26,
 0x18, 0x19, 0x3f, 0x27, 0x22, 0x00, 0x00, 0x00,
 0x40, 0x4f, 0x7f, 0x7b, 0x5b, 0x6c, 0x50, 0x7d,
 0x4d, 0x5d, 0x5c, 0x4e, 0x6b, 0x60, 0x4b, 0x61,
 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,
 0xf8, 0xf9, 0x7a, 0x5e, 0x4c, 0x7e, 0x6e, 0x6f,
 0x7c, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
 0xc8, 0xc9, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6,
 0xd7, 0xd8, 0xd9, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6,
 0xe7, 0xe8, 0xe9, 0x4a, 0xe0, 0x5a, 0x5f, 0x6d,
 0x79, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
 0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96,
 0x97, 0x98, 0x99, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6,
 0xa7, 0xa8, 0xa9, 0xc0, 0x6a, 0xd0, 0xa1, 0x07,

 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

a2e1024(s, len) unsigned char *s; unsigned len;
{
        unsigned col;

        if (len > 1024)
            len = 1024;

        for (col = 0; col < len; col++, s++) {
            if (*s >= 'a' && *s <= 'z')
                *s = *s - 'a' + 'A';
            *s = ebcdic[*s];
        }
}

