static char SccsId[] = "@(#)argcal.c	4.7    9/25/91    15:08:09";

#include "macc.h"

argcal(optr, lbuf, mode)
    char  *optr;
    char  *lbuf;
    int   mode;
{
    int    tmp;
    char   *tokp, *tptr, *lptr;
    char   *s1, *s2, *dp, *o_optr;
    int    sdtno, edtno;
    char   sbuf[256];
    static char   pbuf[256];
    static char   line[PARA_TMP];
    static char   dummy[PARA_TMP];
    static char   buffer[PARA_TMP];
 
    if( !lbuf ){
        lbuf = dummy;
    }
    if( *optr == '#' ){
        strcpy( line, optr );
        strcpy( lbuf, optr );
    }
    else{
        lptr = line;
#ifdef MACC
        for( s1=buffer ; *optr ; ){
            if(*optr == '{'){
                if( ( tokp = strtok( ++optr, "}" ) ) != NULL ){
                    if( ( *tokp == '(' ) && ( *(tokp+strlen(tokp)-1) == ')' ) ){
                        *(tokp+strlen(tokp)-1) = NULL;
                        strcpy( s1, tokp+1 );
                        s1 += strlen( tokp+1 );
                        strcpy( lbuf, tokp+1 );
                        lbuf += strlen( tokp+1 );
                        optr += strlen( tokp ) + 2;
                    }
                    else{
                        tptr = (char *)argck_para(tokp, &dp);
                        strcpy( s1, tptr );
                        s1 += strlen(tptr);
                        strcpy( lbuf, dp );
                        lbuf += strlen(dp);
                        optr += strlen(tokp) + 1;
                    }
                }
                else{
                    sprintf( error_buf, "%d %s invalid statement",
                                                    fp[fpr_level].cnt, optr );
                    longjmp( sjenv, 9 );
                }
            }
            else{
                *s1++ = *optr;
                *lbuf++ = *optr++;
            }
        }
#else
        strcpy( buffer, optr );
#endif
        *s1 = NULL;
        *lbuf = NULL;
        optr = buffer;

        while(*optr) {
            if( *optr == '.' ){
                /*
                for( tmp=0 ; c_len[tmp] ; tmp++ ){
                    if( !strncmp( optr, cname[tmp], c_len[tmp] ) ){
                        break;
                    }
                }
                */
                switch( *(optr+1) ){
                  case 'P' :
                  case 'p' :
                        if( !strncmp( optr, ".PRINTF(", 8 ) ||
                            !strncmp( optr, ".printf(", 8 ) ){
                            optr += 8;
                            tokp = (char *)argck_para_s(&optr);
                            for( ; isspace( *optr ) ; optr++ );
                            if( ( *optr++ != ',' ) ||
                                ( ( s1 = strtok( optr, ")" ) ) == NULL ) ){
                                sprintf( error_buf, "%d %s invalid statement",
                                                   fp[fpr_level].cnt, optr );
                                longjmp( sjenv, 10 );
                            }
                            o_optr = s1 + strlen( s1 ) + 1;
                            if( *s1 == '"' ){
                                if( *(s1 + strlen(s1) - 1) != '"' ){
                                    sprintf( error_buf,
                                                   "%d %s invalid statement",
                                                   fp[fpr_level].cnt, s1 );
                                    longjmp( sjenv, 10 );
                                }
                                *(s1 + strlen(s1)-1) = NULL;
                                sprintf( sbuf, tokp, s1+1 );
                            }
                            else{
                                is_calc( s1, &sdtno, 10 );
                                sprintf( sbuf, tokp, sdtno );
                            }
                            if( mode ){
                                sprintf( lptr, "\"%s\"", sbuf );
                                lptr += ( strlen( sbuf ) + 2 );
                            }
                            else{
                                strcpy( lptr, sbuf );
                                lptr += strlen( sbuf );
                            }
                            optr = o_optr;
                            continue;
                        }
                        break;
                  case 'S' :
                  case 's' :
                        if( !strncmp( optr, ".SUBSTR(", 8 ) ||
                            !strncmp( optr, ".substr(", 8 ) ){
                            optr += 8;
                            tokp = (char *)argck_para_s(&optr);
                            for( ; isspace( *optr ) ; optr++ );
                            if( ( *optr++ != ',' ) ||
                                ( ( s1 = strtok( optr, "," ) ) == NULL ) ||
                                ( ( s2 = strtok( NULL, ")" ) ) == NULL ) ){
                                sprintf( error_buf, "%d %s invalid statement",
                                                   fp[fpr_level].cnt, optr );
                                longjmp( sjenv, 10 );
                            }
                            o_optr = s2 + strlen( s2 ) + 1;
                            is_calc( s1, &sdtno, 10 );
                            is_calc( s2, &edtno, 10 );
                            /*
                                sscanf( tptr, ",%d,%d",
                                              (char *)&sdtno,
                                              (char *)&edtno );
                            */
                            if( (sdtno+edtno) <= strlen(tokp) ){
                                *(tokp+sdtno+edtno) = NULL;
                                tokp += sdtno;
                                if( mode ){
                                    sprintf( lptr, "\"%s\"", tokp );
                                    lptr += ( strlen( tokp ) + 2 );
                                }
                                else{
                                    strcpy( lptr, tokp );
                                    lptr += strlen( tokp );
                                }
                            }
                            optr = o_optr;
                            continue;
                        }
                        else{
                            if( !strncmp( optr, ".SUBNSTR(", 9 ) ||
                                !strncmp( optr, ".subnstr(", 9 ) ){
                                optr += 9;
                                tokp = (char *)argck_para_s(&optr);
                                for( ; isspace( *optr ) ; optr++ );
                                if( ( *optr++ != ',' ) ||
                                    ( ( s1 = strtok( optr, "," ) ) == NULL ) ||
                                    ( ( s2 = strtok( NULL, ")" ) ) == NULL ) ){
                                    sprintf( error_buf,
                                                      "%d %s invalid statement",
                                                      fp[fpr_level].cnt, optr );
                                    longjmp( sjenv, 10 );
                                }
                                o_optr = s2 + strlen( s2 ) + 1;
                                is_calc( s1, &sdtno, 10 );
                                is_calc( s2, &edtno, 10 );
                                /*
                                    sscanf( tptr, ",%d,%d",
                                                  (char *)&sdtno,
                                                  (char *)&edtno );
                                */
                                if( (sdtno+edtno) <= strlen(tokp) ){
                                    *(tokp+sdtno+edtno) = NULL;
                                    tokp += sdtno;
                                    if( mode ){
                                        sprintf( lptr, "\"%s\"", tokp );
                                        lptr += ( strlen( tokp ) + 2 );
                                    }
                                    else{
                                        strcpy( lptr, tokp );
                                        lptr += strlen( tokp );
                                    }
                                }
                                else{
                                    if( sdtno <= strlen(tokp) ){
                                        tokp += sdtno;
                                        if( mode ){
                                            sprintf( lptr, "\"%s\"", tokp );
                                            lptr += ( strlen( tokp ) + 2 );
                                        }
                                        else{
                                            strcpy( lptr, tokp );
                                            lptr += strlen( tokp );
                                        }
                                    }
                                }
                                optr = o_optr;
                                continue;
                            }
                            else{
                                if( !strncmp( optr, ".SHIFT(", 7 ) ||
                                    !strncmp( optr, ".shift(", 7 ) ){
                                    optr += 7;
                                    s1 = (char *)argck_shift( optr, &s2 );
                                    optr = s1;
                                    if( mode ){
                                        sprintf( lptr, "\"%s\"", s2 );
                                        lptr += ( strlen( s2 ) + 2 );
                                    }
                                    else{
                                        strcpy( lptr, s2 );
                                        lptr += strlen( s2 );
                                    }
                                    continue;
                                }
                            }
                        }
                        break;
                  case 'I' :
                  case 'i' :
                        if( !strncmp( optr, ".INSTR(", 7 ) ||
                            !strncmp( optr, ".instr(", 7 ) ){
                            optr += 7;
                            s1 = (char *)argck_para_s(&optr);
                            strcpy( sbuf, s1 );
                            for( ; isspace( *optr ) ; optr++ );
                            if( *optr++ == ',' ){
                                s2 = (char * )argck_para_s(&optr);
                                for( ; isspace( *optr ) ; optr++ );
                                if( *optr == ')' ){
                                    sdtno = argck_instr( sbuf, s2, 0 );
                                    optr++;
                                }
                                else{
                                    if( ( *optr++ == ',' ) &&
                                        ( ( s1 = strtok( optr, ")" ) )
                                                              != NULL ) ){
                                        is_calc( optr, &edtno, 10);
                                        /*
                                        for( ; isspace( *optr ) ; optr++ );
                                        edtno = atoi( optr );
                                        */
                                        sdtno = argck_instr(
                                                      sbuf, s2, edtno );
                                        optr += ( strlen( optr ) + 1 );
                                    }
                                    else{
                                        sprintf( error_buf,
                                                   "%d %s invalid statement",
                                                   fp[fpr_level].cnt, optr );
                                                   longjmp( sjenv, 10 );
                                    }
                                }
                                sprintf( sbuf, "%d", sdtno );
                                strcpy( lptr, sbuf);
                                lptr += strlen(sbuf);
                            }
                            else{
                                sprintf( error_buf, "%d %s invalid statement",
                                                   fp[fpr_level].cnt, optr );
                                longjmp( sjenv, 10 );
                            }
                            continue;
                        }
                        break;
                  case 'L' :
                  case 'l' :
                        if( !strncmp( optr, ".LENGTH(", 8 ) ||
                            !strncmp( optr, ".length(", 8 ) ){
                            optr += 8;
                            s1 = (char *)argck_para_s(&optr);
                            sdtno = strlen( s1 );
                            for( ; isspace( *optr ) ; optr++ );
                            if( *optr++ != ')' ){
                                sprintf( error_buf, "%d %s invalid statement",
                                                   fp[fpr_level].cnt, optr );
                                longjmp( sjenv, 10 );
                            }
                            sprintf( sbuf, "%d", sdtno );
                            strcpy( lptr, sbuf);
                            lptr += strlen(sbuf);
                            continue;
                        }
                        break;
                  case 'A' :
                  case 'a' :
                        if( !strncmp( optr, ".ARGC(", 6 ) ||
                            !strncmp( optr, ".argc(", 6 ) ){
                            optr += 6;
                            s1 = (char *)argck_argc( optr, &tmp );
                            optr = s1;
                            sprintf( lptr, "%d", tmp );
                            lptr += strlen( lptr );
                            continue;
                        }
                        break;
#ifdef MACC
                  case 'C' :
                  case 'c' :
                        if( !strncmp( optr, ".CONVSTR(", 9 ) ||
                            !strncmp( optr, ".convstr(", 9 ) ){
                            optr += 9;
                            s1 = (char *)argck_para_s(&optr);
                            if( (long)( s2 = 
                                    (char *)argck_para_cs(s1) ) == -1 ){
                                sprintf( error_buf, "%d %s undefined parameter",
                                                        fp[fpr_level].cnt,s1 );
                                longjmp( sjenv, 11 );
                            }
                            for( ; isspace( *optr ) ; optr++ );
                            if( *optr++ != ')' ){
                                sprintf( error_buf, "%d %s invalid statement",
                                                    fp[fpr_level].cnt, optr );
                                longjmp( sjenv, 10 );
                            }
                            if( mode ){
                                sprintf( lptr, "\"%s\"", s2 );
                                lptr += ( strlen(s2) + 2 );
                            }
                            else{
                                strcpy( lptr, s2 );
                                lptr += strlen(s2);
                            }
                            continue;
                        }
                        else{
                            if( !strncmp( optr, ".CONVNSTR(", 10 ) ||
                                !strncmp( optr, ".convnstr(", 10 ) ){
                                optr += 10;
                                s1 = (char *)argck_para_s(&optr);
                                if( (long)( s2 = 
                                        (char *)argck_para_cs(s1) ) == -1 ){
                                    s2 = s1;
                                }
                                for( ; isspace( *optr ) ; optr++ );
                                if( *optr++ != ')' ){
                                    sprintf( error_buf,
                                                     "%d %s invalid statement",
                                                     fp[fpr_level].cnt, optr );
                                    longjmp( sjenv, 10 );
                                }
                                if( mode ){
                                    sprintf( lptr, "\"%s\"", s2 );
                                    lptr += ( strlen(s2) + 2 );
                                }
                                else{
                                    strcpy( lptr, s2 );
                                    lptr += strlen(s2);
                                }
                                continue;
                            }
                        }
                        break;
#endif
                  default :
                        break;
                }
            }
            *lptr++ = *optr++;
        }
        *lptr = NULL;
    }
    return((long)line);
}


argck_para_s( dp )
    char    **dp;
{
    static char    lbuf[256];
    char           *lp;

    lp = lbuf;
    for( ; isspace( **dp ) ; (*dp)++ );
    if( *(*dp)++ != '\"' ){
        sprintf( error_buf, "%d %s invalid statement", fp[fpr_level].cnt, *dp );
        longjmp( sjenv, 12 );
    }
    while( **dp ){
        if( ( **dp == '\"' ) && ( *(*dp-1) != '\\' ) ){
            (*dp)++;
            *lp = NULL;
            return( (long)lbuf );
        }
        else{
            *lp++ = *(*dp)++;
        }
    }
    sprintf( error_buf, "%d %s invalid statement( \" )",
                                                     fp[fpr_level].cnt, *dp );
    longjmp( sjenv, 13 );
}

argck_skip( dp )
    char    *dp;
{
    static char    dbuf[256];
    char    *sp;

    for( sp = dbuf ; *dp ; dp++ ){
        if( !isspace( *dp ) ){
            *sp++ = *dp;
        }
    }
    *sp = NULL;
    return( (long)dbuf );
}

#ifdef MACC
argck_para(ptr, dp )
    char    *ptr;
    char    **dp;
{
    int     tmp;

    if( ( tmp = p_hithash( ptr ) ) != -1 ){
        *dp = prm_tbl[tmp].pram;
        return( (long)prm_tbl[tmp].pram );
    }
    if( ( tmp = a_hithash( ptr ) ) != -1 ){
        if( asn_tbl[tmp].mode >= MAC_DFS ){
            *dp = asn_tbl[tmp].name;
        }
        else{
            *dp = asn_tbl[tmp].pram;
        }
        return( (long)asn_tbl[tmp].pram );
    }
    sprintf( error_buf, "%d %s undefined parameter", fp[fpr_level].cnt,ptr );
    longjmp( sjenv, 14 );
}

argck_para_cs(ptr)
    char    *ptr;
{
    int     tmp;

    if( ( tmp = p_hithash( ptr ) ) != -1 ){
        return( (long)prm_tbl[tmp].pram );
    }
    if( ( tmp = a_hithash( ptr ) ) != -1 ){
        return( (long)asn_tbl[tmp].pram );
    }
    return( -1 );
}
#endif

argck_instr( s1, s2, dl )
    char    *s1, *s2;
    int     dl;
{
    int     tmp, slen;
    char    *stp;

    if( dl < 0 ){
        return( -1 );
    }
    else{
        stp = s1;
        slen = strlen( s2 );
    
        for( tmp=0 ; ( tmp<dl ) && ( *s1++ ) ; tmp++ );
        for( ; strlen(s1) >= strlen(s2) ; s1++ ){
            if( !strncmp( s1, s2, slen ) ){
                return( (long)( s1 - stp ) );
            }
        }
        return( -1 );
    }
}

argck_shift( ptr, dp )
    char     *ptr;
    char     **dp;
{
    char     *sp;
    int      tmp, i;
    char     *cp[256];

    sp = shift_ent;
    for( tmp=0 ; tmp<256 ; tmp++ ){
        for( ; isspace( *ptr ) ; ptr++ );
        if( *ptr == '\"' ){
            ptr++;
            cp[tmp] = sp;
            while( *ptr ){
                if( ( *ptr == '\"' ) && ( *(ptr-1) != '\\' ) ){
                    *sp++ = NULL;
                    if( *(++ptr) != ',' ){
                        sprintf( error_buf, "%d %s invalid statement",
                                                     fp[fpr_level].cnt, *ptr );
                        longjmp( sjenv, 15 );
                    }
                    ptr++;
                    break;
                }
                else{
                    *sp++ = *ptr++;
                }
            }
        }
        else{
            break;
        }
    }
    if( ( sp = strtok( ptr, ")" ) ) == NULL ){
        sprintf( error_buf, "%d %s invalid statement",
                                                 fp[fpr_level].cnt, *ptr );
        longjmp( sjenv, 15 );
    }
    ptr += strlen( sp ) + 1;
    is_calc( sp, &i, 10 );
    if( ( i >= 0 ) && ( i < tmp ) ){
        *dp = cp[i];
    }
    else{
        *shift_ent = NULL;
        *dp = shift_ent;
    }
    return( (long)ptr );
}

argck_argc( ptr, dp )
    char     *ptr;
    int      *dp;
{
    int      cnt;
    int      tmp, i;

    cnt = 0;
    for( tmp=0 ; tmp<256 ; tmp++ ){
        for( ; isspace( *ptr ) ; ptr++ );
        if( *ptr == '\"' ){
            ptr++;
            i = 0;
            while( *ptr ){
                if( ( *ptr == '\"' ) && ( *(ptr-1) != '\\' ) ){
                    if( *(++ptr) != ',' ){
                        if( i > 0 ){
                            cnt++;
                        }
                        tmp = 256;
                        break;
                    }
                    ptr++;
                    if( i > 0 ){
                        cnt++;
                    }
                    break;
                }
                else{
                    ptr++;
                    i++;
                }
            }
        }
        else{
            break;
        }
    }
    for( ; isspace( *ptr ) ; ptr++ );
    if( *ptr++ != ')' ){
        sprintf( error_buf, "%d %s invalid statement",
                                                    fp[fpr_level].cnt, ptr );
        longjmp( sjenv, 16 );
    }
    *dp = cnt;
    return( (long)ptr );
}
