static char SccsId[] = "@(#)convdt.c	4.7    9/25/91    15:07:32";

#include "macc.h"

/*************************************************************************
*
*  NAME : convdt
*
*  FUNCTION : macro data convert
*
*  SYNOPSIS : convdt(ptr)
*                 char  *ptr ; macro define (call) instruction pointer
*
*  RETURN   :  0 normal end
*             -1 invalid input error
*
*************************************************************************/

convdt(ptr, fpwo, fpwl, svchr)
char  *ptr;
FILE  *fpwo, *fpwl;
char  *svchr;
{
    int         m_hashval;
    char        *pptr, *dp;
    int         tmp;
    static char line[FGET_SIZ];

    prm_st_cnt = 0;
    ptr++;
    mac_cnt++;
    /*
    for( tmp = 0 ; tmp < PRITBL_CNT + 1 ; tmp++ ){
        prm_tbl[tmp].name = NULL;
    }
    */
    dp = (char *)argcal( ptr, NULL, NULL);
    m_hashval = cvhash(dp);
    if( ( tmp = (macro_lst+m_hashval)->pcnt ) != -1 ){
        prm_st_cnt = 0;
        while( prm_buf[tmp].name ){
            prm_st[prm_st_cnt++] = tmp;
            p_sthash( prm_buf[tmp].name, prm_buf[tmp].pram, mac_cnt, prm_tbl );
            tmp++;
        }
        prm_st[prm_st_cnt] = 0;
    }

    pptr = strtok( NULL, "\n" );
    linkpara( pptr, fpwo, fpwl, svchr, NULL );
    tmp = usemac( (macro_lst+m_hashval)->hash, fpwo, fpwl );
    mac_cnt--;
    return( tmp );
}

convbuf(ptr, fpwo, fpwl, svchr)
char  *ptr;
FILE  *fpwo, *fpwl;
char  *svchr;
{
    char        *pptr, *sptr;
    int         tmp;

    pptr = strtok( NULL, "\n" );
    sptr = (char *)linkpara( pptr, fpwo, fpwl, svchr, ptr );
    (mac_lst+hashval)->type = M_USER;
    (mac_lst+hashval)->llink = (char *)sptr;
    if(if_flag) {
        tbl_id->llink = (char *) (mac_lst+hashval);
        if_flag = 0;
    }
    else
        tbl_id->rlink = (char *) (mac_lst+hashval);
    tbl_id = mac_lst+hashval;
    hashval++;

    return( 0 );
}

convin(ppoint, fpwo, fpwl)
unsigned  *ppoint;
FILE      *fpwo, *fpwl;
{
    int         m_hashval;
    char        *pptr, *sptr;
    int         tmp;
    static char line[FGET_SIZ];
    char        buffer[PARA_TMP];

    prm_st_cnt = 0;
    mac_cnt++;

    for( tmp = 0 ; tmp < PRITBL_CNT + 1 ; tmp++ ){
        if( prm_tbl[tmp].mode == mac_cnt ){
            /*
            prm_tbl[tmp].name = NULL;
             */
            prm_tbl[tmp].mode = MAC_ERR;
        }
    }

    pptr = (char *)*ppoint++;
    pptr++;
    sptr = (char *)argcal( pptr, NULL, NULL);
    m_hashval = cvhash(sptr);
    if( ( tmp = (macro_lst+m_hashval)->pcnt ) != -1 ){
        prm_st_cnt = 0;
        while( prm_buf[tmp].name ){
            prm_st[prm_st_cnt++] = tmp;
            if( p_sthash( prm_buf[tmp].name, prm_buf[tmp].pram, mac_cnt, prm_tbl ) == -1 ){
                sprintf( error_buf, "%d parametr table overflow for %s in %s",
                                 fp[fpr_level].cnt, prm_buf[tmp].name, sptr );
                longjmp( sjenv, 26 );
            }
            tmp++;
        }
        prm_st[prm_st_cnt] = 0;
    }

    pptr = (char *)*ppoint++;
    if( pptr ){
        mac_cnt--;
        sptr = (char *)argcal(pptr, NULL, NULL);
        mac_cnt++;
        set_prm_tbl( sptr );
        sptr = (char *)*ppoint++;
        strcpy( buffer, sptr );
        pptr = strtok( buffer, "\n" );
        while( pptr ){
            if( fpwl ){
                fprintf( fpwl, "   %s\n", pptr );
            }
            fprintf( fpwo, "!  %s\n", pptr );
            pptr = strtok( NULL, "\n" );
        }
    }
    else{
        sptr = (char *)*ppoint++;
        if( fpwl ){
            fprintf( fpwl, "   %s", sptr);
        }
        fprintf( fpwo, "!  %s", sptr );
    }

    tmp = usemac( (macro_lst+m_hashval)->hash, fpwo, fpwl );
    mac_cnt--;
    return( tmp );
}
