/* @(#)ip-oper.c	1.11    3/4/93 */

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* ip-oper.c    89/10/1 */
 
/********************************
*	nop			*
* 'c'  return SCORE_FREE        *
* 'r'  return SCORE_FREE        *
* 'x'  return SCORE_FREE        *
********************************/

o_nop(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  return(SCORE_FREE);
}

/********************************
*	branch			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_brcs0(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_star0_check_score(t_pe) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    src1 = ((int)(insn.i3_12_5.im << 20) >> 20);
    src2 = insn.i3_12_5.r3;
    src3 = pe[T_PE].sr[STAR0].ful;
    return;
    break;
  case 'x':
    if(src3 & ((unsigned)0x80000000 >> src2)) {
      pe[T_PE].sr[PC].ful += (src1 << 3);
      if (src2) {
        if ((src1 << 3) & 0x80000000)
          pe[T_PE].brcs_b_t++;
        else
          pe[T_PE].brcs_f_t++;
      }
    }
    else {
      if ((src1 << 3) & 0x80000000)
        pe[T_PE].brcs_b_n++;
      else
        pe[T_PE].brcs_f_n++;
    }
    return;
    break;
  }
}

o_brcs1(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    src1 = ((int)(insn.i3_12_5.im << 20) >> 20);
    src2 = insn.i3_12_5.r3;
    src3 = pe[T_PE].sr[STAR1].ful;
    return;
    break;
  case 'x':
    if(src3 & ((unsigned)0x80000000 >> src2)) {
      pe[T_PE].sr[PC].ful += (src1 << 3);
      if (src2) {
        if ((src1 << 3) & 0x80000000)
          pe[T_PE].brcs_b_t++;
        else
          pe[T_PE].brcs_f_t++;
      }
    }
    else {
      if ((src1 << 3) & 0x80000000)
        pe[T_PE].brcs_b_n++;
      else
        pe[T_PE].brcs_f_n++;
    }
    return;
    break;
  }
}

o_brncs0(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_star0_check_score(t_pe) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    src1 = ((int)(insn.i3_12_5.im << 20) >> 20);
    src2 = insn.i3_12_5.r3;
    src3 = pe[T_PE].sr[STAR0].ful;
    return;
    break;
  case 'x':
    if(!(src3 & ((unsigned)0x80000000 >> src2))) {
      pe[T_PE].sr[PC].ful += (src1 << 3);
      if (src2) {
        if ((src1 << 3) & 0x80000000)
          pe[T_PE].brcs_b_t++;
        else
          pe[T_PE].brcs_f_t++;
      }
    }
    else {
      if ((src1 << 3) & 0x80000000)
        pe[T_PE].brcs_b_n++;
      else
        pe[T_PE].brcs_f_n++;
    }
    return;
    break;
  }
}

o_brncs1(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    src1 = ((int)(insn.i3_12_5.im << 20) >> 20);
    src2 = insn.i3_12_5.r3;
    src3 = pe[T_PE].sr[STAR1].ful;
    return;
    break;
  case 'x':
    if(!(src3 & ((unsigned)0x80000000 >> src2))) {
      pe[T_PE].sr[PC].ful += (src1 << 3);
      if (src2) {
        if ((src1 << 3) & 0x80000000)
          pe[T_PE].brcs_b_t++;
        else
          pe[T_PE].brcs_f_t++;
      }
    }
    else {
      if ((src1 << 3) & 0x80000000)
        pe[T_PE].brcs_b_n++;
      else
        pe[T_PE].brcs_f_n++;
    }
    return;
    break;
  }
}

o_brc0(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_star0_check_score(t_pe) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    src1 = (insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l;
    src2 = insn.i3_32_5.r3;
    src3 = pe[T_PE].sr[STAR0].ful;
    return;
    break;
  case 'x':
    if(src3 & ((unsigned)0x80000000 >> src2)) {
      pe[T_PE].sr[PC].ful += (src1 << 3);
      if (src2) {
        if ((src1 << 3) & 0x80000000)
          pe[T_PE].brc_b_t++;
        else
          pe[T_PE].brc_f_t++;
      }
    }
    else {
      if ((src1 << 3) & 0x80000000)
        pe[T_PE].brc_b_n++;
      else
        pe[T_PE].brc_f_n++;
    }
    return;
    break;
  }
}

o_brc1(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    src1 = (insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l;
    src2 = insn.i3_32_5.r3;
    src3 = pe[T_PE].sr[STAR1].ful;
    return;
    break;
  case 'x':
    if(src3 & ((unsigned)0x80000000 >> src2)) {
      pe[T_PE].sr[PC].ful += (src1 << 3);
      if (src2) {
        if ((src1 << 3) & 0x80000000)
          pe[T_PE].brc_b_t++;
        else
          pe[T_PE].brc_f_t++;
      }
    }
    else {
      if ((src1 << 3) & 0x80000000)
        pe[T_PE].brc_b_n++;
      else
        pe[T_PE].brc_f_n++;
    }
    return;
    break;
  }
}

o_brnc0(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_star0_check_score(t_pe) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    src1 = (insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l;
    src2 = insn.i3_32_5.r3;
    src3 = pe[T_PE].sr[STAR0].ful;
    return;
    break;
  case 'x':
    if(!(src3 & ((unsigned)0x80000000 >> src2))) {
      pe[T_PE].sr[PC].ful += (src1 << 3);
      if (src2) {
        if ((src1 << 3) & 0x80000000)
          pe[T_PE].brc_b_t++;
        else
          pe[T_PE].brc_f_t++;
      }
    }
    else {
      if ((src1 << 3) & 0x80000000)
        pe[T_PE].brc_b_n++;
      else
        pe[T_PE].brc_f_n++;
    }
    return;
    break;
  }
}

o_brnc1(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    src1 = (insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l;
    src2 = insn.i3_32_5.r3;
    src3 = pe[T_PE].sr[STAR1].ful;
    return;
    break;
  case 'x':
    if(!(src3 & ((unsigned)0x80000000 >> src2))) {
      pe[T_PE].sr[PC].ful += (src1 << 3);
      if (src2) {
        if ((src1 << 3) & 0x80000000)
          pe[T_PE].brc_b_t++;
        else
          pe[T_PE].brc_f_t++;
      }
    }
    else {
      if ((src1 << 3) & 0x80000000)
        pe[T_PE].brc_b_n++;
      else
        pe[T_PE].brc_f_n++;
    }
    return;
    break;
  }
}

/********************************
*	call			*
* 'c'  return SCORE_FREE        *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_call(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1;
  unsigned tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i3_32_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    src1 = (insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l;
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i3_32_5.r3, _W_,tmp);
    return;
    break;
  case 'x':
    if (mx) {
      sys_gr_access(t_pe, insn.i3_32_5.r3, _O_,pe[T_PE].sr[PC].ful);
    }
    else {
      sys_gr_access(t_pe, insn.i3_32_5.r3, _W_,pe[T_PE].sr[PC].ful);
    }
    pe[T_PE].sr[PC].ful += (src1 << 3);
    return;
    break;
  }
}

/********************************
*	seti			*
* 'c'  return SCORE_FREE        *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_seti(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1;
  unsigned tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i3_32_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    src1 = (insn.i3_32_5.im_u << 7) | insn.i3_32_5.im_l;
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i3_32_5.r3, _W_,tmp);
    return;
    break;
  case 'x':
    if (mx) {
      sys_gr_access(t_pe, insn.i3_32_5.r3, _O_,src1);
    }
    else {
      sys_gr_access(t_pe, insn.i3_32_5.r3, _W_,src1);
    }
    return;
    break;
  }
}

/********************************
*	jmp			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_jmp(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_,src1);
    return;
    break;
  case 'x':
    pe[T_PE].sr[PC].ful = src1;
    return;
    break;
  }
}

/********************************
*	arithmetics		*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute (EXCEPTION)      *
********************************/

o_add(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ov;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2[mx]);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] + src2[mx];
    if (ov = (!(src1[mx]>>31)&&!(src2[mx]>>31)&& (dest>>31))
           ||( (src1[mx]>>31)&& (src2[mx]>>31)&&!(dest>>31))) {
      if (pe[T_PE].sr[PEV].pev.ivm)
        pe[T_PE].work_ird0.ivx = 1;
    }
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v = ov;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v = ov;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_addi5(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ov;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(insn.i5_5_5_5.r2 << 27) >> 27);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] + src2[mx];
    if (ov = (!(src1[mx]>>31)&&!(src2[mx]>>31)&& (dest>>31))
           ||( (src1[mx]>>31)&& (src2[mx]>>31)&&!(dest>>31))) {
      if (pe[T_PE].sr[PEV].pev.ivm)
        pe[T_PE].work_ird0.ivx = 1;
    }
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v = ov;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v = ov;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_addi25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ov;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] + src2[mx];
    if (ov = (!(src1[mx]>>31)&&!(src2[mx]>>31)&& (dest>>31))
           ||( (src1[mx]>>31)&& (src2[mx]>>31)&&!(dest>>31))) {
      if (pe[T_PE].sr[PEV].pev.ivm)
        pe[T_PE].work_ird0.ivx = 1;
    }
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v = ov;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v = ov;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_addl(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ul;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2[mx]);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] + src2[mx];
    ul =                ((src1[mx]>>31) && (src2[mx]>>31))
      ||(!(dest>>31) && ((src1[mx]>>31) || (src2[mx]>>31))); 
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_ul = ul;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_ul = ul;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_addli5(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ul;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(insn.i5_5_5_5.r2 << 27) >> 27);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] + src2[mx];
    ul =                ((src1[mx]>>31) && (src2[mx]>>31))
      ||(!(dest>>31) && ((src1[mx]>>31) || (src2[mx]>>31))); 
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_ul = ul;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_ul = ul;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_addli25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ul;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] + src2[mx];
    ul =                ((src1[mx]>>31) && (src2[mx]>>31))
      ||(!(dest>>31) && ((src1[mx]>>31) || (src2[mx]>>31))); 
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_ul = ul;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_ul = ul;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_sub(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ov;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2[mx]);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] - src2[mx];
    if (ov = (!(src1[mx]>>31)&& (src2[mx]>>31)&& (dest>>31))
           ||( (src1[mx]>>31)&&!(src2[mx]>>31)&&!(dest>>31))) {
      if (pe[T_PE].sr[PEV].pev.ivm)
        pe[T_PE].work_ird0.ivx = 1;
    }
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v = ov;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v = ov;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_subi5(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ov;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(insn.i5_5_5_5.r2 << 27) >> 27);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] - src2[mx];
    if (ov = (!(src1[mx]>>31)&& (src2[mx]>>31)&& (dest>>31))
           ||( (src1[mx]>>31)&&!(src2[mx]>>31)&&!(dest>>31))) {
      if (pe[T_PE].sr[PEV].pev.ivm)
        pe[T_PE].work_ird0.ivx = 1;
    }
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v = ov;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v = ov;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_subi25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        ov;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] - src2[mx];
    if (ov = (!(src1[mx]>>31)&& (src2[mx]>>31)&& (dest>>31))
           ||( (src1[mx]>>31)&&!(src2[mx]>>31)&&!(dest>>31))) {
      if (pe[T_PE].sr[PEV].pev.ivm)
        pe[T_PE].work_ird0.ivx = 1;
    }
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v = ov;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v = ov;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_subl(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2[mx]);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] - src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_subli5(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(insn.i5_5_5_5.r2 << 27) >> 27);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] - src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_subli25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] - src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccp_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l = (int) src1[mx] < (int) src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_le = ((int) src1[mx] < (int) src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_ul = src1[mx] < src2[mx];
      pe[T_PE].sr[STAR0].star0.iccs_ule = (src1[mx] < src2[mx]) || (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_and(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2[mx]);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] & src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_and25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] & src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_or(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2[mx]);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] | src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_or25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] | src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_n = (dest >> 31);
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_xor(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned	  z1, z2, z3, z4;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1[mx]);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2[mx]);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] ^ src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z   = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l   = z1 = (dest&0xff000000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_le  = z2 = (dest&0x00ff0000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_ul  = z3 = (dest&0x0000ff00) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_ule = z4 = (dest&0x000000ff) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_n   = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v   = z1 | z2 | z3 | z4;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z   = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l   = z1 = (dest&0xff000000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_le  = z2 = (dest&0x00ff0000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_ul  = z3 = (dest&0x0000ff00) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_ule = z4 = (dest&0x000000ff) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_n   = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v   = z1 | z2 | z3 | z4;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_xor25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1[2], src2[2];
  unsigned        dest;
  unsigned	  z1, z2, z3, z4;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1[mx]);
    src2[mx] = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1[mx] ^ src2[mx];
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    }
    switch (mx) {
    case 0:
      pe[T_PE].sr[STAR0].star0.iccp_z   = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccp_l   = z1 = (dest&0xff000000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_le  = z2 = (dest&0x00ff0000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_ul  = z3 = (dest&0x0000ff00) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_ule = z4 = (dest&0x000000ff) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccp_n   = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccp_v   = z1 | z2 | z3 | z4;
      break;
    case 1:
      pe[T_PE].sr[STAR0].star0.iccs_z   = (dest == 0);
      pe[T_PE].sr[STAR0].star0.iccs_l   = z1 = (dest&0xff000000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_le  = z2 = (dest&0x00ff0000) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_ul  = z3 = (dest&0x0000ff00) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_ule = z4 = (dest&0x000000ff) ? 0 : 1;
      pe[T_PE].sr[STAR0].star0.iccs_n   = (dest >> 31);
      pe[T_PE].sr[STAR0].star0.iccs_v   = z1 | z2 | z3 | z4;
      break;
    }
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_sll(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1 << (src2 & 0x1f);
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_sll5(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    src2 = insn.i5_5_5_5.r2;
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1 << src2;
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_sra(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static int src1, src2;
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1 >> (src2 & 0x1f);
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_sra5(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static int src1, src2;
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    src2 = insn.i5_5_5_5.r2;
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1 >> src2;
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_srl(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1 >> (src2 & 0x1f);
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

o_srl5(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest;
  unsigned        tmp;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    src2 = insn.i5_5_5_5.r2;
    return;
    break;
  case 'e':
    tmp = 0;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, tmp);
    return;
    break;
  case 'x':
    dest = src1 >> src2;
    if (mx) {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _O_, dest);
    }
    else {
      sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    }
    pe[T_PE].sr[STAR0].star0.iccp_z = (dest == 0);
    pe[T_PE].sr[STAR0].star0.iccp_n = (dest >> 31);
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}

/********************************
*	ld			*
* 'c'  check (EXCEPTION)        *
* 'r'  read                     *
* 'x'  EMPTY                    *
********************************/

o_ld(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x06;
    sys_gr_lock(t_pe, insn.i5_5_5_5.r3);
    return;
    break;
  }
}   

o_ld25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x06;
    sys_gr_lock(t_pe, insn.i5_5_25_5.r3);
    return;
    break;
  }
}
   
o_ld_c(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 1;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x02;
    sys_gr_lock(t_pe, insn.i5_5_5_5.r3);
    return;
    break;
  }
}   

o_ld_c25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 1;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x02;
    sys_gr_lock(t_pe, insn.i5_5_25_5.r3);
    return;
    break;
  }
}
   
o_ld_cu(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 1;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x03;
    sys_gr_lock(t_pe, insn.i5_5_5_5.r3);
    return;
    break;
  }
}   

o_ld_cu25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 1;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x03;
    sys_gr_lock(t_pe, insn.i5_5_25_5.r3);
    return;
    break;
  }
}
   
o_ld_d(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 8;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x09;
    sys_fr_lock(t_pe, insn.i5_5_5_5.r3);
    return;
    break;
  }
}   

o_ld_d25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_25_5.r3, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 8;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x09;
    sys_fr_lock(t_pe, insn.i5_5_25_5.r3);
    return;
    break;
  }
}
   
o_ld_f(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x08;
    sys_fr_lock(t_pe, insn.i5_5_5_5.r3);
    return;
    break;
  }
}   

o_ld_f25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_25_5.r3, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x08;
    sys_fr_lock(t_pe, insn.i5_5_25_5.r3);
    return;
    break;
  }
}
   
o_ld_l(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3  , _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3+1, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else  
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 8;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x07;
    sys_gr_lock(t_pe, insn.i5_5_5_5.r3);
    sys_gr_lock(t_pe, insn.i5_5_5_5.r3+1);
    return;
    break;
  }
}   

o_ld_l25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3  , _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3+1, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 8;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x07;
    sys_gr_lock(t_pe, insn.i5_5_25_5.r3);
    sys_gr_lock(t_pe, insn.i5_5_25_5.r3+1);
    return;
    break;
  }
}
   
o_ld_pd(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2  , _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3  , _W_, FQ_NUM) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3+1, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 16;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x0b;
    sys_fr_lock(t_pe, insn.i5_5_5_5.r3);
    sys_fr_lock(t_pe, insn.i5_5_5_5.r3+1);
    return;
    break;
  }
}   

o_ld_pd25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1  , _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_25_5.r3  , _W_, FQ_NUM) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_25_5.r3+1, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 16;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x0b;
    sys_fr_lock(t_pe, insn.i5_5_25_5.r3);
    sys_fr_lock(t_pe, insn.i5_5_25_5.r3+1);
    return;
    break;
  }
}

o_ld_pf(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2  , _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3  , _W_, FQ_NUM) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3+1, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 8;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x0a;
    sys_fr_lock(t_pe, insn.i5_5_5_5.r3);
    sys_fr_lock(t_pe, insn.i5_5_5_5.r3+1);
    return;
    break;
  }
}   

o_ld_pf25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1  , _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_25_5.r3  , _W_, FQ_NUM) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_25_5.r3+1, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 8;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x0a;
    sys_fr_lock(t_pe, insn.i5_5_25_5.r3);
    sys_fr_lock(t_pe, insn.i5_5_25_5.r3+1);
    return;
    break;
  }
}
   
o_ld_s(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 2;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x04;
    sys_gr_lock(t_pe, insn.i5_5_5_5.r3);
    return;
    break;
  }
}   

o_ld_s25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7); 
    pe[T_PE].ap_datq[0].len  = 2;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x04;
    sys_gr_lock(t_pe, insn.i5_5_25_5.r3);
    return;
    break;
  }
}
   
o_ld_su(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].len  = 2;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_5_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x05;
    sys_gr_lock(t_pe, insn.i5_5_5_5.r3);
    return;
    break;
  }
}

o_ld_su25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 2;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.i5_5_25_5.r3;
    pe[T_PE].ap_datq[0].mao  = 0x05;
    sys_gr_lock(t_pe, insn.i5_5_25_5.r3);
    return;
    break;
  }
}
   
/********************************
*	st			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  EMPTY                    *
********************************/

o_st(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _R_, src3);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x13;
    return;
    break;
  }
}   

o_st25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _R_, src3);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x13;
    return;
    break;
  }
}
   
o_st_c(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _R_, src3);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 1;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x11;
    return;
    break;
  }
}   

o_st_c25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _R_, src3);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 1;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x11;
    return;
    break;
  }
}
   
o_st_d(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2, src3, src4;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3, _R_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_fr_access(t_pe, insn.i5_5_5_5.r3, _R_, src3, src4);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].d[1] = src4;
    pe[T_PE].ap_datq[0].len  = 8;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x1d;
    return;
    break;
  }
}   

o_st_d25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src3, src4;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_25_5.r3, _R_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_fr_access(t_pe, insn.i5_5_25_5.r3, _R_, src3, src4);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].d[1] = src4;
    pe[T_PE].ap_datq[0].len  = 8;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x1d;
    return;
    break;
  }
}
   
o_st_f(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2, src3, src4;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3, _R_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_fr_access(t_pe, insn.i5_5_5_5.r3, _R_, src3, src4);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x1c;
    return;
    break;
  }
}   

o_st_f25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src3, src4;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_25_5.r3, _R_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_fr_access(t_pe, insn.i5_5_25_5.r3, _R_, src3, src4);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x1c;
    return;
    break;
  }
}
   
o_st_s(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src2, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _R_, src3);
    pe[T_PE].ap_datq[0].addr = src1 + src2;
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 2;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x12;
    return;
    break;
  }
}   

o_st_s25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _R_, src3);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 2;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x12;
    return;
    break;
  }
}
   
/********************************
*	mov			*
* 'c'  check (EXCEPTION)        *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_mov_if(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3, _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    src2 = 0;
    return;
    break;
  case 'x':
    sys_fr_access(t_pe, insn.i5_5_5_5.r3, _W_, src1, src2);
    return;
    break;
  }
}

o_mov_fi(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_fr_check_score(t_pe, insn.i5_5_5_5.r1, _R_, FQ_NUM) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_fr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1, src2);
    return;
    break;
  case 'x':
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, src1);
    return;
    break;
  }
}

o_mov_ld(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r1 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r1+1, _R_) == SCORE_FREE
     && sys_fr_check_score(t_pe, insn.i5_5_5_5.r3  , _W_, FQ_NUM) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r1+1, _R_, src2);
    return;
    break;
  case 'x':
    sys_fr_access(t_pe, insn.i5_5_5_5.r3, _W_, src1, src2);
    return;
    break;
  }
}

o_mov_dl(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_fr_check_score(t_pe, insn.i5_5_5_5.r1  , _R_, FQ_NUM) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3  , _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3+1, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_fr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1, src2);
    return;
    break;
  case 'x':
    sys_gr_access(t_pe, insn.i5_5_5_5.r3  , _W_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, src2);
    return;
    break;
  }
}

o_movgs(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.sys_mov.r2 < 512) {
      if (pe[T_PE].sr[PEV].pev.u) {
        pe[T_PE].work_ird0.pox = 1;
        return(SCORE_EXCEPTION);
      }
    }
    if (sys_gr_check_score(t_pe, insn.sys_mov.r1, _R_) != SCORE_FREE)
      return(SCORE_BUSY);
    else if (++pe[T_PE].ip_multiple_cycle <= IP_MOVGS_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    sys_gr_access(t_pe, insn.sys_mov.r1, _R_, src1); 
    return;
    break;
  case 'x':
    sys_sr_access(t_pe, insn.sys_mov.r2, _W_, &src1);
    return;
    break;
  }
}

o_movsg(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.sys_mov.r2 < 512) {
      if (pe[T_PE].sr[PEV].pev.u) {
        pe[T_PE].work_ird0.pox = 1;
        return(SCORE_EXCEPTION);
      }
    }
    if (sys_gr_check_score(t_pe, insn.sys_mov.r1, _W_) != SCORE_FREE)
      return(SCORE_BUSY);
    else if (++pe[T_PE].ip_multiple_cycle <= IP_MOVSG_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    sys_sr_access(t_pe, insn.sys_mov.r2, _R_, &src1);
    return;
    break;
  case 'x':
    sys_gr_access(t_pe, insn.sys_mov.r1, _W_, src1);
    return;
    break;
  }
}

o_movgt(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (insn.sys_mov.r1 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.sys_mov.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.sys_mov.r1+1, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.sys_mov.r1  , _R_, src1); 
    sys_gr_access(t_pe, insn.sys_mov.r1+1, _R_, src2); 
    return;
    break;
  case 'x':
    sys_tod_access(t_pe, _W_, src1, src2);
    return;
    break;
  }
}

o_movtg(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.sys_mov.r1 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.sys_mov.r1  , _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.sys_mov.r1+1, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_tod_access(t_pe, _R_, src1, src2);
    return;
    break;
  case 'x':
    sys_gr_access(t_pe, insn.sys_mov.r1  , _W_, src1);
    sys_gr_access(t_pe, insn.sys_mov.r1+1, _W_, src2);
    return;
    break;
  }
}

/********************************
*	mult			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_mult(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    dest = src1 * src2;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3, _W_, dest);
    return;
    break;
  }
}

o_mult_l(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest1, dest2;
  unsigned	  a, b, c, d, n;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3  , _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3+1, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    if ((src1 & 0x80000000) ^ (src2 & 0x80000000))
      n = 1;
    else
      n = 0;
    if (src1 & 0x80000000) src1 = -src1;
    if (src2 & 0x80000000) src2 = -src2;
    a = src1 >> 16; b = src1 & 0xffff;
    c = src2 >> 16; d = src2 & 0xffff;
    dest1 = a * c;
    dest2 = b * d;
    a *= d;
    b *= c;
    if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += a >> 16; dest2 += a << 16;
    if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += b >> 16; dest2 += b << 16;
    if (n) {
      dest1 = ~dest1; dest2 = ~dest2;
      if (((1+(dest2&0xffff))&0x10000) && ((1+(dest2>>16))&0x10000)) dest1++;
      dest2++;
    }
    sys_gr_access(t_pe, insn.i5_5_5_5.r3  , _W_, dest1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, dest2);
    return;
    break;
  }
}

o_mult_lu(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest1, dest2;
  unsigned	  a, b, c, d;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_5_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r2  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3  , _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_5_5.r3+1, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_5_5.r1, _R_, src1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r2, _R_, src2);
    return;
    break;
  case 'x':
    a = src1 >> 16; b = src1 &  0xffff;
    c = src2 >> 16; d = src2 &  0xffff;
    dest1 = a * c;
    dest2 = b * d;
    a *= d;
    b *= c;
    if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += a >> 16; dest2 += a << 16;
    if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += b >> 16; dest2 += b << 16;
    sys_gr_access(t_pe, insn.i5_5_5_5.r3  , _W_, dest1);
    sys_gr_access(t_pe, insn.i5_5_5_5.r3+1, _W_, dest2);
    return;
    break;
  }
}

o_mult25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    src2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'x':
    dest = src1 * src2;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3, _W_, dest);
    return;
    break;
  }
}

o_mult_l25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest1, dest2;
  unsigned	  a, b, c, d, n;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3  , _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3+1, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    src2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'x':
    if ((src1 & 0x80000000) ^ (src2 & 0x80000000))
      n = 1;
    else
      n = 0;
    if (src1 & 0x80000000) src1 = -src1;
    if (src2 & 0x80000000) src2 = -src2;
    a = src1 >> 16; b = src1 &  0xffff;
    c = src2 >> 16; d = src2 &  0xffff;
    dest1 = a * c;
    dest2 = b * d;
    a *= d;
    b *= c;
    if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += a >> 16; dest2 += a << 16;
    if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += b >> 16; dest2 += b << 16;
    if (n) {
      dest1 = ~dest1; dest2 = ~dest2;
      if (((1+(dest2&0xffff))&0x10000) && ((1+(dest2>>16))&0x10000)) dest1++;
      dest2++;
    }
    sys_gr_access(t_pe, insn.i5_5_25_5.r3  , _W_, dest1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3+1, _W_, dest2);
    return;
    break;
  }
}

o_mult_lu25(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned        dest1, dest2;
  unsigned	  a, b, c, d;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (insn.i5_5_25_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, insn.i5_5_25_5.r1  , _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3  , _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.i5_5_25_5.r3+1, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.i5_5_25_5.r1, _R_, src1);
    src2 = ((int)(((insn.i5_5_25_5.im_u << 7) | insn.i5_5_25_5.im_l) << 7) >> 7);
    return;
    break;
  case 'x':
    a = src1 >> 16; b = src1 &  0xffff;
    c = src2 >> 16; d = src2 &  0xffff;
    dest1 = a * c;
    dest2 = b * d;
    a *= d;
    b *= c;
    if (((a&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += a >> 16; dest2 += a << 16;
    if (((b&0xffff)+(dest2>>16))&0x10000) dest1++;
    dest1 += b >> 16; dest2 += b << 16;
    sys_gr_access(t_pe, insn.i5_5_25_5.r3  , _W_, dest1);
    sys_gr_access(t_pe, insn.i5_5_25_5.r3+1, _W_, dest2);
    return;
    break;
  }
}

/********************************
*	floating		*
* 'c'  check (EXCEPTION)        *
* 'r'  lock                     *
* 'x'  EMPTY                    *
********************************/

o_fnop(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fadd(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fadd_d(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fadd_x(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    insn.ful.insn_u = insn_u;
    insn.ful.insn_l = insn_l;
    if ((insn.i5_5_5_5.r1 & 1) || (insn.i5_5_5_5.r2 & 1)
     || (insn.i5_5_5_5.r3 & 1)) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}   

o_fsub(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fsub_d(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fsub_x(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    insn.ful.insn_u = insn_u;
    insn.ful.insn_l = insn_l;
    if ((insn.i5_5_5_5.r1 & 1) || (insn.i5_5_5_5.r2 & 1)
     || (insn.i5_5_5_5.r3 & 1)) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}   

o_fcmp(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  }
}

o_fcmp_d(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  }
}   

o_fcmp_x(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    insn.ful.insn_u = insn_u;
    insn.ful.insn_l = insn_l;
    if ((insn.i5_5_5_5.r1 & 1) || (insn.i5_5_5_5.r2 & 1)) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  }
}   

o_fmul(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fmul_d(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fdiv(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fdiv_d(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_df(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_di(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnz_di(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_dx(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    insn.ful.insn_u = insn_u;
    insn.ful.insn_l = insn_l;
    if (insn.i5_5_5_5.r3 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}   

o_fcnv_fd(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_fi(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnz_fi(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_id(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_if(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}

o_fcnv_xd(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;

  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.fstop) {
      pe[T_PE].work_ird0.fax = 1;
      return(SCORE_EXCEPTION);
    }
    insn.ful.insn_u = insn_u;
    insn.ful.insn_l = insn_l;
    if (insn.i5_5_5_5.r1 & 1) {
      pe[T_PE].work_ird0.spx = 1;
      return(SCORE_EXCEPTION);
    }
    else
      return(SCORE_FREE);
    break;
  }
}   

/********************************
*	system			*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  execute                  *
********************************/

o_aki(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
    break;
  }
}

o_flcha(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned	  ent;
  static unsigned src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) != SCORE_FREE)
      return(SCORE_BUSY);
    else if (++pe[T_PE].ip_multiple_cycle <= IP_FLCHA_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 6) & (CACHE_NUM-1);
    pe[T_PE].text_cache[ent].v = 0;
    pe[T_PE].data_cache[ent].v = 0;
    return;
    break;
  }
}   

o_flche(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned	  ent;
  static unsigned src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) != SCORE_FREE)  
      return(SCORE_BUSY);
    else if (++pe[T_PE].ip_multiple_cycle <= IP_FLCHE_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 6) & (CACHE_NUM-1);
    pe[T_PE].text_cache[ent].v = 0;
    pe[T_PE].data_cache[ent].v = 0;
    return;
    break;
  }
}   

o_ldsr(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) != SCORE_FREE)
      return(SCORE_BUSY);
    else if (++pe[T_PE].ip_multiple_cycle <= IP_LDSR_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)((insn.sys_25.im) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.sys_25.r3;
    pe[T_PE].ap_datq[0].mao  = 0x22;
    sys_sr_lock(t_pe);
    return;
    break;
  }
}   

o_stsr(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        src1, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_, src1);
    sys_sr_access(t_pe, insn.sys_25.r3, _R_, &src3);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)((insn.sys_25.im) << 7) >> 7);
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x23;
    return;
    break;
  }
}
	
o_ld_mcr(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
#ifdef MCR_AREA
  union insn_form insn;
  static unsigned src1;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u && !pe[T_PE].sr[PEV].pev.spu) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.sys_25.r3, _W_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_, src1);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)((insn.sys_25.im) << 7) >> 7);
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _R_;
    pe[T_PE].ap_datq[0].drn  = insn.sys_25.r3;
    pe[T_PE].ap_datq[0].mao  = 0x42; /* 0x42 for simulator convenience */
    sys_gr_lock(t_pe, insn.sys_25.r3);
    return;
    break;
  }
#else
  pe[T_PE].ap_datq[0].av = 0;
  return(SCORE_FREE);
#endif
}

o_st_mcr(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
#ifdef MCR_AREA
  union insn_form insn;
  unsigned        src1, src3;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u && !pe[T_PE].sr[PEV].pev.spu) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.sys_25.r3, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
  case 'r':
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_, src1);
    sys_gr_access(t_pe, insn.sys_25.r3, _R_, src3);
    pe[T_PE].ap_datq[0].addr = src1 + ((int)((insn.sys_25.im) << 7) >> 7);
    pe[T_PE].ap_datq[0].d[0] = src3;
    pe[T_PE].ap_datq[0].len  = 4;
    pe[T_PE].ap_datq[0].rw   = _W_;
    pe[T_PE].ap_datq[0].mao  = 0x43; /* 0x43 for simulator convenience */
    return;
    break;
  }
#else
  pe[T_PE].ap_datq[0].av = 0;
  return(SCORE_FREE);
#endif
}

o_wbst(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
#ifdef MCR_AREA
  union insn_form insn;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u && !pe[T_PE].sr[PEV].pev.spu) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    return(SCORE_FREE);
  case 'r':
    return;
    break;
  case 'x':
    if ((insn.sys_25.im & 1) == 0) {
      switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
      case 0:         break;
      case 1: case 3: pe[T_PE].mcr[BSTN0W].bstn0w.bstnl0 = insn.sys_25.im >> 17; break;
      case 2:         pe[T_PE].mcr[BSTN1W].bstn1w.bstnl1 = insn.sys_25.im >> 17; break;
      }
    }
    else {
      switch (pe[T_PE].mcr[BSDCMC].bsdcmc.ubsdmp) {
      case 0:         break;
      case 1: case 2: break;
      case 3:         pe[T_PE].mcr[BSTN1W].bstn1w.bstnl1 = insn.sys_25.im >> 17; break;
      }
    }
    return;
    break;
  }
#else
  return(SCORE_FREE);
#endif
}

o_ptlbe(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1;
  unsigned	  ent;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) != SCORE_FREE)  
      return(SCORE_BUSY);
    else if (++pe[T_PE].ip_multiple_cycle <= IP_PTLBE_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 15) & (TLB_NUM-1);
    pe[T_PE].text_tlb[ent].vmc &= ~4;
    pe[T_PE].data_tlb[ent].vmc &= ~4;
    return;
    break;
  }
}   

o_ptlbp(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned	  ent;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) != SCORE_FREE)
      return(SCORE_BUSY);
    else if (++pe[T_PE].ip_multiple_cycle <= IP_PTLBP_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    src2 = pe[T_PE].sr[PID].pid.pid;
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 15) & (TLB_NUM-1);
    if (!(pe[T_PE].text_tlb[ent].vmc & 1) && src2 == pe[T_PE].text_tlb[ent].pid)
      pe[T_PE].text_tlb[ent].vmc &= ~4;
    if (!(pe[T_PE].data_tlb[ent].vmc & 1) && src2 == pe[T_PE].data_tlb[ent].pid)
      pe[T_PE].data_tlb[ent].vmc &= ~4;
    return;
    break;
  }
}   

o_ptlba(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  static unsigned src1, src2;
  unsigned	  ent;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (sys_gr_check_score(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_) != SCORE_FREE)
      return(SCORE_BUSY);
    else if (++pe[T_PE].ip_multiple_cycle <= IP_PTLBA_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    sys_gr_access(t_pe, (insn.sys_25.r1_u << 2)+insn.sys_25.r1_l, _R_,src1);
    src2 = pe[T_PE].sr[PID].pid.pid;
    return;
    break;
  case 'x':
    ent = ((src1 + ((int)(insn.sys_25.im << 7) >> 7)) >> 15) & (TLB_NUM-1);
    if ((pe[T_PE].text_tlb[ent].vmc & 1) || src2 == pe[T_PE].text_tlb[ent].pid)
      pe[T_PE].text_tlb[ent].vmc &= ~4;
    if ((pe[T_PE].data_tlb[ent].vmc & 1) || src2 == pe[T_PE].data_tlb[ent].pid)
      pe[T_PE].data_tlb[ent].vmc &= ~4;
    return;
    break;
  }
}   

o_rti(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (pe[T_PE].sr[PEV].pev.u) {
      pe[T_PE].work_ird0.pox = 1;
      return(SCORE_EXCEPTION);
    }
    if (++pe[T_PE].ip_multiple_cycle <= IP_RTI_CYCLE)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].ip_multiple_cycle = 0;
    return;
    break;
  case 'x':
    pe[T_PE].sr[PC].ful  = pe[T_PE].sr[OPC].ful;
    pe[T_PE].sr[PEV].ful = pe[T_PE].sr[OPEV].ful;
    pe[T_PE].firmstate = 0;
    return;
    break;
  }
}   

o_svc(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    return;
    break;
  case 'x':
    pe[T_PE].svc_interrupt = insn.sys_svc.im | 0x80000000;
    return;
    break;
  }
}   

o_fwc(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    return(SCORE_FREE);
    break;
  case 'r':
    return;
    break;
  case 'x':
    switch (insn.ful.insn_u >> 8) {
    case 0xbf83ff:
      pe[T_PE].ip_status = STATUS_HALT;
      message("PE#%u reached to fwc (no sync). COMPLETION CODE=0x%08.8X\n", t_pe, insn.ful.insn_l);
      break;
    case 0xbf83d3:
      pe[T_PE].ip_status = STATUS_HALT;
      lmessage("PE#%u reached to fwc (no sync). MALFUNCTION CODE=0x%08.8X\n", t_pe, insn.ful.insn_l);
      break;
    default:
      pe[T_PE].fwc_interrupt = insn.sys_svc.im | 0x80000000;
      break;
    }
    return;
    break;
  }
}   

/********************************
*	cs			*
* 'c'  check                    *
* 'r'  read/execute             *
* 'x'  EMPTY                    *
********************************/

o_cs(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
  union insn_form insn;
  unsigned        mode, real_addr;
  unsigned        src1, src2, src3, addr, d;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;
  switch (cmd) {
  case 'c':
    if (!pe[T_PE].sr[STAR1].star1.asam
     && sys_gr_check_score(t_pe, insn.cs.r1, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.cs.r3, _R_) == SCORE_FREE
     && sys_gr_check_score(t_pe, insn.cs.r4, _W_) == SCORE_FREE
     && sys_gr_check_score(t_pe,(insn.cs.r2_u<<2)+insn.cs.r2_l, _R_) == SCORE_FREE)
      return(SCORE_FREE);
    else
      return(SCORE_BUSY);
    break;
  case 'r':
    sys_gr_access(t_pe, insn.cs.r1, _R_, src1);
    sys_gr_access(t_pe, insn.cs.r3, _R_, src3);
    sys_gr_access(t_pe,(insn.cs.r2_u<<2)+insn.cs.r2_l, _R_, src2);
    mode = pe[T_PE].sr[PEV].pev.va?'v':'r';
    addr = src2 + ((int)(insn.cs.im << 7) >> 7);
    if (sys_mem_access(t_pe,mode,addr,4,_R_,&d,0,0x31) != RW_SUCCESS) {
      pe[T_PE].ap_datq[0].av = 0;
      pe[T_PE].nullify = 1;
      return;
    }
    if (scan_on & SCAN_MEM) {
      scan_mfc(t_pe);
      message("         MEM(C) addr=0x%08.8X ", addr);
      append_symbol(t_pe, addr);
      get_mem_real_addr(t_pe, mode, _R_, addr, &real_addr, 'n');
      scan_mfc(t_pe);
      message("                real=0x%08.8X len=4  data=0x%08.8X\n", real_addr, d);
    }
    sys_gr_access(t_pe, insn.cs.r4, _W_, d);
    if (src1 == d) {
      pe[T_PE].sr[STAR0].star0.iccp_z = 1;
      /* synchronous operation 
      pe[T_PE].ap_datq[0].addr = addr;
      pe[T_PE].ap_datq[0].d[0] = src3;
      pe[T_PE].ap_datq[0].len  = 4;
      pe[T_PE].ap_datq[0].rw   = _A_;
      pe[T_PE].ap_datq[0].mao  = 0x31; */
      if (sys_mem_access(t_pe,mode,addr,4,_A_,&src3,0,0x31) != RW_SUCCESS) {
        pe[T_PE].ap_datq[0].av = 0;
        return;
      }
      if (scan_on & SCAN_MEM) {
        scan_mfc(t_pe);
        message("         MEM(S) addr=0x%08.8X ", addr);
        append_symbol(t_pe, addr);
        scan_mfc(t_pe);
        message("                real=0x%08.8X len=4  data=0x%08.8X\n", real_addr, d);
      }
    }
    else {
      pe[T_PE].sr[STAR0].star0.iccp_z = 0;
    }
    pe[T_PE].ap_datq[0].av = 0; /* synchronous operation */
    pe[T_PE].sr[STAR0].star0.oz = pe[T_PE].sr[STAR0].star0.iccp_z | pe[T_PE].sr[STAR0].star0.iccs_z;
    return;
    break;
  }
}   

/********************************
*	coprocessor		*
* 'c'  check                    *
* 'r'  read                     *
* 'x'  EMPTY                    *
********************************/

o_COP(t_pe, mx, insn_u, insn_l, cmd)
  unsigned t_pe, mx, insn_u, insn_l, cmd;
{
#ifdef VCP
  union insn_form insn;
  unsigned        src1;
  unsigned        r2, w1, w2, busy;

  insn.ful.insn_u = insn_u;
  insn.ful.insn_l = insn_l;

  if (insn.cop.u_id || (pe[T_PE].sr[PEV].pev.u && !pe[T_PE].sr[PEV].pev.cum0)) {
    pe[T_PE].work_ird0.cux = 1;
    return(SCORE_EXCEPTION);
  }

  switch (cmd) {
  case 'c':
    busy = 0;
    if (insn.cop.r_use & 8) {
      if (sys_gr_check_score(t_pe, insn.cop.r1, _R_) != SCORE_FREE)
        busy++;
    }
    if (insn.cop.r_use & 4) {
      r2 = ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f;
      if (insn.cop.r_type & 0x20) { /* case fr */
        if (sys_fr_check_score(t_pe, r2, _R_, FQ_NUM) != SCORE_FREE)
          busy++;
        if (insn.cop.r_type & 0x10) {
          /* if (r2 & 1) {
            pe[T_PE].work_ird0.spx = 1;
            return(SCORE_EXCEPTION);
          } */
          if (sys_fr_check_score(t_pe, r2|1, _R_, FQ_NUM) != SCORE_FREE)
            busy++;
        }
      }
      else { /* case gr */
        if (sys_gr_check_score(t_pe, r2, _R_) != SCORE_FREE)
          busy++;
        if (insn.cop.r_type & 0x10) {
          /* if (r2 & 1) {
            pe[T_PE].work_ird0.spx = 1;
            return(SCORE_EXCEPTION);
          } */
          if (sys_gr_check_score(t_pe, r2|1, _R_) != SCORE_FREE)
            busy++;
        }
      }
    }
    if (insn.cop.r_use & 2) {
      w1 =   insn.cop.R2 & 0x1f;
      if (insn.cop.r_type & 8) { /* case fr */
        if (sys_fr_check_score(t_pe, w1, _W_, FQ_NUM) != SCORE_FREE)
          busy++;
        if (insn.cop.r_type & 4) {
          /* if (w1 & 1) {
            pe[T_PE].work_ird0.spx = 1;
            return(SCORE_EXCEPTION);
          } */
          if (sys_fr_check_score(t_pe, w1|1, _W_, FQ_NUM) != SCORE_FREE)
            busy++;
        }
      }
      else { /* case gr */
        if (sys_gr_check_score(t_pe, w1, _W_) != SCORE_FREE)
          busy++;
        if (insn.cop.r_type & 4) {
          /* if (w1 & 1) {
            pe[T_PE].work_ird0.spx = 1;
            return(SCORE_EXCEPTION);
          } */
          if (sys_gr_check_score(t_pe, w1|1, _W_) != SCORE_FREE)
            busy++;
        }
      }
    }
    if (insn.cop.r_use & 1) {
      w2 =   insn.cop.R3 & 0x1f;
      if (insn.cop.r_type & 2) { /* case fr */
        if (sys_fr_check_score(t_pe, w2, _W_, FQ_NUM) != SCORE_FREE)
          busy++;
        if (insn.cop.r_type & 1) {
          /* if (w2 & 1) {
            pe[T_PE].work_ird0.spx = 1;
            return(SCORE_EXCEPTION);
          } */
          if (sys_fr_check_score(t_pe, w2|1, _W_, FQ_NUM) != SCORE_FREE)
            busy++;
        }
      }
      else { /* case gr */
        if (sys_gr_check_score(t_pe, w2, _W_) != SCORE_FREE)
          busy++;
        if (insn.cop.r_type & 1) {
          /* if (w2 & 1) {
            pe[T_PE].work_ird0.spx = 1;
            return(SCORE_EXCEPTION);
          } */
          if (sys_gr_check_score(t_pe, w2|1, _W_) != SCORE_FREE)
            busy++;
        }
      }
    }
    if (busy)
      return(SCORE_BUSY);
    else
      return(SCORE_FREE);
    break;
  case 'r':
    pe[T_PE].avn_opiq++;
    sys_gr_access(t_pe, insn.cop.r1, _R_, src1);
    pe[T_PE].vp_opiq[0].r_type = insn.cop.r_type;
    pe[T_PE].vp_opiq[0].r_use  = insn.cop.r_use;
    pe[T_PE].vp_opiq[0].r1     = src1;
    pe[T_PE].vp_opiq[0].u      = pe[T_PE].sr[PEV].pev.u;
    pe[T_PE].vp_opiq[0].op     = (insn.cop.op0 << 6) | (insn.cop.op1 << 4) | insn.cop.op2;
    pe[T_PE].vp_opiq[0].R1     = (insn.cop.R1_u << 2) + insn.cop.R1_l;
    pe[T_PE].vp_opiq[0].R2     = insn.cop.R2;
    pe[T_PE].vp_opiq[0].R4     = insn.cop.R4;
    pe[T_PE].vp_opiq[0].R3     = insn.cop.R3;

    if (insn.cop.r_use & 4) {
      r2 = ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f;
      if (insn.cop.r_type & 0x20) { /* case fr */
        sys_fr_lock(t_pe, r2);
        if (insn.cop.r_type & 0x10)
          sys_fr_lock(t_pe, r2|1);
      }  
      else { /* case gr */
        sys_gr_lock(t_pe, r2);
        if (insn.cop.r_type & 0x10) {
          sys_gr_lock(t_pe, r2|1);
        }
      }  
    }
    if (insn.cop.r_use & 2) {
      w1 =   insn.cop.R2 & 0x1f;
      if (insn.cop.r_type & 8) { /* case fr */
        sys_fr_lock(t_pe, w1);
        if (insn.cop.r_type & 4)
          sys_fr_lock(t_pe, w1|1);
      }
      else { /* case gr */
        sys_gr_lock(t_pe, w1);
        if (insn.cop.r_type & 4)
          sys_gr_lock(t_pe, w1|1);
      }
    }
    if (insn.cop.r_use & 1) {
      w2 =   insn.cop.R3 & 0x1f;
      if (insn.cop.r_type & 2) { /* case fr */
        sys_fr_lock(t_pe, w2);
        if (insn.cop.r_type & 1)
          sys_fr_lock(t_pe, w2|1);
      }
      else { /* case gr */
        sys_gr_lock(t_pe, w2);
        if (insn.cop.r_type & 1)
          sys_gr_lock(t_pe, w2|1);
      }
    }
    return;
    break;
  }
#else
  pe[T_PE].work_ird0.cux = 1;
  return(SCORE_EXCEPTION);
#endif
}

#ifdef VCP

COP_unlock(t_pe, r_type, r_use, R1, R2, R3, rw)
  unsigned t_pe, r_type, r_use, R1, R2, R3, rw;
  /* rw ... _R_ : read         */
  /* rw ... _W_ : write        */
  /* rw ... _A_ : read & write */
{
  unsigned r2, w1, w2, zero;

  if (rw & _R_) {
    if (r_use & 4) {
      r2 =   R1 & 0x1f;
      if (r_type & 0x20) { /* case fr */
        sys_fr_unlock(t_pe, r2);
        if (r_type & 0x10)
          sys_fr_unlock(t_pe, r2|1);
      }  
      else { /* case gr */
        sys_gr_unlock(t_pe, r2);
        if (r_type & 0x10) {
          sys_gr_unlock(t_pe, r2|1);
        }
      }  
    }
  }

  /* following statements are executed only */
  /* if exceptions are detected             */

  if (rw & _W_) {
    if (r_use & 2) {
      w1 =   R2 & 0x1f;
      if (r_type & 8) { /* case fr */
        sys_fr_exception(t_pe, w1);
        if (r_type & 4) {
          sys_fr_exception(t_pe, w1|1);
        }
      }
      else { /* case gr */
        sys_gr_unlock(t_pe, w1);
	zero = 0;
	sys_gr_access(t_pe, w1, _W_, zero);
        if (r_type & 4) {
          sys_gr_unlock(t_pe, w1|1);
        }
      }
    }
    if (r_use & 1) {
      w2 =   R3 & 0x1f;
      if (r_type & 2) { /* case fr */
        sys_fr_exception(t_pe, w2);
	zero = 0;
	sys_fr_access(t_pe, w2, _W_, zero, zero);
        if (r_type & 1) {
          sys_fr_exception(t_pe, w2|1);
        }
      }
      else { /* case gr */
        sys_gr_unlock(t_pe, w2);
	zero = 0;
	sys_gr_access(t_pe, w2, _W_, zero);
        if (r_type & 1) {
          sys_gr_unlock(t_pe, w2|1);
        }
      }
    }
  }
}

#endif

