static char SccsId[] = "@(#)userfunc.c	1.2    9/27/93";

/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/* userfunc.c    90/7/17 */

#define	_R_ 4
#define _W_ 2

/*									*/
/* Prepared functions are as follows.					*/
/*									*/
/* ---Functions---							*/
/*									*/
/*     cmd_gr_access(t_pe, num, _R_/_W_, *d)				*/
/*     cmd_fr_access(t_pe, num, _R_/_W_, *d1, *d2)			*/
/*     cmd_sr_access(t_pe, num, _R_/_W_, *d)				*/
/*     cmd_tod_access(t_pe, _R_/_W_, *d1, *d2)				*/
/*     cmd_mcr_access(t_pe, addr, len, _R_/_W_, *d)			*/
/*     cmd_mem_access(t_pe, 'v'/'r', addr, len, _R_/_W_, *d, 'y'/'n')	*/
/*     cmd_ext_interrupt(t_pe, level)					*/
/*									*/
/* ---Parameters---							*/
/*									*/
/*     unsigned t_pe;	: PE#						*/
/*     unsigned num;	: register number				*/
/*     unsigned addr;	: mcr/memory address				*/
/*              'v'	: virtual address				*/
/*              'r'	: real address					*/
/*     unsigned len;	: access length					*/
/*              _R_	: read access					*/
/*              _W_	: write access					*/
/*     unsigned *d;	: word						*/
/*     unsigned *d1;	: upper word					*/
/*     unsigned *d2;	: lower word					*/
/*              'y'	: ignore write protection (ste, pte, HSA)	*/
/*              'n'	: obey protection (ste, pte, HSA)		*/
/*     unsigned level;	: interrupt level (1-15)			*/
/*									*/
/* ---Return value---							*/
/*									*/
/*     0 : completed 							*/
/*     1 : illegal							*/
/*									*/

user_function(t_pe, p1, p2, p3, p4, p5, p6, p7)
    unsigned  t_pe, p1, p2, p3, p4, p5, p6, p7;
    /* return 1 if failed, 0 if succeeded */
{

    /* your codes here */

    /* sample */

    if (p1) {
      message("PE#%u: user_function called. p1=%d\n", t_pe, p1);
      return(1); /* failed */
    }
    else {
      message("PE#%u: user_function called. p1=%d\n", t_pe, p1);
      return(0); /* succeeded */
    }
}

