#include "stdio.h"
#include "ctype.h"
#include "tachyon.h"
#include "sim.h"
#include "extern.h"


imax3(x,y,z)
int   x,y,z;
{
  return MAX(x,MAX(y,z));
}

imax4(x,y,z,u)
int   x,y,z,u;
{
  return MAX(MAX(x,y),MAX(z,u));
}

imax2(x,y)
int   x,y;
{
  return MAX(x,y);
}

getoptype(itype)
int       itype;
{
  int      optype;

  switch (itype){
    case IK_IC:
    case IK_ICL:
    case IK_LC:
    case IK_LCL:
    case IK_SFT:
    case IK_BRC:
    case IK_BRCS:
    case IK_CALL:
    case IK_JMP:
    case IK_MULT:
    case IK_MULTL:
    case IK_MOV:
    case IK_MVLD:
    case IK_MVDL:
           optype=PIPE_I;
           break;
    case IK_LDG:
    case IK_LDGL:
    case IK_LDF:
    case IK_LDFL:
    case IK_STG:
    case IK_STGL:
    case IK_STF:
    case IK_STFL:
    case IK_SETI:
           optype=PIPE_LS;
           break;
    case IK_FA:
    case IK_FAX:
           optype=PIPE_FA;
           break;
    case IK_FM:
           optype=PIPE_FM;
           break;
    case IK_CS:
    case IK_VC:
           optype=PIPE_CS;
           break;
    default:
           printf(" ERROR AT MaKe time CHART. ITYPE=%d\n",itype);
           exit(1);
  }
  return(optype);
}

oprtnpos(k)
int	k;
{
  unsigned char	itype;

  if ((itype=possible_pos[k])>=0x80) return(0);
  else if (itype>=0x40) return(1);
  else return(2);
}
