#include  "stdio.h"
#include  "ctype.h"
#include  "string.h"
#include  "sim.h"
#include  "tachyon.h"
#include  "extern.h"

getterm()
{
  /* Global Variable:
       char line[]
       char term[]
       char *pos
  */
  int  kind,i,no;
  int  intf;
  
  for(;*pos ==' '||*pos == '\t';pos++);
  if (*pos == '\n' || *pos=='\0' || *pos==';' ) return(EOL);
  
#ifdef  DEBUG
    printf(" DEBUG: ENTER GETTERM POS=%s\n",pos);
#endif  
  if (isalpha(*pos)!=0 || (*pos)=='_' || *pos=='$' || *pos=='%') { 
/*  for(i=0;i<MAXL;term[i++]=' '); */
    for(i=0;isalnum(*pos)!=0 || *pos=='.' || *pos=='_' || *pos=='$' || *pos=='+' || *pos=='-' || *pos=='%';pos++,i++)
      term[i]= *pos;
    if(*pos =='<'){
      for(;*pos!='>' && *pos!='\n';pos++,i++)
        term[i]= *pos;
      if(*pos=='>') term[i++]= *pos++;
      else {
        printf(" INVALID ARRAY \n");
        exit(1);
      }
    }
    else if(*pos == ':'){
      return(LABEL); /* LABEL LINE */
    }
    term[i]='\0'; 
#ifdef  DEBUG
    printf(" DEBUG: WORK=%s\n",term);
#endif  
    if ((kind=symscan(term))>=INST_BEGIN && kind <= INST_END)
      return(kind);
    else {
      if((strncmp(term,"vut",3)==0)||(strncmp(term,"VUT",3)==0)){
        if((no=atoi(&(term[3])))>=0 && no<=VUTEG_END-VUTEG_BEGIN)
	  return(VUTEG_BEGIN+no);
      }
      else if((strncmp(term,"vr",2)==0)||(strncmp(term,"VR",2)==0)){
        if((no=atoi(&(term[2])))>=0 && no<=VREG_END-VREG_BEGIN)
	  return(VREG_BEGIN+no);
      } 
      else if((strncmp(term,"mr",2)==0)||(strncmp(term,"MR",2)==0)){
        if((no=atoi(&(term[2])))>=0 && no<=MREG_END-MREG_BEGIN)
	  return(MREG_BEGIN+no);
      }	
      else if((strncmp(term,"vcr",3)==0)||(strncmp(term,"VCR",3)==0)){
        if((no=atoi(&(term[3])))>=0 && no<=VCREG_END-VCREG_BEGIN)
	  return(VCREG_BEGIN+no);
      }
      else if((strncmp(term,"sr",2)==0)||(strncmp(term,"SR",2)==0)){
        if((no=atoi(&(term[2])))>=0 && no<=SREG_END-SREG_BEGIN)
	  return(SREG_BEGIN+no);
      }
      else if((strncmp(term,"fr",2)==0)||(strncmp(term,"FR",2)==0)){
        if((no=atoi(&(term[2])))>=0 && no<=FREG_END-FREG_BEGIN)
	  return(FREG_BEGIN+no);
      }
      else if((strncmp(term,"%fr",3)==0)){
        if((no=atoi(&(term[3])))>=0 && no<=FREG_END-FREG_BEGIN)
          return(FREG_BEGIN+no);
      }
      else if((strncmp(term,"gr",2)==0)||(strncmp(term,"GR",2)==0)){
        if ((no=atoi(&(term[2])))>=0 && no<=GREG_END-GREG_BEGIN)
	  return(GREG_BEGIN+no);
      }
      else if((strncmp(term,"%gr",3)==0)){
        if ((no=atoi(&(term[4])))>=0 && no<=GREG_END-GREG_BEGIN)
          return(GREG_BEGIN+no);
      }
      else if((strncmp(term,"true",4)==0)){
	  return(TRUE);
      }
      else if((strncmp(term,"%true",5)==0)){
          return(TRUE);
      }
      else  return(NAME); /* SYMBOL */
    }
  }
  else if (*pos == '='){ /* ADDRESS CONSTANT  */
    for(i=0;*pos!=',' && *pos!='\0' && *pos!='\n';pos++)
      term[i++]= *pos;
    return(NAME);
  }
  else if (isdigit(*pos)!=0 || *pos=='+' || *pos=='-') {
    intf=1;
    term[0]= *pos++;
    if (*pos == 'x' || *pos=='X'){
      term[1]= *pos++;
      for(i=2;isdigit(*pos)!=0 || *pos>='a' && *pos <='f' || *pos>='A' && *pos <='F';pos++,i++) term[i]= *pos;
      term[i]='\0';
      return(NUMBER);
    }
    for(i=1;isdigit(*pos)!=0 || *pos=='+' || *pos=='-';pos++,i++) term[i]= *pos;
    if(*pos=='.'){
      intf=0;
      term[i++]= *pos;
      for(pos++;isdigit(*pos)!=0;pos++,i++) term[i]= *pos; 
    }
    if(*pos=='e' || *pos=='E'){
      intf=0;
      term[i++]= *pos;
      pos++;
      if(*pos=='+' || *pos=='-') term[i++]= *pos++;
      for(;isdigit(*pos)!=0;pos++) term[i++]= *pos;
    }
    term[i]='\0';
    if (intf) symnumber = atoi(term); 
    else      symnumber = 0; 
    return(NUMBER);
  }
  else if(*pos=='('){
    strcpy(term,"(");
    pos++;
    return(LPAREN);
  }
  else if(*pos==')'){ 
    strcpy(term,")");
    pos++;
    return(RPAREN);
  }
  else if(*pos=='.'){
    strcpy(term,".");
    pos++;
    return(PERIOD);
  }
  else if(*pos=='#'){
    strcpy(term,"#");
    pos++;
    return(SHARP);
  }
  else if(*pos=='/'){
    strcpy(term,"/");
    pos++;
    return(SLASH);
  }
  else if(*pos==':'){
    strcpy(term,":");
    pos++;
    return(COLON);
  }
  else if(*pos==','){
    strcpy(term,",");
    pos++;
    return(COMMA);
  }
  else if(*pos=='&'){
    strcpy(term,"&");
    pos++;
    return(AMPERSAND);
  }
  else if(*pos==';'){
    strcpy(term,";");
    pos++;
    return(SEMICOLON);
  }
  else if(*pos=='*'){
    strcpy(term,"*");
    pos++;
    return(ASTERISC);
  }
  else if(*pos=='@'){
    strcpy(term,"@");
    pos++;
    return(TYPE);
  }
  else if(*pos=='!'){
    strcpy(term,"!");
    pos++;
    return(COMMENT);
  }
  else return(ILLEGAL);
}

atoi(c)
char *c;
{
  int i;

  for(i=0;isdigit(*c)!=0;i=10*i+ *c-'0',c++);
  return(i);
}

int symscan(word)
char   *word;
{
  INSTTBL *low=insttbl,
          *high = insttbl-1+sizeof(insttbl)/sizeof(insttbl[0]),
          *mid;
  int c,ret;
/*
#ifdef DEBUG
     printf("  SIZEOF(insttable)=%d\n",sizeof(insttbl)); 
     printf("  SIZEOF(insttable[0])=%d\n",sizeof(insttbl[0])); 
#endif
*/
  for(;low<=high;){
    mid = low+(high-low)/2;
/*
#ifdef DEBUG
    printf("DEBUG : word=%s\n",word);
    printf("DEBUG : mid =%s\n",mid->mnemonic);
    printf("DEBUG : mid Adress->%d\n",mid);
    printf("DEBUG : insttbl Adress->%d\n",insttbl);
    printf("DEBUG : sizeof (INSTTBL)->%d\n",sizeof(INSTTBL));
#endif
*/
    if((c=strcmp(mid->mnemonic,word))==0){
#ifdef DEBUG
      printf("DEBUG : mid Adress->%d\n",mid);
      printf("DEBUG : insttbl Adress->%d\n",insttbl);
      printf("DEBUG : sizeof (INSTTBL)->%d\n",sizeof(INSTTBL));
#endif
      return (((int)mid-(int)insttbl)/(int)sizeof(INSTTBL));
    }
    else if (c<0) low =mid+1;
    else          high=mid-1;
  }
  return (-1);
}
