/*  This is the instruction set define file */
INSTTBL  insttbl[]={
/*	      mnemonic size time kind num_of_oprd mem_bytes ( No.)  */
/* ---------------------------------------------------------------- */
		"add"    	,1, 1,IK_IC   ,3,  0,	/*   0	*/	
		"addi"   	,1, 1,IK_IC   ,3,  0,	/*   1	*/	
		"addi25" 	,2, 1,IK_ICL  ,3,  0,	/*   2	*/	
		"addi5"  	,1, 1,IK_IC   ,3,  0,	/*   3	*/	
		"addl"   	,1, 1,IK_IC   ,3,  0,	/*   4	*/	
		"addli25"	,2, 1,IK_ICL  ,3,  0,	/*   5	*/	
		"addli5" 	,1, 1,IK_IC   ,3,  0,	/*   6	*/	
		"aki"    	,3, 1,IK_CS   ,2,  0,	/*   7	*/	
		"and"    	,1, 1,IK_LC   ,3,  0,	/*   8	*/	
		"brc"    	,2, 1,IK_BRC  ,2,  0,	/*   9	*/	
		"brcs"   	,2, 1,IK_BRCS ,2,  0,	/*  10	*/	
		"brnc"   	,2, 1,IK_BRC  ,2,  0,	/*  11	*/	
		"brncs"  	,2, 1,IK_BRCS ,2,  0,	/*  12	*/	
		"call"   	,2, 2,IK_CALL ,2,  0,	/*  13	*/	
		"cs"     	,3, 1,IK_CS   ,5,  0,	/*  14	*/	
		"fadd"   	,1, 4,IK_FA   ,3,  0,	/*  15	*/	
		"fadd.d" 	,1, 4,IK_FA   ,3,  0,	/*  16	*/	
		"fadd.x" 	,1, 4,IK_FAX  ,3,  0,	/*  17	*/	
		"fcmp"   	,1, 4,IK_FA   ,3,  0,	/*  18	*/	
		"fcmp.d" 	,1, 4,IK_FA   ,3,  0,	/*  19	*/	
		"fcmp.x" 	,1, 4,IK_FAX  ,3,  0,	/*  20	*/	
		"fcnv.df"	,1, 4,IK_FAX  ,2,  0,	/*  21	*/	
		"fcnv.di"	,1, 4,IK_FAX  ,2,  0,	/*  22	*/	
		"fcnv.dx"	,1, 4,IK_FAX  ,2,  0,	/*  23	*/	
		"fcnv.fd"	,1, 4,IK_FAX  ,2,  0,	/*  24	*/	
		"fcnv.fi"	,1, 4,IK_FAX  ,2,  0,	/*  25	*/	
		"fcnv.id"	,1, 4,IK_FAX  ,2,  0,	/*  26	*/	
		"fcnv.if"	,1, 4,IK_FAX  ,2,  0,	/*  27	*/	
		"fcnv.xd"	,1, 4,IK_FAX  ,2,  0,	/*  28	*/	
		"fcnz.di"	,1, 4,IK_FAX  ,2,  0,	/*  29	*/	
		"fcnz.fi"	,1, 4,IK_FAX  ,2,  0,	/*  30	*/	
		"fcnz.xi"	,1, 4,IK_FAX  ,2,  0,	/*  31	*/	
		"fdiv"   	,1,26,IK_FM   ,3,  0,	/*  32	*/	
		"fdiv.d" 	,1,26,IK_FM   ,3,  0,	/*  33	*/	
		"flcha"  	,3, 1,IK_CS   ,2,  0,	/*  34	*/	
		"flche"  	,3, 1,IK_CS   ,2,  0,	/*  35	*/	
		"fmul"   	,1, 4,IK_FM   ,3,  0,	/*  36	*/	
		"fmul.d" 	,1, 4,IK_FM   ,3,  0,	/*  37	*/	
		"fsub"   	,1, 4,IK_FA   ,3,  0,	/*  38	*/	
		"fsub.d" 	,1, 4,IK_FA   ,3,  0,	/*  39	*/	
		"fsub.x" 	,1, 4,IK_FAX  ,3,  0,	/*  40	*/	
		"fwc"    	,3, 1,IK_CS   ,3,  0,	/*  41	*/	
		"jmp"    	,1, 8,IK_JMP  ,1,  0,	/*  42	*/	
		"ld"     	,1, 3,IK_LDG  ,3,  4,	/*  43	*/	
		"ld.c"   	,1, 3,IK_LDG  ,3,  1,	/*  44	*/	
		"ld.cu"  	,1, 3,IK_LDG  ,3,  1,	/*  45	*/	
		"ld.d"   	,1, 3,IK_LDF  ,3, 16,	/*  46	*/	
		"ld.f"   	,1, 3,IK_LDF  ,3,  8,	/*  47	*/	
		"ld.l"   	,1, 3,IK_LDG  ,3,  8,	/*  48	*/	
		"ld.mcr" 	,3, 1,IK_CS   ,2,  4,	/*  49	*/	
		"ld.pd"  	,1, 2,IK_LDF  ,3, 32,	/*  50	*/	
		"ld.pf"  	,1, 2,IK_LDF  ,3, 64,	/*  51	*/	
		"ld.s"   	,1, 2,IK_LDG  ,3,  2,	/*  52	*/	
		"ld.su"  	,1, 2,IK_LDG  ,3,  2,	/*  53	*/	
		"ldsr"   	,3, 1,IK_CS   ,2,  0,	/*  54	*/	
		"mov.dl" 	,1, 4,IK_MVDL ,2,  0,	/*  55	*/	
		"mov.fi" 	,1, 4,IK_MOV  ,2,  0,	/*  56	*/	
		"mov.if" 	,1, 3,IK_MOV  ,2,  0,	/*  57	*/	
		"mov.ld" 	,1, 3,IK_MVLD ,2,  0,	/*  58	*/	
		"movgs"  	,3, 2,IK_CS   ,2,  0,	/*  59	*/	
		"movgt"  	,3, 4,IK_CS   ,1,  0,	/*  60	*/	
		"movsg"  	,3, 5,IK_CS   ,2,  0,	/*  61	*/	
		"movtg"  	,3, 3,IK_CS   ,1,  0,	/*  62	*/	
		"mult"   	,1, 6,IK_MULT ,3,  0,	/*  63	*/	
		"mult.l" 	,1, 7,IK_MULT ,3,  0,	/*  64	*/	
		"mult.lu"	,1, 7,IK_MULT ,3,  0,	/*  65	*/	
		"nop"    	,1, 0,IK_NON  ,0,  0,	/*  66	*/	
		"or"     	,1, 1,IK_LC   ,3,  0,	/*  67	*/	
		"ptlba"  	,3, 1,IK_CS   ,2,  0,	/*  68	*/	
		"ptlbe"  	,3, 1,IK_CS   ,2,  0,	/*  69	*/	
		"ptlbp"  	,3, 1,IK_CS   ,2,  0,	/*  70	*/	
		"rti"    	,3, 2,IK_CS   ,0,  0,	/*  71	*/	
		"seti"   	,2, 1,IK_SETI ,2,  4,	/*  72	*/	
		"sll"    	,1, 1,IK_SFT  ,3,  0,	/*  73	*/	
		"sra"    	,1, 1,IK_SFT  ,3,  0,	/*  74	*/	
		"srl"    	,1, 1,IK_SFT  ,3,  0,	/*  75	*/	
		"st"     	,1, 1,IK_STG  ,3,  4,	/*  76	*/	
		"st.c"   	,1, 1,IK_STG  ,3,  1,	/*  77	*/	
		"st.d"   	,1, 1,IK_STF  ,3, 16,	/*  78	*/	
		"st.f"   	,1, 1,IK_STF  ,3,  8,	/*  79	*/	
		"st.mcr" 	,3, 1,IK_CS   ,2,  2,	/*  80	*/	
		"st.s"   	,1, 1,IK_STG  ,3,  0,	/*  81	*/	
		"stsr"   	,3, 2,IK_CS   ,2,  4,	/*  82	*/	
		"sub"    	,1, 1,IK_IC   ,3,  0,	/*  83	*/	
		"subi"   	,1, 1,IK_IC   ,3,  0,	/*  84	*/	
		"subi25" 	,2, 1,IK_ICL  ,3,  0,	/*  85	*/	
		"subi5"  	,1, 1,IK_IC   ,3,  0,	/*  86	*/	
		"subl"   	,1, 1,IK_IC   ,3,  0,	/*  87	*/	
		"subli25"	,2, 1,IK_ICL  ,3,  0,	/*  88	*/	
		"subli5" 	,1, 1,IK_IC   ,3,  0,	/*  89	*/	
		"svc"    	,3, 1,IK_CS   ,2,  0,	/*  90	*/	
		"va"	 	,3, 4,IK_VC   ,4,  8,	/*  91	*/	
		"vad"	 	,3, 4,IK_VC   ,4,  8,	/*  92	*/	
		"vae"	 	,3, 4,IK_VC   ,4,  8,	/*  93	*/	
		"vas"	 	,3, 4,IK_VC   ,4,  8,	/*  94	*/	
		"vasd"	 	,3, 4,IK_VC   ,4,  8,	/*  95	*/	
		"vase"	 	,3, 4,IK_VC   ,4,  8,	/*  96	*/	
		"vce"	 	,3, 4,IK_VC   ,4,  8,	/*  97	*/	
		"vced"	 	,3, 4,IK_VC   ,4,  8,	/*  98	*/	
		"vcee"	 	,3, 4,IK_VC   ,4,  8,	/*  99	*/	
		"vcf"	 	,3, 4,IK_VC   ,4,  8,	/* 100	*/	
		"vcfd"	 	,3, 4,IK_VC   ,4,  8,	/* 101	*/	
		"vcfe"	 	,3, 4,IK_VC   ,4,  8,	/* 102	*/	
		"vch"	 	,3, 4,IK_VC   ,4,  8,	/* 103	*/	
		"vchd"	 	,3, 4,IK_VC   ,4,  8,	/* 104	*/	
		"vche"	 	,3, 4,IK_VC   ,4,  8,	/* 105	*/	
		"vcl"	 	,3, 4,IK_VC   ,4,  8,	/* 106	*/	
		"vcld"	 	,3, 4,IK_VC   ,4,  8,	/* 107	*/	
		"vcle"	 	,3, 4,IK_VC   ,4,  8,	/* 108	*/	
		"vcne"	 	,3, 4,IK_VC   ,4,  8,	/* 109	*/	
		"vcned"	 	,3, 4,IK_VC   ,4,  8,	/* 110	*/	
		"vcnee"	 	,3, 4,IK_VC   ,4,  8,	/* 111	*/	
		"vcnh"	 	,3, 4,IK_VC   ,4,  8,	/* 112	*/	
		"vcnhd"	 	,3, 4,IK_VC   ,4,  8,	/* 113	*/	
		"vcnhe"	 	,3, 4,IK_VC   ,4,  8,	/* 114	*/	
		"vcnl"	 	,3, 4,IK_VC   ,4,  8,	/* 115	*/	
		"vcnld"	 	,3, 4,IK_VC   ,4,  8,	/* 116	*/	
		"vcnle"	 	,3, 4,IK_VC   ,4,  8,	/* 117	*/	
		"vcse"	 	,3, 4,IK_VC   ,4,  8,	/* 118	*/	
		"vcsed"	 	,3, 4,IK_VC   ,4,  8,	/* 119	*/	
		"vcsee"	 	,3, 4,IK_VC   ,4,  8,	/* 120	*/	
		"vcsf"	 	,3, 4,IK_VC   ,4,  8,	/* 121	*/	
		"vcsfd"	 	,3, 4,IK_VC   ,4,  8,	/* 122	*/	
		"vcsfe"	 	,3, 4,IK_VC   ,4,  8,	/* 123	*/	
		"vcsh"	 	,3, 4,IK_VC   ,4,  8,	/* 124	*/	
		"vcshd"	 	,3, 4,IK_VC   ,4,  8,	/* 125	*/	
		"vcshe"	 	,3, 4,IK_VC   ,4,  8,	/* 126	*/	
		"vcsl"	 	,3, 4,IK_VC   ,4,  8,	/* 127	*/	
		"vcsld"	 	,3, 4,IK_VC   ,4,  8,	/* 128	*/	
		"vcsle"	 	,3, 4,IK_VC   ,4,  8,	/* 129	*/	
		"vcsne"	 	,3, 4,IK_VC   ,4,  8,	/* 130	*/	
		"vcsned" 	,3, 4,IK_VC   ,4,  8,	/* 131	*/	
		"vcsnee" 	,3, 4,IK_VC   ,4,  8,	/* 132	*/	
		"vcsnh"	 	,3, 4,IK_VC   ,4,  8,	/* 133	*/	
		"vcsnhd" 	,3, 4,IK_VC   ,4,  8,	/* 134	*/	
		"vcsnhe" 	,3, 4,IK_VC   ,4,  8,	/* 135	*/	
		"vcsnl"	 	,3, 4,IK_VC   ,4,  8,	/* 136	*/	
		"vcsnld" 	,3, 4,IK_VC   ,4,  8,	/* 137	*/	
		"vcsnle" 	,3, 4,IK_VC   ,4,  8,	/* 138	*/	
		"vcst"	 	,3, 4,IK_VC   ,4,  8,	/* 139	*/	
		"vcstd"	 	,3, 4,IK_VC   ,4,  8,	/* 140	*/	
		"vcste"	 	,3, 4,IK_VC   ,4,  8,	/* 141	*/	
		"vct"	 	,3, 4,IK_VC   ,4,  8,	/* 142	*/	
		"vctd"	 	,3, 4,IK_VC   ,4,  8,	/* 143	*/	
		"vcte"	 	,3, 4,IK_VC   ,4,  8,	/* 144	*/	
		"vdd"	 	,3, 4,IK_VC   ,4,  8,	/* 145	*/	
		"vde"	 	,3, 4,IK_VC   ,4,  8,	/* 146	*/	
		"vdsd"	 	,3, 4,IK_VC   ,4,  8,	/* 147	*/	
		"vdse"	 	,3, 4,IK_VC   ,4,  8,	/* 148	*/	
		"vesll"	 	,3, 4,IK_VC   ,4,  8,	/* 149	*/	
		"vfm"	 	,3, 4,IK_VC   ,3,  8,	/* 150	*/	
		"vfmx"	 	,3, 4,IK_VC   ,3,  8,	/* 151	*/	
		"vfn"	 	,3, 4,IK_VC   ,4,  8,	/* 152	*/	
		"vfnd"	 	,3, 4,IK_VC   ,4,  8,	/* 153	*/	
		"vfndx"	 	,3, 4,IK_VC   ,4,  8,	/* 154	*/	
		"vfne"	 	,3, 4,IK_VC   ,4,  8,	/* 155	*/	
		"vfnex"	 	,3, 4,IK_VC   ,4,  8,	/* 156	*/	
		"vfnx"	 	,3, 4,IK_VC   ,4,  8,	/* 157	*/	
		"vfx"	 	,3, 4,IK_VC   ,4,  8,	/* 158	*/	
		"vfxd"	 	,3, 4,IK_VC   ,4,  8,	/* 159	*/	
		"vfxdx"	 	,3, 4,IK_VC   ,4,  8,	/* 160	*/	
		"vfxe"	 	,3, 4,IK_VC   ,4,  8,	/* 161	*/	
		"vfxex"	 	,3, 4,IK_VC   ,4,  8,	/* 162	*/	
		"vfxx"	 	,3, 4,IK_VC   ,4,  8,	/* 163	*/	
		"vgm"	 	,3, 4,IK_VC   ,3,  8,	/* 164	*/	
		"vgs"	 	,3, 4,IK_VC   ,3,  8,	/* 165	*/	
		"vil"	 	,3, 4,IK_VC   ,4,  8,	/* 166	*/	
		"vild"	 	,3, 4,IK_VC   ,4,  8,	/* 167	*/	
		"vile"	 	,3, 4,IK_VC   ,4,  8,	/* 168	*/	
		"vist"	 	,3, 4,IK_VC   ,4,  8,	/* 169	*/	
		"vistd"	 	,3, 4,IK_VC   ,4,  8,	/* 170	*/	
		"viste"	 	,3, 4,IK_VC   ,4,  8,	/* 171	*/	
		"vl"	 	,3, 4,IK_VC   ,4,  8,	/* 172	*/	
		"vla"	 	,3, 4,IK_VC   ,4,  8,	/* 173	*/	
		"vlb"	 	,3, 4,IK_VC   ,4,  8,	/* 174	*/	
		"vlcp"	 	,3, 4,IK_VC   ,4,  8,	/* 175	*/	
		"vlcpa"	 	,3, 4,IK_VC   ,4,  8,	/* 176	*/	
		"vlcpb"	 	,3, 4,IK_VC   ,4,  8,	/* 177	*/	
		"vlcpd"	 	,3, 4,IK_VC   ,4,  8,	/* 178	*/	
		"vlcpda" 	,3, 4,IK_VC   ,4,  8,	/* 179	*/	
		"vlcpdb" 	,3, 4,IK_VC   ,4,  8,	/* 180	*/	
		"vlcpe"	 	,3, 4,IK_VC   ,4,  8,	/* 181	*/	
		"vlcpea" 	,3, 4,IK_VC   ,4,  8,	/* 182	*/	
		"vlcpeb" 	,3, 4,IK_VC   ,4,  8,	/* 183	*/	
		"vlcr"	 	,3, 4,IK_VC   ,2,  8,	/* 184	*/	
		"vld"	 	,3, 4,IK_VC   ,4,  8,	/* 185	*/	
		"vlda"	 	,3, 4,IK_VC   ,4,  8,	/* 186	*/	
		"vldb"	 	,3, 4,IK_VC   ,4,  8,	/* 187	*/	
		"vle"	 	,3, 4,IK_VC   ,4,  8,	/* 188	*/	
		"vlea"	 	,3, 4,IK_VC   ,4,  8,	/* 189	*/	
		"vleb"	 	,3, 4,IK_VC   ,4,  8,	/* 190	*/	
		"vlm"	 	,3, 4,IK_VC   ,4,  8,	/* 191	*/	
		"vlma"	 	,3, 4,IK_VC   ,4,  8,	/* 192	*/	
		"vlmb"	 	,3, 4,IK_VC   ,4,  8,	/* 193	*/	
		"vlp"	 	,3, 4,IK_VC   ,3,  8,	/* 194	*/	
		"vlpd"	 	,3, 4,IK_VC   ,3,  8,	/* 195	*/	
		"vlpe"	 	,3, 4,IK_VC   ,3,  8,	/* 196	*/	
		"vls"	 	,3, 4,IK_VC   ,3,  8,	/* 197	*/	
		"vlsd"	 	,3, 4,IK_VC   ,3,  8,	/* 198	*/	
		"vlse"	 	,3, 4,IK_VC   ,3,  8,	/* 199	*/	
		"vltr"	 	,3, 4,IK_VC   ,1,  8,	/* 200	*/	
		"vlvl"	 	,3, 4,IK_VC   ,1,  8,	/* 201	*/	
		"vlvlf"	 	,3, 4,IK_VC   ,1,  8,	/* 202	*/	
		"vlvt"	 	,3, 4,IK_VC   ,2,  8,	/* 203	*/	
		"vm"	 	,3, 4,IK_VC   ,4,  8,	/* 204	*/	
		"vmd"	 	,3, 4,IK_VC   ,4,  8,	/* 205	*/	
		"vme"	 	,3, 4,IK_VC   ,4,  8,	/* 206	*/	
		"vms"	 	,3, 4,IK_VC   ,4,  8,	/* 207	*/	
		"vmsd"	 	,3, 4,IK_VC   ,4,  8,	/* 208	*/	
		"vmse"	 	,3, 4,IK_VC   ,4,  8,	/* 209	*/	
		"vn"	 	,3, 4,IK_VC   ,4,  8,	/* 210	*/	
		"vnm"	 	,3, 4,IK_VC   ,4,  8,	/* 211	*/	
		"vns"	 	,3, 4,IK_VC   ,4,  8,	/* 212	*/	
		"vo"	 	,3, 4,IK_VC   ,4,  8,	/* 213	*/	
		"vom"	 	,3, 4,IK_VC   ,4,  8,	/* 214	*/	
		"vos"	 	,3, 4,IK_VC   ,4,  8,	/* 215	*/	
		"vplcr"	 	,3, 4,IK_VC   ,2,  8,	/* 216	*/	
		"vpscr"	 	,3, 4,IK_VC   ,2,  8,	/* 217	*/	
		"vpt"	 	,3, 4,IK_VC   ,0,  8,	/* 218	*/	
		"vs"	 	,3, 4,IK_VC   ,4,  8,	/* 219	*/	
		"vscr"	 	,3, 4,IK_VC   ,2,  8,	/* 220	*/	
		"vsd"	 	,3, 4,IK_VC   ,4,  8,	/* 221	*/	
		"vse"	 	,3, 4,IK_VC   ,4,  8,	/* 222	*/	
		"vsll"	 	,3, 4,IK_VC   ,4,  8,	/* 223	*/	
		"vsm"	 	,3, 4,IK_VC   ,3,  8,	/* 224	*/	
		"vsmd"	 	,3, 4,IK_VC   ,3,  8,	/* 225	*/	
		"vsme"	 	,3, 4,IK_VC   ,3,  8,	/* 226	*/	
		"vsmm"	 	,3, 4,IK_VC   ,3,  8,	/* 227	*/	
		"vsrl"	 	,3, 4,IK_VC   ,4,  8,	/* 228	*/	
		"vss"	 	,3, 4,IK_VC   ,4,  8,	/* 229	*/	
		"vssd"	 	,3, 4,IK_VC   ,4,  8,	/* 230	*/	
		"vsse"	 	,3, 4,IK_VC   ,4,  8,	/* 231	*/	
		"vst"	 	,3, 4,IK_VC   ,4,  8,	/* 232	*/	
		"vsta"	 	,3, 4,IK_VC   ,4,  8,	/* 233	*/	
		"vstb"	 	,3, 4,IK_VC   ,4,  8,	/* 234	*/	
		"vstd"	 	,3, 4,IK_VC   ,4,  8,	/* 235	*/	
		"vstda"	 	,3, 4,IK_VC   ,4,  8,	/* 236	*/	
		"vstdb"	 	,3, 4,IK_VC   ,4,  8,	/* 237	*/	
		"vste"	 	,3, 4,IK_VC   ,4,  8,	/* 238	*/	
		"vstea"	 	,3, 4,IK_VC   ,4,  8,	/* 239	*/	
		"vsteb"	 	,3, 4,IK_VC   ,4,  8,	/* 240	*/	
		"vstm"	 	,3, 4,IK_VC   ,3,  8,	/* 241	*/	
		"vstma"	 	,3, 4,IK_VC   ,3,  8,	/* 242	*/	
		"vstmb"	 	,3, 4,IK_VC   ,3,  8,	/* 243	*/	
		"vstx"	 	,3, 4,IK_VC   ,4,  8,	/* 244	*/	
		"vstxa"	 	,3, 4,IK_VC   ,4,  8,	/* 245	*/	
		"vstxb"	 	,3, 4,IK_VC   ,4,  8,	/* 246	*/	
		"vstxd"	 	,3, 4,IK_VC   ,4,  8,	/* 247	*/	
		"vstxda" 	,3, 4,IK_VC   ,4,  8,	/* 248	*/	
		"vstxdb" 	,3, 4,IK_VC   ,4,  8,	/* 249	*/	
		"vstxe"	 	,3, 4,IK_VC   ,4,  8,	/* 250	*/	
		"vstxea" 	,3, 4,IK_VC   ,4,  8,	/* 251	*/	
		"vstxeb" 	,3, 4,IK_VC   ,4,  8,	/* 252	*/	
		"vsvt"	 	,3, 4,IK_VC   ,2,  8,	/* 253	*/	
		"vtm"	 	,3, 4,IK_VC   ,3,  8,	/* 254	*/	
		"vts"	 	,3, 4,IK_VC   ,3,  8,	/* 255	*/	
		"vtsd"	 	,3, 4,IK_VC   ,3,  8,	/* 256	*/	
		"vtse"	 	,3, 4,IK_VC   ,3,  8,	/* 257	*/	
		"vvde"	 	,3, 4,IK_VC   ,3,  8,	/* 258	*/	
		"vvdi"	 	,3, 4,IK_VC   ,3,  8,	/* 259	*/	
		"vved"	 	,3, 4,IK_VC   ,3,  8,	/* 260	*/	
		"vvei"	 	,3, 4,IK_VC   ,3,  8,	/* 261	*/	
		"vvid"	 	,3, 4,IK_VC   ,3,  8,	/* 262	*/	
		"vvie"	 	,3, 4,IK_VC   ,3,  8,	/* 263	*/	
		"vx"	 	,3, 4,IK_VC   ,4,  8,	/* 264	*/	
		"vxm"	 	,3, 4,IK_VC   ,4,  8,	/* 265	*/	
		"vxs"	 	,3, 4,IK_VC   ,3,  8,	/* 266	*/	
		"wbst"	 	,3, 6,IK_CS   ,1,  0,	/* 267	*/	
		"xor"	 	,1, 1,IK_LC   ,3,  0,	/* 268	*/	
             }; 

         
unsigned char possible_pos[]={
/*   NON  */   0xe0,
/*   LDG  */   0xc0,
/*   LDGL */   0x40,
/*   LDF  */   0xc0,
/*   LDFL */   0x40,
/*   STG  */   0xc0,
/*   STGL */   0x40,
/*   STF  */   0xc0,
/*   STFL */   0x40,
/*   SETI */   0x40,
/*   IC   */   0xc0,
/*   ICL  */   0x40,
/*   LC   */   0xc0,
/*   LCL  */   0x40,
/*   MULT */   0xc0,
/*   MULTL*/   0x40,
/*   CALL */   0x40,
/*   JMP  */   0xc0,
/*   BRC  */   0x40,
/*   BRCS */   0x40,
/*   SFT  */   0x80,
/*   FA   */   0xe0,
/*   FAX  */   0xe0,
/*   FM   */   0xe0,
/*   MOV  */   0x80,
/*   MVLD */   0x80,
/*   MVDL */   0x80,
/*   CS   */   0xe0,
/*   VC   */   0xe0,
};

int  is_c12[29][29]={
/*    \    | N L L L L S S S S S I I L L M M C J B B S F F F M M M C V  */
/*     \ 2 | O D D D D T T T T E C C C C U U A M R R F A A M O V V S C  */
/*      \  | N G G F F G G F F T   L   L L L L P C C T   X   V L D      */
/*    1  \ |     L   L   L   L I         T T L     S           D L      */
/*        \|                               L                            */
/*   ------+------------------------------------------------------------*/
/*   NON  */ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,
/*   LDG  */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,1,0,1,1,0,1,1,1,0,0,0,0,0,
/*   LDGL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   LDF  */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,1,0,1,1,0,0,0,0,0,0,0,0,0,
/*   LDFL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   STG  */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,1,0,1,1,0,1,1,1,0,0,0,0,0,
/*   STGL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   STF  */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,1,0,1,1,0,0,0,0,0,0,0,0,0,
/*   STFL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   SETI */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   IC   */ 1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,
/*   ICL  */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   LC   */ 1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,
/*   LCL  */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   MULT */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,1,0,1,1,0,1,1,1,0,0,0,0,0,
/*   MULTL*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   CALL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   JMP  */ 1,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,
/*   BRC  */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   BRCS */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   SFT  */ 1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,
/*   FA   */ 1,0,1,0,0,0,1,0,0,1,0,0,0,1,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,
/*   FAX  */ 1,0,1,0,0,0,1,0,0,1,0,0,0,1,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,
/*   FM   */ 1,0,1,0,0,0,1,0,0,1,0,1,0,1,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,
/*   MOV  */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,1,0,1,1,0,1,1,1,0,0,0,0,0,
/*   MVLD */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,1,0,1,1,0,1,1,1,0,0,0,0,0,
/*   MVDL */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,1,0,1,1,0,1,1,1,0,0,0,0,0,
/*   CS   */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   VC   */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
             };

int  is_c23[29][29]={
/*    \    | N L L L L S S S S S I I L L M M C J B B S F F F M M M C V  */  
/*     \ 3 | O D D D D T T T T E C C C C U U A M R R F A A M O V V S C  */  
/*      \  | N G G F F G G F F T   L   L L L L P C C T   X   V L D      */  
/*    2  \ |     L   L   L   L I         T T L     S           D L      */  
/*        \|                               L                            */  
/*   ------+------------------------------------------------------------*/  
/*   NON  */ 1,1,0,1,0,1,0,1,0,0,1,0,1,0,1,0,1,0,1,1,0,1,1,1,1,1,1,0,0,   
/*   LDG  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   LDGL */ 1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   LDF  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   LDFL */ 1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   STG  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   STGL */ 1,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   STF  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   STFL */ 1,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   SETI */ 1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   IC   */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   ICL  */ 1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   LC   */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   LCL  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   MULT */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   MULTL*/ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   CALL */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   JMP  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   BRC  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,   
/*   BRCS */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,   
/*   SFT  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   FA   */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   FAX  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   FM   */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   MOV  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   MVLD */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   MVDL */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   CS   */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   VC   */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
            };                                      

int  is_c13[29][29]={
/*    \    | N L L L L S S S S S I I L L M M C J B B S F F F M M M C V  */  
/*     \ 3 | O D D D D T T T T E C C C C U U A M R R F A A M O V V S C  */  
/*      \  | N G G F F G G F F T   L   L L L L P C C T   X   V L D      */  
/*    1  \ |     L   L   L   L I         T T L     S           D L      */  
/*        \|                               L                            */  
/*   ------+------------------------------------------------------------*/  
/*   NON  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   LDG  */ 1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   LDGL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   LDF  */ 1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   LDFL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   STG  */ 1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   STGL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   STF  */ 1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   STFL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
/*   SETI */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   IC   */ 1,0,1,0,1,0,1,0,1,1,0,0,0,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   ICL  */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   LC   */ 1,0,1,0,1,0,1,0,1,1,0,0,0,0,0,1,1,0,1,1,0,1,1,1,0,0,0,0,0,   
/*   LCL  */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   MULT */ 1,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,   
/*   MULTL*/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   CALL */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   JMP  */ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,   
/*   BRC  */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   BRCS */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   SFT  */ 1,0,1,0,1,0,1,0,1,1,0,0,1,0,0,1,1,0,1,1,0,1,1,1,0,0,0,0,0,   
/*   FA   */ 1,0,1,0,0,0,1,0,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   FAX  */ 1,0,1,0,0,0,1,0,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   FM   */ 1,0,1,0,0,0,1,0,0,1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   MOV  */ 1,0,1,0,1,0,1,0,1,1,0,1,0,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   MVLD */ 1,0,1,0,1,0,1,0,1,1,0,1,0,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   MVDL */ 1,0,1,0,1,0,1,0,1,1,0,1,0,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,   
/*   CS   */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
/*   VC   */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,   
             };                                     

char size_tbl[29]={
/*   NON  */   0x01,
/*   LDG  */   0x01,
/*   LDGL */   0x02,
/*   LDF  */   0x01,
/*   LDFL */   0x02,
/*   STG  */   0x01,
/*   STGL */   0x02,
/*   STF  */   0x01,
/*   STFL */   0x02,
/*   SETI */   0x02,
/*   IC   */   0x01,
/*   ICL  */   0x02,
/*   LC   */   0x01,
/*   LCL  */   0x02,
/*   MULT */   0x01,
/*   MULTL*/   0x02,
/*   CALL */   0x02,
/*   JMP  */   0x01,
/*   BRC  */   0x02,
/*   BRCS */   0x02,
/*   SFT  */   0x01,
/*   FA   */   0x01,
/*   FAX  */   0x01,
/*   FM   */   0x01,
/*   MOV  */   0x01,
/*   MVLD */   0x01,
/*   MVDL */   0x01,
/*   CS   */   0x02,
/*   VC   */   0x02,
             };
