#define		IK_NON		0
#define		IK_LDG		1
#define		IK_LDGL		2
#define		IK_LDF		3
#define		IK_LDFL		4
#define		IK_STG		5
#define		IK_STGL		6
#define		IK_STF		7
#define		IK_STFL		8
#define		IK_SETI		9
#define		IK_IC		10
#define		IK_ICL		11
#define		IK_LC		12
#define		IK_LCL		13
#define		IK_MULT		14
#define		IK_MULTL	15
#define		IK_CALL		16
#define		IK_JMP		17
#define		IK_BRC		18
#define         IK_BRCS         19
#define         IK_SFT          20
#define         IK_FA           21
#define         IK_FAX          22
#define         IK_FM           23
#define         IK_MOV          24
#define         IK_MVLD         25
#define         IK_MVDL         26
#define         IK_CS           27
#define         IK_VC           28

#define     PIPE_LS  0
#define     PIPE_I   1 
#define     PIPE_FA  2
#define     PIPE_FM  3
#define     PIPE_CS  4

typedef struct insttbl{
  char  *mnemonic;
  int    size;
  int    time;
  int    type;
  int    num_of_op;
  int    mem_def;   
}INSTTBL;
 
typedef struct inst_buf{
  int             frmt;
  int             inst_no;
  struct graph    *inst[4];
  struct inst_buf *next;
}INST_BUF;

#define  INST_BEGIN     0 
#define  INST_END       272
#define  VUTEG_BEGIN    (INST_END +   1)
#define  VUTEG_END      (INST_END +  32) 
#define  VREG_BEGIN     (INST_END +  33) 
#define  VREG_END       (INST_END + 288) 
#define  MREG_BEGIN     (INST_END + 289)
#define  MREG_END       (INST_END + 544) 
#define  VCREG_BEGIN    (INST_END + 545)
#define  VCREG_END      (INST_END + 576) 
#define  SREG_BEGIN     (INST_END + 577) 
#define  SREG_END       (INST_END +1600) 
#define  FREG_BEGIN     (INST_END +1601)
#define  FREG_END       (INST_END +1632) 
#define  GREG_BEGIN     (INST_END +1633)
#define  GREG_END       (INST_END +1664) 
#define  CREG_BEGIN     (INST_END +1665)
#define  CREG_END       (INST_END +1685)

#define  INDX_BRC       (symscan("brc"))
#define  INDX_BRNC      (symscan("brnc"))
#define  INDX_CALL      (symscan("call"))
#define  INDX_JMP       (symscan("jmp"))
#define  INDX_LD_L      (symscan("ld.l")) 
#define  INDX_LD_PF     (symscan("ld.pf")) 
#define  INDX_LD_PD     (symscan("ld.pd")) 
#define  INDX_ST		(symscan("st")) 
#define  INDX_STC		(symscan("st.c")) 
#define  INDX_NOP		(symscan("nop")) 
