/* @(#)crt0-tachyon.s	1.3 10/26/93 */

	.align	16
	.globl	_exit
start:	movtg   gr2			! save initial clock
	sll     gr2,20,gr2
	srl     gr3,12,gr3
	or      gr2,gr3,gr2
	seti	time,gr1
	st	gr2,gr1,gr0
	seti	0xf0000000,gr1		! assume PEV=0
	movgs	gr1,sr32
	seti	0x08000000,gr1		! assume max location of 128MB mem
	call	_startup,gr3		! call Startup
	call	_main,gr3		! call Program
_exit:	call	_terminate,gr3		! call Terminate
	movtg   gr2
	sll     gr2,20,gr2
	srl     gr3,12,gr3
	or      gr2,gr3,gr2
	seti    time,gr1
	ld	gr1,gr0,gr3		! load initial clock
	subl	gr2,gr3,gr2
	st	gr2,gr1,gr0		! store clock (micro sec)
	nop & 	brnc true,exitm		! EXT_FUNC2   (for simulator)
	nop & 	brnc true,exith		! EXT_FUNC1   (for simulator)
	.octa	0xbf83ff0000000000	! FWC_83FF    (for SP)
exitl:	brc	true,exitl		! TIGHT_LOOP  (for KAI)
time:	.int	0

	.align	16
exitm:	.int	2,1,exitf,0
exitf:	.asciz	"Program is normally terminated. (in crt0)\n"

	.align	16
exith:	.int	1,0,0,0

	.align	256
	.globl	__opsr0
	.globl	__opsr1
	.globl	__opsr2
	.globl	__opsr3
	.globl	__pepar
__opsr0:.int	0	/* 1: printf disable (libkai) */
__opsr1:.int	0	/* psel: pepa control (libkai) */
__opsr2:.int	0	/* reserved (libkai) */
__opsr3:.int	0	/* reserved (libkai) */
__pepar:.int	0
	.int	0,0,0,0,0,0,0,0
	.int	0,0,0,0,0,0,0,0
