!   Linpack 100 Gen TaChyon assm                     
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Carnel loop                                      
!
!   General Registar Usage                           
!                                                    
!     gr01 : base registar  
!     gr02 : outer loop counter 
!     gr03 : outer loop index  K
!     gr04 : base of A
!     gr05 : distance
!
	.text
	.align 8

        .global _startup
_startup:
        jmp     gr3

        .global _terminate
_terminate:
        jmp     gr3

        .global _main
_main:
!
	seti      BASE, gr01            ! get base address
	ld        gr01,0    , gr02      ! outer loop counter 
	seti         2, gr03
	seti      A   , gr04
	seti       152, gr05
	seti         0, gr06
	ld.d      gr01,   80, fr08
loop:
	ld        gr01,    0, gr31      !
	subl      gr31, gr00, gr00      ! if(K.GT.0) goto b1
	brncs     iccp.le   , b1        !
	st        gr00, gr01,4          !
b1:
	ld        gr01,    4, gr31      ! if(K.LE.0) goto next
	subl      gr31, gr00, gr00      !
	brnc      iccp.le   , skip      ! 

	ld        gr01,    8, gr31      ! load  KP1
	st        gr31, gr01,   12      ! store J  
	ld        gr01,   16, gr30      ! 
	st        gr30, gr01,   20      ! 
	ld        gr01,    8, gr31      ! 
	subl      gr31, gr00, gr31      ! 
	brncs     iccp.le   , b2        ! 
	st        gr00, gr01,24         ! 
b2:
	ld        gr01,28   , gr26
	ld        gr01,32   , gr30      ! 
	add       gr26, gr30, gr29      ! 
	st        gr20, gr01,   36      !

	and       gr31, gr00, gr22      !
	st        gr22, gr01,   40      !
	st        gr22, gr01,   44      !

	ld        gr01,    4, gr31      ! 
	vlvl      gr31

	seti         1, gr28
	ld        gr01,   48, gr30
	ld        gr01,   52, gr29
	sub       gr30, gr29, gr00
	brcs      iccp.z    , b3  
	seti         0, gr28      
b3:
	seti         1, gr27      
	ld        gr01,   56, gr23
	subl      gr04, gr23, gr00
	brcs      iccp.z    , b4  
	seti         0, gr27
b4:
	addl      gr04, gr26, gr25
	addli25   gr25,    8, gr25
	vld       gr25, gr05,vr020,mr000
	seti     SVT25, gr24
	addl      gr24, gr22, gr21
	addli25   gr21, 1600, gr21
	vstd     vr020, gr21, gr00,mr000

	subl      gr05, gr23, gr00
	brc       iccp.z    , b5

	ld        gr01,   60, gr20
	ld        gr01,   64, gr19
	addl      gr04, gr06, gr18
	addli25   gr18,    8, gr18  
	vld       gr18, gr19, vr008,mr000 
	ld        gr01,   36, gr17  
	addli25   gr17,    8, gr17 
	addl      gr17, gr06, gr18  
	vstd     vr008, gr18, gr19,mr000
	addl      gr17, gr06, gr18
	vstd     vr020, gr18, gr19,mr000
b5:
	ld        gr01,   64, gr31
	vgs       gr31,vr000,mr000
	ld        gr01,   68, gr30
	vas       gr30,vr000,vr004,mr000
	ld        gr01,   40, gr29
	seti     SVT24, gr28
	addl      gr28, gr29, gr27 
	addli25   gr27,  800, gr27
	vstd     vr004, gr27, gr00,mr000
	ld        gr01,   20, gr26
	sub       gr26, gr00, gr00
	seti         1, gr25
	brcs      iccp.le   , b6
	seti         0, gr25 
b6:
	seti         1, gr24
	subl      gr25, gr00, gr00
	brcs      iccp.z    , b7
	seti         0, gr24
b7:
	st        gr24, gr01,72
	st        gr24, gr01,76
	subl      gr24, gr00, gr00
	brncs     iccp.z    , b8

	vcsned    fr08,vr020,mr016,mr000
b8:
	ld        gr01,   48, gr30
	seti     SVT21, gr29
	addl      gr30, gr29, gr28 
	addli25   gr28,  504, gr28 
	vstm     mr016, gr28, gr00
	ld        gr01,   72, gr27
	subl      gr27, gr00, gr00
	brcs      iccp.z    , b9
b9:
	vpt

	ld        gr01,    4, gr26
	st        gr26, gr01,88

	ld        gr01,   24, gr25 
	vlvl      gr25  
VWT1:	brcs       es1, VWT1

	ld        gr01,   92, gr23
	ld        gr01,   96, gr22
	addl      gr23, gr22, gr21
	addli25   gr21,    8, gr21
	vld       gr21, gr00,vr032,mr000

	st        gr00, gr01,  100
	st        gr00, gr01,  104
	st        gr00, gr01,  108
	st        gr00, gr01,  112
	st        gr00, gr01,  116

	ld        gr01,   88, gr30
	ld        gr01,   40, gr29
	ld        gr01,   44, gr28
	seti      A         , gr27
!	ld        gr01,   92, gr27
	seti         8, gr26
	ld        gr01,   76, gr26
	or        gr02, gr00, gr10
	ld        gr01,    4, gr18 

	vlvl      gr02
inloop: 
	seti     SVT21, gr31
	ld        gr31, gr00, gr25
	and       gr25, gr26, gr24
	subl      gr24, gr00, gr00
	brncs   iccp.z, b10

	seti     SVT24, gr23
	seti     SVT25, gr22
	ld        gr23, gr00, gr21 
	ld.d      gr22, gr00, fr14 

	ld        gr01,   20, gr20 
	sub       gr20, gr00, gr00 
	brncs     iccp.z    , b10
	and       gr00, gr19, gr19 
	add       gr19, gr26, gr19 

	addl      gr27, gr20, gr17 
	addli25   gr17,    8, gr17
	vld       gr17, gr00,vr000,mr000
	vmsd      fr14,vr000,vr064,mr000
	vad      vr064,vr032,vr004,mr000
	vstd     vr004, gr17, gr00,mr000
b10:
	addl      gr28, gr26, gr28
	addli25   gr30,    4,gr30
	subli5    gr10,    1, gr10
	brnc      iccp.z   , inloop

	vpt 

	subli5    gr02,    1, gr02
	brnc      iccp.z    , loop
skip:

	brnc    true,NEND               ! End of Job     
NEND:	brc     true,_exit

	.data
BASE:
	.set   base,.
N:	.int   99     ! gr01,0    G410043
	.int    0     ! gr01,4    G410027
KP1:	.int    0     ! gr01,8 
J:	.int    0     ! gr01,12
	.int    0     ! gr01,16   G410036
	.int    0     ! gr01,20   G210008
	.int    0     ! gr01,24   G410014
	.int    0     ! gr01,28   G410015
	.int    0     ! gr01,32   G410037
	.int    0     ! gr01,36   G410017
	.int    0     ! gr01,40   G410022
	.int    0     ! gr01,44   G410026
	.int    0     ! gr01,48   G410027
L:	.int    0     ! gr01,52   
	.int    0     ! gr01,56   
	.int    0     ! gr01,60   G410016
	.int    0     ! gr01,64   G130003
	.int    0     ! gr01,68   G410045
	.int    0     ! gr01,72   G410032
	.int    0     ! gr01,76   G410023
	.double 0     ! gr01,80   
	.int    0     ! gr01,88   G410031
	.int    0     ! gr01,92   G210012
	.int    0     ! gr01,96   G210010
	.int    0     ! gr01,100  G130004
	.int    0     ! gr01,104  G210003
	.int    0     ! gr01,108  G210004
	.int    0     ! gr01,112  G410020
K:	.int    0     ! gr01,118  
A:	.skip   8000
SVT21:	.skip   8000
SVT24:	.skip   8000
SVT25:	.skip   8000
