!   Livermore Loop for TaChyon assm                  
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Loop 2.   Mcr, Inner Product                     
!
	.text
	.align 8

	.global _startup
_startup:
	jmp	gr3

        .global _terminate
_terminate:
        jmp     gr3

	.global _main
_main:

 	brnc     true, GC1            ! Get clock

        seti     10000, gr31

loop:   seti     200 , gr01           ! Set VL value  
	seti     Base, gr02           ! Get Base      
	addli25  gr02,    8, gr05     ! Get Q addr    
	seti      40 , gr06           ! set Distance  
	ld.d     gr02, gr00, fr01     !                
	st.d     fr01, gr05,gr00      !               
!
!	Q = Q + Z(K)*X(K) + Z(K+1)*X(K+1) .... Z(K+4)*X(K+4) 
!


	vpt
VWT1:	brcs      es0,VWT1               ! VWT(VU) 
VWT2:	brcs     asam,VWT2               ! VWT(SU) 

        vlvl     gr01                    !                

        addli25  gr02,   16, gr03       ! Get  X addr    
	vld      gr03 ,gr06 ,vr000,mr0  ! Load X(K)       
	addli25  gr02,64056, gr04       ! Get  Z addr    
	vld      gr04 ,gr06 ,vr004,mr0  ! Load Z(K)       
	vmd      vr000,vr004,vr008,mr0  ! Mult            

	addi25   gr03 ,  8 ,gr07        ! set  Z(K+1) address
	vld      gr07 ,gr06 ,vr012,mr0  ! Load Z(K+1)     
	addi25   gr04 ,  8 ,gr11        ! set  X(K+1) address
	vld      gr11 ,gr06 ,vr016,mr0  ! Load X(K+1)     
	vmd      vr012,vr016,vr020,mr0  ! Mult            

	addi25   gr03 , 16 ,gr08        ! set  Z(K+2) address
	vld      gr08 ,gr06 ,vr024,mr0  ! Load Z(K+2)     
	addi25   gr04 , 16 ,gr12        ! set  X(K+2) address
	vld      gr12 ,gr06 ,vr028,mr0  ! Load X(K+2)     
	vmd      vr024,vr028,vr032,mr0  ! Mult            

	addi25   gr03 , 24 ,gr09        ! set  Z(K+3) address
	vld      gr09 ,gr06 ,vr036,mr0  ! Load Z(K+3)     
	addi25   gr04 , 24 ,gr13        ! set  X(K+3) address
	vld      gr13 ,gr06 ,vr040,mr0  ! Load X(K+3)     
	vmd      vr036,vr040,vr044,mr0  ! Mult            

	addi25   gr03 , 32 ,gr10        ! set  Z(K+4) address
	vld      gr10 ,gr06 ,vr048,mr0  ! Load Z(K+4)     
	addi25   gr04 , 32 ,gr14        ! set  Z(K+4) address
	vld      gr14 ,gr06 ,vr052,mr0  ! Load X(K+4)     
	vmd      vr048,vr052,vr056,mr0  ! Mult            

	vad      vr008,vr020,vr060,mr0  !
	vad      vr032,vr060,vr064,mr0  !
	vad      vr044,vr064,vr068,mr0  !
	vad      vr056,vr068,vr072,mr0  !

	vsmd     vr072, fr02,mr0 
	st.d      fr02, gr02,gr00
	vpt                             !
        subli25  gr31 ,  1 ,gr31
VWT3:	brcs      es0,VWT3              ! VWT(VU) 

 	brnc   iccp.z,loop              ! Get clock

	brnc    true,NEND               ! End of Job

NEND:	brc	true,_exit

GC1:	.int 3,1,0,0
GC2:    .int 3,1,0,0

!       Data Division

	.data      

Base:
ZERO:	.double   0.0e+00               ! set ZERO value
Q:      .double   1.0e+00               ! set Q    value
X:      .double   1.0e+00,2.0e+00,3.0e+00
	.double   4.0e+00,5.0e+00
	.fill     8000,8,0
Z:      .double   1.0e+00,2.0e+00,3.0e+00
	.double   4.0e+00,5.0e+00
	.fill     8000,8,0
