!   Livermore Loop for TaChyon assm                  
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Loop 7.   Equation Of State Excerpt.            
!
	.text
	.align 8

	.global _startup
_startup:
	jmp	gr3

        .global _terminate
_terminate:
        jmp     gr3

	.global _main
_main:
!
CLOCK1: brnc    true,GC1
!
        seti   10000 , gr31

loop:   seti     120, gr01          ! set VL 
	seti    BASE, gr02          ! set U(BASE) address 
	addli25 gr02,0xf00, gr06    ! set R  address
	addli25 gr02,0xf08, gr07    ! set T  address
!
	vpt
!
!     X(M)= U(M)+R*(Z(M)+R*Y(M))+
!          +T*(U(M+3)+R*(U(M+2)+R*U(M+1))
!          +T*(U(M+6)+R*(U(M+5)+R*U(M+4))))
!
!
VWT1:   brcs    es0,VWT1                 ! VWT(VU)     
VWT2:   brcs   asam,VWT2                 ! VWT(SU)
!
        vlvl    gr01                      ! VL=120
        vld    gr02, gr00,vr000, mr00    ! LOAD U(M)
	addli25 gr02,0x008, gr13         ! set U(.+1)  address
	vld    gr13, gr00,vr002, mr00    ! LOAD U(M+1)
	addli25 gr02,0x010, gr14         ! set U(.+2)  address
	vld    gr14, gr00,vr004, mr00    ! LOAD U(M+2)
	addli25 gr02,0x018, gr15         ! set U(.+3)  address
	vld    gr15, gr00,vr006, mr00    ! LOAD U(M+3)
	addli25 gr02,0x020, gr16         ! set U(.+4)  address
	vld    gr16, gr00,vr008, mr00    ! LOAD U(M+4)
	addli25 gr02,0x028, gr17         ! set U(.+5)  address
	vld    gr17, gr00,vr010, mr00    ! LOAD U(M+5)
	addli25 gr02,0x030, gr18         ! set U(.+6)  address
	vld    gr18, gr00,vr012, mr00    ! LOAD U(M+6)
	addli25 gr02,0xb40, gr05    ! set Z  address
	vld    gr05, gr00,vr014, mr00    ! LOAD Z(M)
        addli25 gr02,0x780, gr04    ! set Y  address 	
	vld    gr04, gr00,vr016, mr00    ! LOAD Y(M)
	addli25 gr02,0x3c0, gr03    ! set X  address 
	vld    gr03, gr00,vr018, mr00    ! LOAD X(M)
!
	ld.d    gr06, gr00, fr01    ! LOAD R
	vmsd   fr01,vr008,vr020, mr00    ! R*U(M+4)
	vad   vr020,vr010,vr022, mr00    ! R1=U(M+5)+R*(U(M+4))
	vmsd   fr01,vr022,vr024, mr00    ! R*R1
	vad   vr024,vr012,vr026, mr00    ! R2=U(M+6)+R*R1
!
	vmsd   fr01,vr002,vr028, mr00    ! R*U(M+1)
	vad   vr028,vr004,vr030, mr00    ! R3=U(M+2)+R*(U(M+1))
	vmsd   fr01,vr030,vr032, mr00    ! R*R3
	vad   vr032,vr006,vr034, mr00    ! R4=U(M+3)+R*R3
!
	ld.d    gr07, gr00, fr02    ! LOAD T
	vmsd   fr02,vr026,vr036, mr00    ! T*R2
	vad   vr036,vr034,vr038, mr00    ! R5=R4+T*R2
!
	vmsd   fr01,vr016,vr040, mr00    ! R*Y(M)
	vad   vr040,vr014,vr042, mr00    ! R6=Z(M)+R*(Y(M))
	vmsd   fr01,vr042,vr044, mr00    ! R*R6
	vad   vr044,vr000,vr046, mr00    ! R7=U(M)+R*R6
!
	vmsd   fr02,vr038,vr048, mr00    ! T*R5
	vad   vr048,vr046,vr050, mr00    ! ANSWER=R7+T*R5
!
	vstd  vr050, gr03, gr00, mr00    ! store X(M) answer
!
        vpt
        subli5 gr31,   1,gr31
VWT3:   brcs   es0,VWT3                  ! VWT(VU)
!
CLOCK2: brnc    iccp.z,loop
!
	brnc    true,NEND                ! End of Job
NEND:	brc	true,_exit
!
GC1:    .int    3,1,0,0
GC2:    .int    3,1,0,0
!
!       Data Division
!
	.data
BASE:
U:	.double   1.0e+00,2.0e+00,3.0e+00,4.0e+00,5.0e+00,6.0e+00
        .fill     114,8,0                 ! set U value
X:	.fill     120,8,0                 ! set X value
Y:	.double   1.0e+00,2.0e+00,3.0e+00,4.0e+00,5.0e+00,6.0e+00
        .fill     114,8,0                 ! set Y value
Z:	.double   1.0e+00,2.0e+00,3.0e+00,4.0e+00,5.0e+00,6.0e+00
        .fill     114,8,0                 ! set Z value
R:	.double   2.0e+00                 ! set R value
T:	.double   3.0e+00                 ! set T value
ANS:    .int      322                     ! Answer
