!   Livermore Loop for TaChyon assm                  
!   Copy right Fujitsu Shizuoka Engineering Limited  
!                                                    
!   Loop 9.   Integrate Predictors.  
!
	.text
	.align 8

	.global _startup
_startup:
	jmp	gr3

        .global _terminate
_terminate:
        jmp     gr3

	.global _main
_main:
!
!
CLOCK1: brnc    true,GC1
!
        seti   10000 , gr31

loop:   seti     100, gr01               ! set VL value
	seti     120, gr20               ! set DISP value
!
	vpt
!
!        PX(1,I)= BM28*PX(13,I)+BM27*PX(12,I)+BM26*PX(11,I)
!                +BM25*PX(10,I)+BM24*PX(9,I)+BM23*PX(8,I)
!                +BM22*PX(7,I)
!                +CO*(PX(6,I)+PX(5,I))
!                +PX(3,I)

	vlvl    gr01
!	
VWT1:   brcs     es0,VWT1                ! VWT(VU) 
VWT2:   brcs    asam,VWT2                ! VWT(SU)
!
        vlvl    gr01
        seti     BASE, gr02               ! set PX(BASE) address
	addli25  gr02,0x060, gr21         ! set PX(13,I) address
	vld      gr21, gr20,vr000, mr00   ! load PX(13,I)
	addli25  gr02,0x2ee0,gr16         ! set BM28 address
	ld.d     gr16, gr00, fr01         ! load BM28
	vmsd     fr01,vr000,vr002, mr00   ! BM28*PX(13,I)
!
	addli25  gr02,0x058, gr22         ! set PX(12,I) address
	vld      gr22, gr20,vr004, mr00   ! load PX(12,I)
	addli25  gr02,0x2ee8,gr15         ! set BM27 address
	ld.d     gr15, gr00, fr02         ! load BM27
	vmsd     fr02,vr004,vr006, mr00   ! BM27*PX(12,I)
	vad     vr002,vr006,vr008, mr00   !
!
	addli25  gr02,0x050, gr23         ! set PX(11,I) address
	vld      gr23, gr20,vr010, mr00   ! load PX(11,I)
	addli25  gr02,0x2ef0,gr14         ! set BM26 address
	ld.d     gr14, gr00, fr03         ! load BM26
	vmsd     fr03,vr010,vr012, mr00   ! BM26*PX(11,I)
	vad     vr008,vr012,vr014, mr00   !
!
	addli25  gr02,0x048, gr24         ! set PX(10,I) address
	vld      gr24, gr20,vr016, mr00   ! load PX(10,I)
	addli25  gr02,0x2ef8,gr13         ! set BM25 address
	ld.d     gr13, gr00, fr04         ! load BM25
	vmsd     fr04,vr016,vr018, mr00   ! BM25*PX(10,I)
	vad     vr014,vr018,vr020, mr00   !
!
	addli25  gr02,0x040, gr25         ! set PX(9,I) address
	vld      gr25, gr20,vr022, mr00   ! load PX(9,I)
	addli25  gr02,0x2f00,gr12         ! set BM24 address
	ld.d     gr12, gr00, fr05         ! load BM24
	vmsd     fr05,vr022,vr024, mr00   ! BM24*PX(9,I)
	vad     vr020,vr024,vr026, mr00   !
!
	addli25  gr02,0x038, gr26         ! set PX(8,I) address
	vld      gr26, gr20,vr028, mr00   ! load PX(8,I)
	addli25  gr02,0x2f08,gr11         ! set BM23 address
	ld.d     gr11, gr00, fr06         ! load BM23
	vmsd     fr06,vr028,vr030, mr00   ! BM23*PX(8,I)
	vad     vr026,vr030,vr032, mr00   ! 
!
	addli25  gr02,0x030, gr27         ! set PX(7,I) address
	vld      gr27, gr20,vr034, mr00   ! laod PX(7,I)
	addli25  gr02,0x2f10,gr10         ! set BM22 address
	ld.d     gr10, gr00, fr07         ! load BM22
	vmsd     fr07,vr034,vr036, mr00   ! BM22*PX(7,I)
	vad     vr032,vr036,vr038, mr00   ! 
!
	addli25  gr02,0x028, gr28         ! set PX(6,I) address 
	vld      gr28, gr20,vr040, mr00   ! load PX(6,I)
	addli25  gr02,0x020, gr29         ! set PX(5,I) address
	vld      gr29, gr20,vr042, mr00   ! load PX(5,I)
	vad     vr040,vr042,vr044, mr00   ! PX(5,I)+PX(6,I)
!
	addli25  gr02,0x2f18, gr09        ! set CO   address
	ld.d     gr09, gr00, fr08         ! load CO
	vmsd     fr08,vr044,vr046, mr00   ! 
	vad     vr046,vr038,vr048, mr00   ! 
!
	addli25  gr02,0x010, gr30         ! set PX(3,I) address
	vld      gr30, gr20,vr050, mr00   ! load PX(3,I)
	vad     vr050,vr048,vr052, mr00   ! 
!
        vstd    vr052, gr02, gr00, mr00   ! 
!
        vpt 
        subli25  gr31,    1, gr31
VWT3:   brcs     es0,VWT3                ! VWT(VU)
!
CLOCK2: brnc    iccp.z,loop
!
	brnc    true,NEND                ! End of Job
NEND:	brc	true,_exit
!
GC1:    .int    3,1,0,0
GC2:    .int    3,1,0,0
!
!       Data Division
!
	.data
BASE:
PX:	.double   1.0e+00,2.0e+00,3.0e+00,4.0e+00,5.0e+00,6.0e+00
	.fill     1494,8,0                  ! set PX value
BM28:	.double   1.0e+00
BM27:	.double   2.0e+00
BM26:	.double   3.0e+00
BM25:	.double   4.0e+00
BM24:	.double   5.0e+00
BM23:	.double   6.0e+00
BM22:	.double   7.0e+00
CO:	.double   2.0e+00
ANS:    .double   2.5e+01                   ! Answer
