#ident  "@(#)dtuerrord.c	1.2 1/6/93 16:11:22 - FUJITSU UXP/VPP"

/* #ident "@(#)dtuerrord.c	1.13 11/27/92" */

#include "util/types.h"
#include "util/param.h"
#include "util/sysmacros.h"
#include "util/bootinfo.h"
#include "mem/immu.h"
#include "mem/page.h"
#include "mem/kmem.h"
#include "mem/kaidep.h"
#include "proc/proc.h"
#include "util/cmn_err.h"
#include "util/mcr.h"
#include "util/mcr_field.h"
#include "io/dtu/dc.h"                  

extern int dc_repflg;

dtuerrord()
{
  int        dummy;
  struct mb* mb;
  struct statistics* stat;

  for(;;) {
    if (dc_recv(DC_MODE_WAIT, 0, &dummy, &dummy, &mb) == DC_CC_NORMALEND) {
      if (mb->status == DC_STATUS_MONITOR) {
#ifdef DEBUG
        stat = (struct statistics*)(mb->msg);
        if(dc_repflg) {
        cmn_err(CE_NOTE, "RT=%u,FA=%u,1p=%u,1b=%u,3p=%u,3b=%u,lp=%u,lb=%u,1f=%u,3f=%u,df=%u,tf=%u,dq=%u,tq=%u:%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u,%u",
          stat->retrycount,
          stat->failcount,
          stat->mb01pcount,
          stat->mb01bcount,
          stat->mb32pcount,
          stat->mb32bcount,
          stat->ldtpcount,
          stat->ldtbcount,
          stat->mb01f_enum,
          stat->mb32f_enum,
          stat->dcbf_enum,
          stat->tokf_enum,
          stat->dcbq_enum,
          stat->tokq_enum,
	  stat->rbq_enum[0],stat->rbq_enum[1],stat->rbq_enum[2],stat->rbq_enum[3],
	  stat->rbq_enum[4],stat->rbq_enum[5],stat->rbq_enum[6],stat->rbq_enum[7],
	  stat->rbq_enum[8],stat->rbq_enum[9],stat->rbq_enum[10],stat->rbq_enum[11],
	  stat->rbq_enum[12],stat->rbq_enum[13],stat->rbq_enum[14],stat->rbq_enum[15],
	  stat->rbq_enum[16],stat->rbq_enum[17],stat->rbq_enum[18],stat->rbq_enum[19],
	  stat->rbq_enum[20],stat->rbq_enum[21],stat->rbq_enum[22],stat->rbq_enum[23],
	  stat->rbq_enum[24],stat->rbq_enum[25],stat->rbq_enum[26],stat->rbq_enum[27],
	  stat->rbq_enum[28],stat->rbq_enum[29],stat->rbq_enum[30],stat->rbq_enum[31]);
          }
#endif
      }
      else {
        cmn_err(CE_NOTE, "dtuerrord: status=%d,cc=%d,cmd=%d,mode=%d,sel=%d,size=%d intr=%x",
        mb->status, mb->cc, mb->cmd, mb->mode, mb->sel, mb->size, mb->key);
      }
      mb->key = 0;
      dc_mbfree(mb);
    }
  }
}
