static char SccsId[] = "@(#)maccalc.c	4.5    9/25/91    15:08:54";

/*      maccalc.c  90/02/01   */

#ifdef MACC
#include "macc.h"
#else
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#ifndef  UTS
#include <strings.h>
#endif
#endif

#define  END_CODE  21

is_calc( o_dp, dest, o_cardinal )
    char    *o_dp;
    int     *dest, o_cardinal;
{
    int     d, tmp, cb_cnt, cal_f, digit, d_case;
    int     cardinal;
    char    *dp, *sp;
    int     sf[64];
    int     cb[64];
    char    cc[64];
    char    cs[64][256];
    char    ss[256];
    static char    hex_data[256] = {
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
              0,  1,  2,  3,  4,  5,  6,  7,  8,  9,'!','!','!','!','!','!',
            '!', 10, 11, 12, 13, 14, 15,'!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!', 10, 11, 12, 13, 14, 15,'!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!',
            '!','!','!','!','!','!','!','!','!','!','!','!','!','!','!','!'
            };
    static char *enz[] = {
           "(", ")", "*", "/", "%", "+", "-", "<<", ">>", "LT", "LE", "GT",
                "GE", "EQ", "NE", "&", "^", "|", "AND", "XOR", "OR", NULL };
    static char  enl[] = {
             1,   1,   1,   1,   1,   1,   1,    2,    2,    2,    2,    2,
                   2,    2,    2,   1,   1,   1,     3,     3,    2,    0 };
    static char  enu[] = {
             0,   0,   1,   1,   1,   2,   2,    3,    3,    4,    4,    4,
                   4,    5,    5,   6,   7,   8,     9,    10,   11,   12 };

    dp = o_dp;
    if( ( *dp == '*' ) || ( *dp == '/' ) ){
#ifdef MACC
        sprintf( error_buf, "%d macro calc error %s", fp[fpr_level].cnt, o_dp );
        longjmp( sjenv, 27 );
#else
        printf( "key error\n" );
        return( -1 );
#endif
    }
    for( tmp=0 ; tmp < 64 ; tmp++ ){
        sf[tmp] = 0;
    }
    for( tmp=0 ; tmp <= enu[END_CODE] ; tmp++ ){
        cc[tmp] = END_CODE;
        cb[tmp] = 0;
    }
    cb_cnt = enu[END_CODE];
    cal_f = digit = d_case = 0;
    sp = 0;
    for( ; isspace(*dp) ; dp++ );
    switch( *dp ){
        case '+' :
                d_case = 1;
                dp++;
                break;
        case '-' :
                d_case = 2;
                dp++;
                break;
        case '~' :
                d_case = 3;
                dp++;
                break;
        case 'N' :
                if( !strncmp( dp, "OT", 2 ) ){
                   d_case = 4;
                   dp += 3;
                }
                break;
        default :
                break;
    }
calc_roop:
    switch( *dp ){
        case ' ' :
        case '\t' :
                dp++;
                break;
        case '1' :
        case '2' :
        case '3' :
        case '4' :
        case '5' :
        case '6' :
        case '7' :
        case '8' :
        case '9' :
                cardinal = o_cardinal;
                goto b_store;
        case '0' :
                dp++;
                switch( *dp ){
                    case 'b' :
                    case 'B' :
                            /* 0b10010101 */
                            cardinal = 2;
                            dp++;
                            break;
                    case 'x' :
                    case 'X' :
                            /* 0x12345678 */
                            cardinal = 16;
                            dp++;
                            break;
                    case 'd' :
                    case 'D' :
                            /* 0d10010101 */
                            cardinal = 10;
                            dp++;
                            break;
                    case '1' :
                    case '2' :
                    case '3' :
                    case '4' :
                    case '5' :
                    case '6' :
                    case '7' :
                    case '8' :
                    case '9' :
                            /* 0123456701 */
                            cardinal = 8;
                            break;
                    default :
                            cardinal = 10;
                            dp--;
                            break;
                }
b_store:
                sp = NULL;
                for( digit=0 ; ( d=hex_data[*dp] ) < cardinal ; dp++ ){
                    digit = digit * cardinal + d;
                }
                break;
        case '"' :
                dp++;
                if( sp ){
#ifdef MACC
                    sprintf( error_buf,
                                  "%d invalid parameter %s",
                                            fp[fpr_level].cnt, o_dp );
                    longjmp( sjenv, 28 );
#else
                    printf("invalid parameter error 1\n");
                    return( -1 );
#endif
                }
                for( sp = ss ; *dp && ( (*dp != '\"') || (*(dp-1) == '\\') ) ;
                                                                        dp++ ){
                    *sp++ = *dp;
                }
                if( *dp++ != '\"' ){
#ifdef MACC
                    sprintf( error_buf,
                                  "%d invalid parameter %s",
                                                  fp[fpr_level].cnt, o_dp);
                    longjmp( sjenv, 28 );
#else
                    printf("invalid parameter error 2\n");
                    return( -1 );
#endif
                }
                *sp = NULL;
                sp = ss;
                digit = 0;
                break;
        case 'a' :
        case 'b' :
        case 'c' :
        case 'd' :
        case 'e' :
        case 'f' :
        case 'A' :
        case 'B' :
        case 'C' :
        case 'D' :
        case 'E' :
        case 'F' :
                if( o_cardinal == 16 ){
                    cardinal = o_cardinal;
                    goto b_store;
                }
        default :
                /*
                printf("digit :  data = %d(%d)\n", digit, cardinal );
                */
                if( d_case && sp ){
#ifdef MACC
                    sprintf( error_buf,
                                   "%d invalid parameter %s",
                                     fp[fpr_level].cnt, o_dp );
                    longjmp( sjenv, 28 );
#else
                    printf("invalid parameter error 3\n");
                    return( -1 );
#endif
                }
                switch( d_case ){
                    case 1 : /* + */
                            break;
                    case 2 : /* - */
                            digit = digit * ( -1 );
                            break;
                    case 3 : /* ~ */
                            digit = ~digit;
                            break;
                    case 4 : /* NOT */
                            digit = !digit;
                            break;
                    default :
                            break;
                }
        
                cal_f = d_case = 0;
cont_case:
                for( tmp=0 ;
                     enl[tmp] && ( strncmp( enz[tmp], dp, enl[tmp]) ) ;
                                                                       tmp++ );
                if( enl[tmp] ){
                    dp += enl[tmp];
                }
                else{
                    if( *dp ){
#ifdef MACC
                        sprintf( error_buf, "%d calc error 1 %s",
                                                  fp[fpr_level].cnt, o_dp);
                        longjmp( sjenv, 100 );
#else
                        printf("key error\n");
                        return( -1 );
#endif
                    }
                    else{
                        *dp = NULL;
                    }
                }
        
                switch( tmp ){
                    case 0 : /* ( */
                            cb[++cb_cnt] = 0;
                            cc[cb_cnt] = END_CODE;
                            sf[cb_cnt] = 0;
                            cs[cb_cnt][0] = NULL;
                            cal_f = 1;
                            break;
                    case 1 : /* ) */
                            digit = cal_proc( cc[cb_cnt],
                                              cb[cb_cnt], digit,
                                              &cs[cb_cnt][0], sp,
                                              sf[cb_cnt] );
                            if( sp ){
                                strcpy( &cs[cb_cnt][0], sp );
                            }
                            --cb_cnt;
                            sp = 0;
                            for( ; isspace(*dp) ; dp++ );
                            goto cont_case;
                            break;
                    case 3 : /* / */
                    case 4 : /* % */
                    case 2 : /* * */
                    case 5 : /* + */
                    case 6 : /* - */
                    case 7 : /* << */
                    case 8 : /* >> */
                    case 9 : /* LT */
                    case 10 : /* LE */
                    case 11 : /* GT */
                    case 12 : /* GE */
                    case 13 : /* EQ */
                    case 14 : /* NE */
                    case 15 : /* & */
                    case 16 : /* ^ */
                    case 17 : /* | */
                    case 18 : /* AND */
                    case 19 : /* XOR */
                    case 20 : /* OR */
                            if( enu[cc[cb_cnt]] == enu[END_CODE] ){
                                cb[cb_cnt] = digit;
                                if( sp ){
                                    strcpy( &cs[cb_cnt][0], sp );
                                }
                                else{
                                    cs[cb_cnt][0] = NULL;
                                }
                            }
                            else{
                                if( enu[cc[cb_cnt]] == enu[tmp] ){
                                    cb[cb_cnt] = cal_proc( cc[cb_cnt],
                                                           cb[cb_cnt], digit,
                                                           &cs[cb_cnt][0], sp,
                                                           sf[cb_cnt] );
                                    if( sp ){
                                        strcpy( &cs[cb_cnt][0], sp );
                                    }
                                }
                                else{
                                    if( enu[cc[cb_cnt]] > enu[tmp] ){
                                        cb[++cb_cnt] = digit;
                                        if( sp ){
                                            strcpy( &cs[cb_cnt][0], sp );
                                        }
                                        else{
                                            cs[cb_cnt][0] = NULL;
                                        }
                                    }
                                    else{
                                        if( enu[cc[cb_cnt]] < enu[tmp] ){
                                            digit = cal_proc( cc[cb_cnt],
                                                              cb[cb_cnt],
                                                              digit,
                                                              &cs[cb_cnt][0],
                                                              sp,
                                                              sf[cb_cnt] );
                                            if( sp ){
                                                strcpy( &cs[cb_cnt][0], sp );
                                            }
                                            sp = 0;
                                            --cb_cnt;
                                            cb[cb_cnt] = cal_proc(
                                                               cc[cb_cnt],
                                                               cb[cb_cnt],
                                                               digit,
                                                               &cs[cb_cnt][0],
                                                               sp,
                                                               sf[cb_cnt] );
                                            if( sp ){
                                                strcpy( &cs[cb_cnt][0], sp );
                                            }
                                        }
                                    }
                                }
                            }
                            sf[cb_cnt] = (int)sp;
                            cc[cb_cnt] = tmp;
                            cal_f = 1;
                            sp = 0;
                            break;
                    case END_CODE : /* null */
                            /*
                            printf("..digit :  data = %d\n", digit );
                            for( tmp=0 ; tmp<=cb_cnt ; tmp++ ){
                                printf("cb = %d  : data = %d\n", tmp, cb[tmp] );
                            }
                            */
                            if( !cb_cnt ){
                                digit = cal_proc( cc[cb_cnt],
                                                  cb[cb_cnt], digit,
                                                  &cs[cb_cnt][0], sp,
                                                  sf[cb_cnt] );
                                if( sp ){
                                    strcpy( &cs[cb_cnt][0], sp );
                                }
                            }
                            else{
                                do{
                                    digit = cal_proc( cc[cb_cnt],
                                                      cb[cb_cnt], digit,
                                                      &cs[cb_cnt][0], sp,
                                                      sf[cb_cnt] );
                                    if( sp ){
                                        strcpy( &cs[cb_cnt][0], sp );
                                    }
                                    sp = 0;
                                    --cb_cnt;
                                }while( cb_cnt );
                            }
                            *dest =  digit;
                            return( 0 );
                            break;
                    default :
#ifdef MACC
                            printf("error 1\n" );
                            exit(1);
#else
                            printf("key error\n");
                            return( -1 );
#endif
                            break;
                }
                for( ; isspace(*dp) ; dp++ );
                if( cal_f ){
                    switch( *dp ){
                        case '+' :
                                d_case = 1;
                                dp++;
                                break;
                        case '-' :
                                d_case = 2;
                                dp++;
                                break;
                        case '~' :
                                d_case = 3;
                                dp++;
                                break;
                        case 'N' :
                                if( !strncmp( dp, "OT", 2 ) ){
                                   d_case = 4;
                                   dp += 3;
                                }
                                break;
                        default :
                                break;
                    }
                }
                break;
    }
    goto calc_roop;
}

cal_proc( com, d1, d2, s1, s2, f )
    char    com;
    int     d1, d2;
    char    *s1, *s2;
    int     f;
{
    int     tmp;

    if( !s2 ){
        if( f ){
            fprintf( stderr, "error *********** !!\n" );
            fprintf( stdout, "error *********** !!\n" );
            return( 0 );
        }
        else{
            switch( com ){
                case 2 : /* * */
                        return( d1 * d2 );
                        break;
                case 3 : /* / */
                        if( !d2 ){
#ifdef MACC
                            sprintf( error_buf,
                             "%d macro calc error. zero div error. %d / %d",
                                              fp[fpr_level].cnt, d1, d2 );
                            longjmp( sjenv, 29 );
#else
                            printf("zero div error\n");
                            return( -1 );
#endif
                        }
                        return( d1 / d2 );
                        break;
                case 4 : /* % */
                        if( !d2 ){
#ifdef MACC
                            sprintf( error_buf,
                             "%d macro calc error. zero div error. %d %% %d",
                                              fp[fpr_level].cnt, d1, d2 );
                            longjmp( sjenv, 29 );
#else
                            printf("zero div error\n");
                            return( -1 );
#endif
                        }
                        return( d1 % d2 );
                        break;
                case 5 : /* + */
                        return( d1 + d2 );
                        break;
                case 6 : /* - */
                        return( d1 - d2 );
                        break;
                case 7 : /* << */
                        return( d1 << d2 );
                        break;
                case 8 : /* >> */
                        return( d1 >> d2 );
                        break;
                case 9 : /* LT */
                        return( d1 < d2 );
                        break;
                case 10 : /* LE */
                        return( d1 <= d2 );
                        break;
                case 11 : /* GT */
                        return( d1 > d2 );
                        break;
                case 12 : /* GE */
                        return( d1 >= d2 );
                        break;
                case 13 : /* EQ */
                        return( d1 == d2 );
                        break;
                case 14 : /* NE */
                        return( d1 != d2 );
                        break;
                case 15 : /* & */
                        return( d1 & d2 );
                        break;
                case 16 : /* ^ */
                        return( d1 ^ d2 );
                        break;
                case 17 : /* | */
                        return( d1 | d2 );
                        break;
                case 18 : /* AND */
                        return( d1 && d2 );
                        break;
                case 19 : /* XOR */
                        return( ( d1 != 0 ) ^ ( d2 != 0 ) );
                        break;
                case 20 : /* OR */
                        return( d1 || d2 );
                        break;
                default :
                        return( d2 );
            }
        }
    }
    else{
        if( !f ){
            fprintf( stderr, "error *********** !!\n" );
            fprintf( stdout, "error *********** !!\n" );
            return( 0 );
        }
        else{
            switch( com ){
                case 2  : /* * */
                case 3  : /* / */
                case 4  : /* % */
                case 5  : /* + */
                case 6  : /* - */
                case 7  : /* << */
                case 8  : /* >> */
                case 15 : /* & */
                case 16 : /* ^ */
                case 17 : /* | */
                case 18 : /* AND */
                case 19 : /* XOR */
                case 20 : /* OR */
                        return( 0 );
                        break;
                case 9  : /* LT */
                case 10 : /* LE */
                case 11 : /* GT */
                case 12 : /* GE */
                case 13 : /* EQ */
                case 14 : /* NE */
                        tmp = strcmp( s1, s2 );
                        switch( com ){
                            case 9  : /* LT */
                                    return( tmp < 0 );
                                    break;
                            case 10 : /* LE */
                                    return( tmp <= 0 );
                                    break;
                            case 11 : /* GT */
                                    return( tmp > 0 );
                                    break;
                            case 12 : /* GE */
                                    return( tmp >= 0 );
                                    break;
                            case 13 : /* EQ */
                                    return( tmp == 0 );
                                    break;
                            case 14 : /* NE */
                                    return( tmp != 0 );
                                    break;
                            default :
                                    return( 0 );
                                    break;
                        }
                        break;
                default :
                        return( 0 );
                        break;
            }
        }
    }
}
