static char SccsId[] = "@(#)mklst.c	4.5    2/27/91    15:07:48";

#include "macc.h"

mklst( mode )
int   mode;
{
    int         tmp;
    long        m_hashval;
    char        *sptr, *mptr, *xptr;
    char        *svchr;
    static char prmsv[256], prms[256];
    static char dbuf[FGET_SIZ];
    static char buffer[FGET_SIZ*4];

    xptr = prms;
    switch( mode ) {
    case M_MACRO :
        if( (sptr = strtok( NULL, " " ) ) == NULL ){
            sprintf( error_buf,
                        "%d macro name not find\n", fp[fpr_level].cnt );
            longjmp( sjenv, 30 );
        }
        m_hashval = sthash(sptr);
        strcpy( prms, sptr );

        (macro_lst+m_hashval)->name = (char *)entrycd(sptr);
        (macro_lst+m_hashval)->hash = hashval;
        (macro_lst+m_hashval)->type = M_USER;

        (mac_lst+hashval)->type = MAC_MAC;
        mac_id = mac_lst+hashval;
        tbl_id = mac_lst+hashval;
        nod_id = mac_lst+hashval;
        if((mptr = strtok(NULL,"\n")) == NULL) {
            (macro_lst+m_hashval)->pcnt = -1;
        }
        else{
            (macro_lst+m_hashval)->pcnt = prm_cnt;
            strprm( mptr );
        }
        hashval++;
        mac_f = 1;
        tbl_id = mac_id;
        break;
    case M_AIF :
    case M_AWHILE :
    case M_AREPEAT :
    case M_IFDEF :
    case M_IFNDEF :
    case M_IFASS :
    case M_IFNASS :
        if((sptr = strtok(NULL,"\n")) == NULL) {
            sprintf( error_buf, "%d condition undifined", fp[fpr_level].cnt );
            longjmp( sjenv, 31 );
        }
        for( ; isspace( *sptr ) ; sptr++ );
        *buffer = NULL;
        while( *( sptr + strlen(sptr) - 1 ) == '\\' ){
            *( sptr + strlen(sptr) - 1 ) = NULL;
            strcat( buffer, sptr );

            if( strgets( dbuf, &svchr ) == NULL ){
                sprintf( error_buf, "%d syntax error 06",fp[fpr_level].cnt );
                longjmp( sjenv, 32 );
            }
            if( *(sptr = strtok( dbuf, " " ) ) != '+' ){
                sprintf( error_buf, "%d syntax error 07",fp[fpr_level].cnt );
                longjmp( sjenv, 33 );
            }
            if( (sptr = strtok( NULL, "\n" ) ) == NULL ){
                sprintf( error_buf, "%d syntax error 08",fp[fpr_level].cnt );
                longjmp( sjenv, 34 );
            }
            for( ; isspace( *sptr ) ; sptr++ );
        }
        strcat( buffer, sptr );

        comment_cut( buffer );
        (mac_lst+hashval)->type = MAC_AIF;
        nod_tbl[nod_cnt].adr = mac_lst+hashval;
        nod_cnt++;
        if(if_flag){
            tbl_id->llink = (char *) (mac_lst+hashval);
            if_flag = 0;
        }
        else
            tbl_id->rlink = (char *) (mac_lst+hashval);
        tbl_id = mac_lst+hashval;
        hashval++;

        switch( mode ){
            case M_AREPEAT :
                    (mac_lst+hashval)->type = MAC_CHR;
                 
                    (mac_lst+hashval)->llink = (char *)entrycd( buffer );
                    tbl_id->llink = (char *) (mac_lst+hashval);
                    tbl_id = mac_lst+hashval;
                    hashval++;
                    (mac_lst+hashval)->type = MAC_IRH;
                    break;
            case M_AWHILE :
                    (mac_lst+hashval)->type = MAC_CHW;

                    (mac_lst+hashval)->llink = (char *)entrycd( buffer );
                    tbl_id->llink = (char *) (mac_lst+hashval);
                    tbl_id = mac_lst+hashval;
                    hashval++;
                    (mac_lst+hashval)->type = MAC_IWH;
                    break;
            case M_IFDEF :
            case M_IFNDEF :
            case M_IFASS :
            case M_IFNASS :
                    switch( mode ){
                            case M_IFDEF :
                                    (mac_lst+hashval)->type = MAC_IFD;
                                    break;
                            case M_IFNDEF :
                                    (mac_lst+hashval)->type = MAC_NFD;
                                    break;
                            case M_IFASS :
                                    (mac_lst+hashval)->type = MAC_IFA;
                                    break;
                            case M_IFNASS :
                                    (mac_lst+hashval)->type = MAC_NFA;
                                    break;
                    }

                    (mac_lst+hashval)->llink = (char *)entrycd( buffer );
                    tbl_id->llink = (char *) (mac_lst+hashval);
                    tbl_id = mac_lst+hashval;
                    hashval++;
                    (mac_lst+hashval)->type = MAC_IFT;
                    break;
            default :
                    (mac_lst+hashval)->type = MAC_CHK;

                    (mac_lst+hashval)->llink = (char *)entrycd( buffer );
                    tbl_id->llink = (char *) (mac_lst+hashval);
                    tbl_id = mac_lst+hashval;
                    hashval++;
                    (mac_lst+hashval)->type = MAC_IFT;
                    break;
        }
        tbl_id->rlink = (char *) (mac_lst+hashval);
        nod_tbl[nod_cnt].adr = mac_lst+hashval;
        nod_tbl[nod_cnt].flag = 1;
        nod_tbl[nod_cnt].mode = mode;
        tbl_id = mac_lst+hashval;
        nod_cnt++;
        nod_tbl[nod_cnt].flag = 1;
        nod_tbl[nod_cnt].mode = mode;
        hashval++;

        if_flag = 1;
        break;
    case M_AELSE :
        if( !nod_tbl[nod_cnt].flag || ( nod_tbl[nod_cnt].mode != M_AIF ) ){
            sprintf( error_buf, "%d .AELSE redecleared", fp[fpr_level].cnt );
            longjmp( sjenv, 35 );
        }
        nod_cnt--;
        nod_tbl[nod_cnt].flag = 0;
        tbl_id = nod_tbl[nod_cnt].adr;
        break;
    case M_ELSE :
        if( nod_tbl[nod_cnt].flag &&
            ( ( nod_tbl[nod_cnt].mode == M_IFDEF )  ||
              ( nod_tbl[nod_cnt].mode == M_IFNDEF ) ||
              ( nod_tbl[nod_cnt].mode == M_IFASS )  ||
              ( nod_tbl[nod_cnt].mode == M_IFNASS ) ) ){
            nod_cnt--;
            nod_tbl[nod_cnt].flag = 0;
            tbl_id = nod_tbl[nod_cnt].adr;
        }
        else{
            sprintf( error_buf, "%d .ELSE redecleared", fp[fpr_level].cnt );
            longjmp( sjenv, 36 );
        }
        break;
    case M_AENDI :
        if( nod_tbl[nod_cnt].mode != M_AIF ){
            sprintf( error_buf, "%d .AENDI redecleared", fp[fpr_level].cnt );
            longjmp( sjenv, 37 );
        }
        if( nod_tbl[nod_cnt].flag ){
            nod_cnt -= 2;
        }
        else{
            nod_cnt--;
        }
        if( nod_cnt<0 ) {
            sprintf( error_buf,
                "%d Meaningless macro directive .AENDI ", fp[fpr_level].cnt );
            longjmp( sjenv, 38 );
        }
        tbl_id = nod_tbl[nod_cnt].adr;
        break;
    case M_ENDIF :
        if( ( nod_tbl[nod_cnt].mode == M_IFDEF )  ||
            ( nod_tbl[nod_cnt].mode == M_IFNDEF ) ||
            ( nod_tbl[nod_cnt].mode == M_IFASS )  ||
            ( nod_tbl[nod_cnt].mode == M_IFNASS ) ){
            if( nod_tbl[nod_cnt].flag ){
                nod_cnt -= 2;
            }
            else{
                nod_cnt--;
            }
            if( nod_cnt<0 ) {
                sprintf( error_buf, "%d Meaningless macro directive .ENDIF ",
                                                         fp[fpr_level].cnt );
                longjmp( sjenv, 39 );
            }
            tbl_id = nod_tbl[nod_cnt].adr;
        }
        else{
            sprintf( error_buf, "%d .ENDIF redecleared", fp[fpr_level].cnt );
            longjmp( sjenv, 40 );
        }
        break;
    case M_AENDR :
        if( nod_tbl[nod_cnt].mode != M_AREPEAT ){
            sprintf( error_buf, "%d .AENDR redecleared", fp[fpr_level].cnt );
            longjmp( sjenv, 41 );
        }
        if( nod_tbl[nod_cnt].flag ){
            nod_cnt -= 2;
        }
        else{
            nod_cnt--;
        }
        if( nod_cnt<0 ) {
            sprintf( error_buf,
                "%d Meaningless macro directive .AENDR ", fp[fpr_level].cnt );
            longjmp( sjenv, 42 );
        }
        tbl_id = nod_tbl[nod_cnt].adr;
        break;
    case M_AENDW :
        if( nod_tbl[nod_cnt].mode != M_AWHILE ){
            sprintf( error_buf, "%d .AENDW redecleared", fp[fpr_level].cnt );
            longjmp( sjenv, 43 );
        }
        if( nod_tbl[nod_cnt].flag ){
            nod_cnt -= 2;
        }
        else{
            nod_cnt--;
        }
        if( nod_cnt<0 ) {
            sprintf( error_buf,
                "%d Meaningless macro directive .AENDW ", fp[fpr_level].cnt );
            longjmp( sjenv, 44 );
        }
        tbl_id = nod_tbl[nod_cnt].adr;
        break;
    case M_EXITM :
        (mac_lst+hashval)->type = MAC_EXT;
        if(if_flag){
            tbl_id->llink = (char *) (mac_lst+hashval);
            if_flag = 0;
        }
        else
            tbl_id->rlink = (char *) (mac_lst+hashval);
        tbl_id = mac_lst+hashval;
        hashval++;
        break;
    case M_INCLUDE :
        if( (sptr = strtok( NULL, "\n" ) ) == NULL ){
            sprintf( error_buf,
                        "%d include file not find", fp[fpr_level].cnt );
            longjmp( sjenv, 45 );
        }
        for( ; isspace( *sptr ) ; sptr++ );
        comment_cut( sptr );
        fpr_level++;
        strcpy( buffer, sptr+1 );
        switch( *sptr ){
            case '<' :
                    if( *(buffer + strlen(buffer) - 1 ) != '>' ){
                        sprintf( error_buf, "%d include file name error",
                                                          fp[fpr_level].cnt );
                        longjmp( sjenv, 46 );
                    }
                    *(buffer + strlen(buffer) -1 ) = NULL;
                    tmp = 0;
                    break;
            case '"' :
                    if( *(buffer + strlen(buffer) - 1 ) != '"' ){
                        sprintf( error_buf, "%d include file name error",
                                                          fp[fpr_level].cnt );
                        longjmp( sjenv, 46 );
                    }
                    *(buffer + strlen(buffer) -1 ) = NULL;
                    tmp = 1;
                    break;
            default :
                    sprintf( error_buf, "%d include file name error",
                                                          fp[fpr_level].cnt );
                    longjmp( sjenv, 46 );
                    break;
        }
        strcpy( fp[fpr_level].name, buffer );
        if( ( fp[fpr_level].fpr = fopen( fp[fpr_level].name, "r" ) ) == NULL ){
            if( tmp ){
                if( ( tmp = a_hithash( "INCLUDE" ) ) != -1 ){
                    if( asn_tbl[tmp].mode >= MAC_DFS ){
                        sprintf( fp[fpr_level].name,
                                 "%s/%s", asn_tbl[tmp].pram, buffer );
                        if( ( fp[fpr_level].fpr =
                                  fopen( fp[fpr_level].name, "r" ) ) == NULL ){
                            sprintf( error_buf, "%d can't open %s",
                                      fp[fpr_level].cnt, fp[fpr_level].name );
                            longjmp( sjenv, 47 );
                        }
                        fp[fpr_level].cnt = 0;
                        break;
                    }
                }
            }
            else{
                if( getenv("MACINCLUDE") ){
                    sprintf( fp[fpr_level].name,
                           "%s/%s", ( char * )getenv("MACINCLUDE"), buffer );
                    if( ( fp[fpr_level].fpr =
                              fopen( fp[fpr_level].name, "r" ) ) == NULL ){
                        sprintf( error_buf, "%d can't open %s",
                                  fp[fpr_level].cnt, fp[fpr_level].name );
                        longjmp( sjenv, 47 );
                    }
                    fp[fpr_level].cnt = 0;
                    break;
                }
            }
            sprintf( error_buf,
                  "%d can't open %s", fp[fpr_level].cnt, fp[fpr_level].name );
            longjmp( sjenv, 47 );
        }
        fp[fpr_level].cnt = 0;
        break;
    case M_ERROR :
        if( (sptr = strtok( NULL, "\n" ) ) == NULL ){
            sprintf( error_buf, "%d .ERROR parameter not find",
                                                          fp[fpr_level].cnt );
            longjmp( sjenv, 48 );
        }
        for( ; isspace( *sptr ) ; sptr++ );
        comment_cut( sptr );
        strcpy( buffer, sptr+1 );
        switch( *sptr ){
            case '<' :
                    if( *(buffer + strlen(buffer) - 1 ) != '>' ){
                        sprintf( error_buf, "%d .ERROR parameter error",
                                                          fp[fpr_level].cnt );
                        longjmp( sjenv, 49 );
                    }
                    *(buffer + strlen(buffer) -1 ) = NULL;
                    break;
            case '"' :
                    if( *(buffer + strlen(buffer) - 1 ) != '"' ){
                        sprintf( error_buf, "%d .ERROR parameter error",
                                                          fp[fpr_level].cnt );
                        longjmp( sjenv, 49 );
                    }
                    *(buffer + strlen(buffer) -1 ) = NULL;
                    break;
            default :
                    sprintf( error_buf, "%d .ERROR parameter error",
                                                          fp[fpr_level].cnt );
                    longjmp( sjenv, 49 );
                    break;
        }
        (mac_lst+hashval)->type = MAC_ERR;
        (mac_lst+hashval)->llink = (char *)entrycd(buffer);
        if(if_flag){
            tbl_id->llink = (char *) (mac_lst+hashval);
            if_flag = 0;
        }
        else
            tbl_id->rlink = (char *) (mac_lst+hashval);
        tbl_id = mac_lst+hashval;
        hashval++;
        break;
    case M_ENDM :
        if( nod_cnt ){
            sprintf( error_buf, "%d .AIF or .AREPEAT or .AWHILE unreachable",
                                                           fp[fpr_level].cnt );
            longjmp( sjenv, 50 );
        }
        (mac_lst+hashval)->type = MAC_END;
        (mac_lst+hashval)->llink = NULL;
        (mac_lst+hashval)->rlink = NULL;
        if(if_flag){
            tbl_id->llink = (char *) (mac_lst+hashval);
            if_flag = 0;
        }
        else
            tbl_id->rlink = (char *) (mac_lst+hashval);
        hashval++;
        mac_f = 0;
        break;
    default:
        sprintf( error_buf, "%d undefind macro code", fp[fpr_level].cnt );
        longjmp( sjenv, 51 );
        break;
    }
    return(0);
}
