static char SccsId[] = "@(#)pripro.c	4.13    9/4/91    15:08:32";

#include "macc.h"

/* assign & parameter */
p_hash( key )
    char *key;
{
    register unsigned p_hashval;
    register unsigned hashc;

    p_hashval = 0;
    for( hashc = 1 ; *key != NULL ; hashc++ )
        p_hashval += ( ( *key++ ) * hashc );
    return( ( p_hashval % PRITBL_CNT ) + 1 );
}

p_sthash( key, data, mode, p_tbl )
    char *key, *data;
    int  mode;
    PRM_TBL *p_tbl;
{
    unsigned p_hashval;
    unsigned o_hashval;
    int      i;

    p_hashval = p_hash( key );
    o_hashval = p_hashval;
    while( ( p_tbl+p_hashval )->name ){
        if(!strcmp(key,(p_tbl+p_hashval)->name)) {
            if( mode >= MAC_ASS ){
                if( mode >= MAC_DFS ){
                    sprintf( error_buf,
                                 "%d %s redecleared", fp[fpr_level].cnt, key );
                    longjmp( sjenv, 52 );
                }
                if( data ){
                    i = strlen( data );
                    if( i > (p_tbl+p_hashval)->len ){
                        (p_tbl+p_hashval)->pram = (char *)entrycd( data );
                        (p_tbl+p_hashval)->len  = i;
                    }
                    else{
                        strcpy( (p_tbl+p_hashval)->pram, data );
                    }
                }
                else{
                    (p_tbl+p_hashval)->pram = (char *)entrycd( data );
                }
                (p_tbl+p_hashval)->mode = mode;
                return(p_hashval);
                break;
            }
            else{
                if( (p_tbl+p_hashval)->mode >= mode ){
                    if( data ){
                        i = strlen( data );
                        if( i > (p_tbl+p_hashval)->len ){
                            (p_tbl+p_hashval)->pram = (char *)entrycd( data );
                            (p_tbl+p_hashval)->len  = i;
                        }
                        else{
                            strcpy( (p_tbl+p_hashval)->pram, data );
                        }
                    }
                    else{
                        if( (p_tbl+p_hashval)->len ){
                            *(p_tbl+p_hashval)->pram = NULL;
                        }
                        else{
                            (p_tbl+p_hashval)->pram = (char *)entrycd( data );
                        }
                    }
                    (p_tbl+p_hashval)->mode = mode;
                    return(p_hashval);
                    break;
                }
            }
        }
        if( ( p_hashval = p_rehash(p_hashval) ) == o_hashval ){
            sprintf( error_buf,
                         "%d %s pripro count over", fp[fpr_level].cnt, key );
            longjmp( sjenv, 52 );
            return( -1 );
        }
    }
    (p_tbl+p_hashval)->name = (char *)entrycd( key );
    (p_tbl+p_hashval)->pram = (char *)entrycd( data );
    (p_tbl+p_hashval)->len  = strlen( (p_tbl+p_hashval)->pram );
    (p_tbl+p_hashval)->mode = mode;
    return(p_hashval);
}

p_sthash_c( key, data, mode, p_tbl )
    char *key, *data;
    int  mode;
    PRM_TBL *p_tbl;
{
    register unsigned p_hashval;
    int               i;

    p_hashval = p_hash( key );
    while( ( p_tbl+p_hashval )->name ){
        if( !strcmp(key,(p_tbl+p_hashval)->name) &&
            ( (p_tbl+p_hashval)->mode == mode ) ){
            if( data ){
                i = strlen( data );
                if( i > (p_tbl+p_hashval)->len ){
                    (p_tbl+p_hashval)->pram = (char *)entrycd( data );
                    (p_tbl+p_hashval)->len  = i;
                }
                else{
                    strcpy( (p_tbl+p_hashval)->pram, data );
                }
            }
            else{
                if( (p_tbl+p_hashval)->len ){
                    *(p_tbl+p_hashval)->pram = NULL;
                }
                else{
                    (p_tbl+p_hashval)->pram = (char *)entrycd( data );
                }
            }
            /*
            (p_tbl+p_hashval)->mode = mode;
             */
            return(p_hashval);
            break;
        }
        p_hashval = p_rehash(p_hashval);
    }
    return( -1 );
}

p_sthash_e( key, data, mode, p_tbl )
    char *key, *data;
    int  mode;
    PRM_TBL *p_tbl;
{
    register unsigned p_hashval;
    int               i;

    p_hashval = p_hash( key );
    while( ( p_tbl+p_hashval )->name ){
        if( !strcmp(key,(p_tbl+p_hashval)->name) &&
            ( (p_tbl+p_hashval)->mode == mode ) ){
            if( data ){
                i = strlen( data );
                if( i > (p_tbl+p_hashval)->len ){
                    (p_tbl+p_hashval)->pram = (char *)entrycd( data );
                    (p_tbl+p_hashval)->len  = i;
                }
                else{
                    strcpy( (p_tbl+p_hashval)->pram, data );
                }
            }
            else{
                if( (p_tbl+p_hashval)->len ){
                    *(p_tbl+p_hashval)->pram = NULL;
                }
                else{
                    (p_tbl+p_hashval)->pram = (char *)entrycd( data );
                }
            }
            /*
            (p_tbl+p_hashval)->mode = mode;
             */
            return(p_hashval);
            break;
        }
        p_hashval = p_rehash(p_hashval);
    }
    sprintf( error_buf, "%d %s redecleared", fp[fpr_level].cnt, key );
    longjmp( sjenv, 53 );
}

a_hithash( key )
    char *key;
{
    register unsigned p_hashval;

    p_hashval = p_hash( key );
    while( ( asn_tbl+p_hashval )->name ){
        if(!strcmp(key,(asn_tbl+p_hashval)->name) ){
            return(p_hashval);
        }
        p_hashval = p_rehash(p_hashval);
    }
    return( -1 );
}

p_hithash( key )
    char *key;
{
    register unsigned p_hashval;

    p_hashval = p_hash( key );
    while( ( prm_tbl+p_hashval )->name ){
        if( !strcmp(key,(prm_tbl+p_hashval)->name) && 
            ( (prm_tbl+p_hashval)->mode == mac_cnt ) ){
            return(p_hashval);
        }
        p_hashval = p_rehash(p_hashval);
    }
    return( -1 );
}


sthash(key)
    char *key;
{
    int m_hashval;

    m_hashval = hash(key);
    while((macro_lst+m_hashval)->name) {
        if(!strcmp(key,(macro_lst+m_hashval)->name)) {
            sprintf( error_buf, "%d %s redecleared", fp[fpr_level].cnt,key );
            longjmp( sjenv, 54 );
        }
        m_hashval = rehash(m_hashval);
    }
    return(m_hashval);
}

prhash(key)
    char *key;
{
    int m_hashval;

    m_hashval = hash(key);
    while((macro_lst+m_hashval)->name)
        m_hashval = rehash(m_hashval);
    return(m_hashval);
}

chkhash(key)
    char *key;
{
    int m_hashval;

    key++;
    m_hashval = hash(key);
    if(!(macro_lst+m_hashval)->name) {
        return( M_USER );
    }
    while(strcmp(key,(macro_lst+m_hashval)->name)) {
        m_hashval = rehash(m_hashval);
        if(!(macro_lst+m_hashval)->name) {
            return( M_USER );
        }
    }
    return( (macro_lst+m_hashval)->type );
}


cvhash(key)
    char *key;
{
    int m_hashval;

    m_hashval = hash(key);
    if(!(macro_lst+m_hashval)->name) {
        sprintf( error_buf, "%d %s undefined", fp[fpr_level].cnt,key );
        longjmp( sjenv, 55 );
    }
    while(strcmp(key,(macro_lst+m_hashval)->name)) {
        m_hashval = rehash(m_hashval);
        if(!(macro_lst+m_hashval)->name) {
            sprintf( error_buf, "%d %s undefined", fp[fpr_level].cnt,key );
            longjmp( sjenv, 56 );
        }
    }
    return(m_hashval);
}

hash(key)
    char *key;
{
    int m_hashval;
    int hashc;

    m_hashval = 0;
    for(hashc = 1;*key != NULL;hashc++)
        m_hashval += (*key++ * hashc);
    return(m_hashval % MACROTBL_CNT + 1);
}
