static char SccsId[] = "@(#)usemac.c	4.8    5/12/91    15:07:38";

#include "macc.h"

/*************************************************************************
*
*  NAME : usemac
*
*  FUNCTION : 
*
*  SYNOPSIS :
*                 char  *ptr ;
*
*  RETURN   :  0 normal end
*             -1 invalid input error
*
*************************************************************************/

usemac( hval, fpwo, fpwl )
long  hval;
FILE  *fpwo, *fpwl;
{
    MAC_LLST     *plst;
    char         *data, *optr;
    int          tmp;
    unsigned     *itmp;
    static char  prmsv[256], stl_buf[256], str_buf[256];


    plst = (MAC_LLST *) (mac_lst+hval)->rlink;
    while(1) {
        if(!plst)
            break;
        switch( plst->type ){
        case M_USER:
            if( plst->rlink ){
                ntbl[ncnt++] = plst->rlink;
            }
            rtbl[ncnt] = 0;
            exitm[ncnt] = ncnt - 1;
            /* ntbl[ncnt++] = (char *)plst; */

            itmp = (unsigned *)plst->llink;
            convin( itmp, fpwo, fpwl );

            /*
            plst = (MAC_LLST *) ntbl[--ncnt];
            if(!plst->rlink) {
            */
                if(!ncnt)
                    return(0);
                else
                    plst = (MAC_LLST *) ntbl[--ncnt];
           /*
            }
            else
                plst = (MAC_LLST *) plst->rlink;
            */
            break;
        case MAC_AIF:
            if( plst->rlink ){
                ntbl[ncnt++] = plst->rlink;
            }
            plst = (MAC_LLST *) plst->llink;
            rtbl[ncnt] = 0;
            exitm[ncnt] = -1;
            break;
        case MAC_IFD:
            optr = (char*)argcal(plst->llink, NULL, NULL);
            if( ( tmp = a_hithash( optr ) ) == -1 ){
                ifflg = 0;
            }
            else{
                if( asn_tbl[tmp].mode >= MAC_DFS ){
                    ifflg = 1;
                }
                else{
                    ifflg = 0;
                }
            }
            plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_NFD:
            optr = (char*)argcal(plst->llink, NULL, NULL);
            if( ( tmp = a_hithash( optr ) ) == -1 ){
                ifflg = 1;
            }
            else{
                if( asn_tbl[tmp].mode >= MAC_DFS ){
                    ifflg = 0;
                }
                else{
                    ifflg = 1;
                }
            }
            plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_IFA:
            optr = (char*)argcal(plst->llink, NULL, NULL);
            if( ( tmp = a_hithash( optr ) ) == -1 ){
                ifflg = 0;
            }
            else{
                if( asn_tbl[tmp].mode < MAC_DFS ){
                    ifflg = 1;
                }
                else{
                    ifflg = 0;
                }
            }
            plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_NFA:
            optr = (char*)argcal(plst->llink, NULL, NULL);
            if( ( tmp = a_hithash( optr ) ) == -1 ){
                ifflg = 1;
            }
            else{
                if( asn_tbl[tmp].mode < MAC_DFS ){
                    ifflg = 0;
                }
                else{
                    ifflg = 1;
                }
            }
            plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_CHR:
            exitm[ncnt] = ncnt - 1;
            ntbl[ncnt++] = (char *)plst;
            exitm[ncnt] = ncnt - 1;
            strcpy(prmsv,plst->llink);
            optr = (char *) argcal(prmsv, NULL, NULL);
            strcpy( stl_buf, optr );
            is_calc( stl_buf, &tmp, 10 );
            ifflg = (  tmp > rtbl[ncnt-1] );
            rtbl[ncnt-1]++;
            plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_CHW:
            exitm[ncnt] = ncnt - 1;
            ntbl[ncnt++] = (char *)plst;
            exitm[ncnt] = ncnt - 1;
        case MAC_CHK:
            /* strcpy(prmsv,plst->llink); */
            optr = (char *) argcal(plst->llink, NULL, 1);
            /* strcpy( stl_buf, optr ); */
            is_calc( optr, &ifflg, 10 );
            plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_IFT:
            if(ifflg)
                plst = (MAC_LLST *) plst->llink;
            else
                plst = (MAC_LLST *) plst->rlink;
            if(!plst) {
                if(!ncnt)
                    return(0);
                else
                    plst = (MAC_LLST *) ntbl[--ncnt];
            }
            break;
        case MAC_IWH:
            if( ++rtbl[ncnt-1] >= next_level ){
                sprintf( error_buf, "%d AWHILE next level error", 
                                                         fp[fpr_level].cnt );
                longjmp( sjenv, 70 );
            }
        case MAC_IRH:
            if(ifflg){
                if( !( plst = (MAC_LLST *)plst->llink ) ){
                    if(!ncnt){
                        return(0);
                    }
                    else{
                        plst = (MAC_LLST *) ntbl[--ncnt];
                    }
                }
            }
            else{
                ncnt -= 2;
                if( ncnt < 0 ){
                    return(0);
                }
                else{
                    plst = (MAC_LLST *)ntbl[ncnt];
                }
            }
            break;
        case MAC_EXT:
            if( !ncnt ){
                return(0);
            }
            else{
                ncnt = exitm[--ncnt];
                if( ncnt < 0 ){
                    return( 0 );
                }
                plst = (MAC_LLST *)ntbl[ncnt];
            }
            break;
        case MAC_END:
            return(0);
            break;
        case MAC_BDY:
            data = (char *)argcal(plst->llink, stl_buf, NULL);
            strputs_m( data, fpwo, fpwl, stl_buf );
            if(!plst->rlink) {
                if(!ncnt)
                    return(0);
                else
                    plst = (MAC_LLST *) ntbl[--ncnt];
            }
            else
                plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_ASS:
        case MAC_DFS:
            /*
            data = plst->name+3;
            */
            itmp = (unsigned *)plst->llink;
            data = (char *)*(itmp+1);
            optr = (char*)argcal(data, NULL, NULL);
            strcpy( stl_buf, optr );
            data = (char *)*itmp;
            optr = (char*)argcal(data, NULL, NULL);
            p_sthash( optr, stl_buf, plst->type, asn_tbl );
            if(!plst->rlink) {
                if(!ncnt)
                    return(0);
                else
                    plst = (MAC_LLST *) ntbl[--ncnt];
            }
            else
                plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_ASA:
        case MAC_ASB:
        case MAC_ASO:
        case MAC_ASX:
        case MAC_DFA:
            itmp = (unsigned *)plst->llink;
            data = (char *)*(itmp+1);
            optr = (char*)argcal(data, NULL, NULL);
            data = (char *)*itmp;
            is_calc( optr, &tmp, 10 );
            switch( plst->type ){
                case MAC_ASX :
                        sprintf(prmsv, "%x", tmp );
                        break;
                case MAC_ASO :
                        sprintf(prmsv, "%o", tmp );
                        break;
                case MAC_ASB :
                        optr = (char *)conv_bin( tmp );
                        strcpy( prmsv, optr );
                        break;
                default:
                        sprintf(prmsv, "%d", tmp );
                        break;
            }
            optr = (char*)argcal(data, NULL, NULL);
            p_sthash( optr, prmsv, plst->type, asn_tbl );
            if(!plst->rlink) {
                if(!ncnt)
                    return(0);
                else
                    plst = (MAC_LLST *) ntbl[--ncnt];
            }
            else
                plst = (MAC_LLST *) plst->rlink;
            break;
        case MAC_ERR:
            optr = (char*)argcal(plst->llink, NULL, NULL);
            sprintf( error_buf, "%d %s",fp[fpr_level].cnt, optr );
            longjmp( sjenv, 71 );

/*
            if(!plst->rlink) {
                if(!ncnt)
                    return(0);
                else
                    plst = (MAC_LLST *) ntbl[--ncnt];
            }
            else
                plst = (MAC_LLST *) plst->rlink;
*/
            break;
        default:
            break;
        }
    }
    return(0);
}

conv_bin( tmp)
    unsigned tmp;
{
    static char b[256];
    int  c;

    c = 255;
    b[c--] = NULL;
    for( ; tmp ; ){
        if( tmp % 2 ){
            b[c--] = '1';
        }
        else{
            b[c--] = '0';
        }
        tmp = tmp / 2;
    }
    return( (long)&b[c+1] );
}
