#include <stdio.h>
#include "ip-decode.h"
#define BUF_LINE 2048
char	mbuf[BUF_LINE];
char	buf[BUF_LINE];
 
o_nop(){} o_call(){} o_brc0(){} o_brnc0(){} o_brc1(){} o_brnc1(){}
o_seti(){} o_brcs0(){} o_brncs0(){} o_brcs1(){} o_brncs1(){} o_jmp(){}
o_ld_c(){} o_ld_cu(){} o_ld_s(){} o_ld_su(){} o_ld(){} o_ld_l(){}
o_ld_f(){} o_ld_d(){} o_ld_pf(){} o_ld_pd(){} o_st_c(){} o_st_s(){}
o_st(){} o_st_d(){} o_st_f(){} o_mov_if(){} o_mov_fi(){} o_mov_ld(){}
o_mov_dl(){} o_mult(){} o_mult_l(){} o_mult_lu(){} o_ld_c25(){}
o_ld_cu25(){} o_ld_s25(){} o_ld_su25(){} o_ld25(){} o_ld_l25(){}
o_ld_f25(){} o_ld_d25(){} o_ld_pf25(){} o_ld_pd25(){} o_st_c25(){}
o_st_s25(){} o_st25(){} o_addi25(){} o_addli25(){} o_subi25(){}
o_subli25(){} o_and25(){} o_or25(){} o_xor25(){} o_st_f25(){}
o_st_d25(){} o_mult25(){} o_mult_l25(){} o_mult_lu25(){} o_add(){}
o_addl(){} o_sub(){} o_subl(){} o_and(){} o_or(){} o_xor(){}
o_sra(){} o_srl(){} o_sll(){} o_addi5(){} o_addli5(){} o_subi5(){}
o_subli5(){} o_sra5(){} o_srl5(){} o_sll5(){} o_fadd(){} o_fadd_d(){}
o_fadd_x(){} o_fsub(){} o_fsub_d(){} o_fsub_x(){} o_fcmp(){} o_fcmp_d(){}
o_fcmp_x(){} o_fmul(){} o_fmul_d(){} o_fdiv(){} o_fdiv_d(){} o_fcnv_fd(){}
o_fcnv_df(){} o_fcnv_if(){} o_fcnv_fi(){} o_fcnv_id(){} o_fcnv_di(){}
o_fcnv_dx(){} o_fcnv_xd(){} o_fcnz_fi(){} o_fcnz_di(){} o_svc(){}
o_fwc(){} o_ldsr(){} o_stsr(){} o_ld_mcr(){} o_st_mcr(){} o_wbst(){}
o_movgs(){} o_movsg(){} o_movgt(){} o_movtg(){} o_ptlbe(){} o_ptlbp(){}
o_ptlba(){} o_flche(){} o_flcha(){} o_aki(){} o_rti(){} o_cs(){} o_COP(){}

main(argc, argv) int argc; char **argv;
{
        FILE 	 *fp = stdin;
        unsigned a, b, c, d, e, f, g, h, i, j, k, retv;
        int      sp, dwait=0, ewait=0, wwait=0;
        int      olddwait=0, oldewait=0, oldwwait=0;
        int      dstage=3, estage=2, wstage=1;
        int      olddstage=2, oldestage=1, oldwstage=0;
 
        if (argc != 2) {
	  fprintf(stderr, "usage: %s <file>\n", *argv);
          exit(1);
        }
      
        if ((fp = fopen(argv[1], "r")) == NULL) {
          fprintf(stderr, "can't open %s\n", argv[1]);
          exit(1);
        }

    	while (fgets(buf, BUF_LINE, fp) != NULL) {
          if (sscanf(buf, "%d. %x %x %x %8x%8x %x %x %x %x %x", 
              &a, &b, &c, &d, &e, &f, &g, &h, &i, &j, &k) == 11) {
            printf("%d ", a);
            olddwait = dwait;
            olddstage = dstage;
            if (g & 0x10000) {
	      disasm(0, d, e, f);
              printf("%-72s |D", mbuf);
              dwait=0;
              dstage = (dstage+1) & 3;
            }
            else {
              printf("%-72s | ", "");
              dwait++;
            }
            printf("|%c%c%c%c|%c%c%c%c|%c%c%c%c|",
              k&0x80000000?'p':' ',k&0x40000000?'i':' ',k&0x20000000?'m':' ',k&0x10000000?'c':' ',
              k&0x08000000?'i':' ',k&0x04000000?'s':' ',k&0x02000000?'d':' ',k&0x01000000?'b':' ',
              k&0x00800000?'l':' ',k&0x00400000?'o':' ',k&0x00200000?'d':' ',k&0x00100000?'s':' ');
            oldewait = ewait;
            oldestage = estage;
            if (g & 0x01000) {
              for (sp=0; sp<olddwait; sp++)
                printf(" ");
              printf("E");
              for (sp=olddwait; sp<8; sp++)
                  printf(" ");
              ewait=0;
              estage = olddstage;
            }
            else if (dwait && dstage != estage) {
              for (sp=0; sp<olddwait; sp++)
                printf(" ");
              printf("\\");
              for (sp=olddwait; sp<8; sp++)
                  printf(" ");
              ewait++;
            }
            else
              printf("         ");
            printf("|%c%c%c|%c%c%c%c|",
                                   k&0x00040000?'s':' ',k&0x00020000?'v':' ',k&0x00010000?'f':' ',
              k&0x00001000?'w':' ',k&0x00000100?'r':' ',k&0x00000010?'0':' ',k&0x00000001?'1':' ');
            oldwwait = wwait;
            oldwstage = wstage;
            if ((g & 0x00110) == 0x00110) {
              for (sp=0; sp<oldewait; sp++)
                printf(" ");
              printf("W", d);
              for (sp=oldewait; sp<8; sp++)
                  printf(" ");
              printf("%08.8x", d);
              wwait=0;
              wstage = oldestage;
            }
            else if (ewait && estage != wstage) {
              for (sp=0; sp<oldewait; sp++)
                printf(" ");
              printf("\\");
              for (sp=oldewait; sp<8; sp++)
                  printf(" ");
              wwait++;
            }
            printf("\n");
          }
	}

	exit(0);
}

disasm(t_pe, addr, insnh, insnl)
    unsigned t_pe, addr, insnh, insnl;
{
    struct tachyon_insn   *ti;
    struct tachyon_opcode *tmp_op;
    unsigned insn_u1, insn_u2;
    unsigned insn_l1, insn_l2;
    unsigned type;
    unsigned index0, index1, index2;
    char *sym;
    char mbuf2[BUF_LINE];

	type = insnh >> 28;
	sprintf(mbuf, "[%c%1.1X]", type_exchange_loc[type] ? 'X':' ', type);

	ti = &(insn_type[type]);
	insn_u1 = type<<28|insnh<<20&0x0fffffff|insnl>>12;
        insn_l1 = insnl <<20;
	insn_u2 = type<<28|insnl<<8&0x0fffff00;
        insn_l2 = 0;
        if (ti->op0 == oper_cop) {
          index0 = ((insnh >> ti->sft0) & ti->mask0)
                 | ((insnl >> ti->sft1) & ti->mask1)
                 | ((insnl >> ti->sft2) & ti->mask2);
	  if (index0 > 0) {
	    sprintf(mbuf2, " @.%1.1X", (insnh >> 24) & 0xf);
	    strcat(mbuf, mbuf2);
          }
        }
        else {
          index0 =  (insnh >> ti->sft0) & ti->mask0;
          index1 =  (insn_u1 >> ti->sft1) & ti->mask1;
          index2 =  (insn_u2 >> ti->sft2) & ti->mask2;
        }
	if (type_exchange_loc[type]) {
	  if (ti->op1) {
	    tmp_op = &((ti->op1)[index1]);
	    disasm_op(t_pe, addr, insn_u1, insn_l1, tmp_op->name, tmp_op->args);
	    sprintf(mbuf2, " %-18s", buf);
	    strcat(mbuf, mbuf2);
	  }
	  if (ti->op0) {
	    tmp_op = &((ti->op0)[index0]);
	    disasm_op(t_pe, addr, insnh, insnl, tmp_op->name, tmp_op->args);
	    sprintf(mbuf2, " & %-18s", buf);
	    strcat(mbuf, mbuf2);
	  }
        }
        else {
	  if (ti->op0) {
	    tmp_op = &((ti->op0)[index0]);
	    disasm_op(t_pe, addr, insnh, insnl, tmp_op->name, tmp_op->args);
	    sprintf(mbuf2, " %-18s", buf);
	    strcat(mbuf, mbuf2);
	  }
	  if (ti->op1) {
	    tmp_op = &((ti->op1)[index1]);
	    disasm_op(t_pe, addr, insn_u1, insn_l1, tmp_op->name, tmp_op->args);
	    sprintf(mbuf2, " & %-18s", buf);
	    strcat(mbuf, mbuf2);
	  }
	}
	if (ti->op2) {
	    tmp_op = &((ti->op2)[index2]);
	    disasm_op(t_pe, addr, insn_u2, insn_l2, tmp_op->name, tmp_op->args);
	    sprintf(mbuf2, " & %-18s", buf);
	    strcat(mbuf, mbuf2);
    	}
}

disasm_op(t_pe, addr, insn_u, insn_l, name, args)
    unsigned t_pe, addr, insn_u, insn_l;
    char     *name, *args;
{
    union insn_form insn;
    unsigned tmp;
    char buf2[20];

    insn.ful.insn_u = insn_u;
    insn.ful.insn_l = insn_l;

    if ((*args) == 'G') {
	args += 2;
	switch (insn.cop.R1_u >> 3) {
        case 1:
          sprintf(buf, "%sa ", name);
	  break;
	case 2:
          sprintf(buf, "%sb ", name);
	  break;
	default:
          sprintf(buf, "%s ", name);
	  break;
	}
    }
    else {
        sprintf(buf, "%s ", name);
    }

    for(;;) {
        switch (*args++) {
        case NULL:
	    return;
	    break;
	case ',':
	    sprintf(buf2, ",");
	    break;
	case '1': /* rs1 register. */
	    sprintf(buf2, "gr%u", insn.i5_5_5_5.r1);
	    break;
	case '2': /* rs2 register. */
	    sprintf(buf2, "gr%u", insn.i5_5_5_5.r2);
	    break;
	case '3': /* rs3 register(for 20 bit OP). */
	    sprintf(buf2, "gr%u", insn.i5_5_5_5.r3);
	    break;
	case '4': /* rs3 register(for 40 bit OP). */
	    sprintf(buf2, "gr%u", insn.i5_5_25_5.r3);
	    break;
	case '5': /* rs3 register(for 60 bit OP). */
	    sprintf(buf2, "gr%u", insn.sys_aki.r3);
	    break;
	case 'e': /* frs1 floating point register. */
	    sprintf(buf2, "fr%u", insn.i5_5_5_5.r1);
	    break;
	case 'f': /* frs2 floating point register. */
	    sprintf(buf2, "fr%u", insn.i5_5_5_5.r2);
	    break;
	case 'g': /* frs3 floating point register(for 20 bit OP). */
	    sprintf(buf2, "fr%u", insn.i5_5_5_5.r3);
	    break;
	case 'h': /* frs3 floating point register(for 40 bit OP). */
	    sprintf(buf2, "fr%u", insn.i5_5_25_5.r3);
	    break;
	case 'i': /*  5 bit Immediate. */
	    sprintf(buf2, "%d", insn.i5_5_5_5.r2 > 15 ? insn.i5_5_5_5.r2 - 32 : insn.i5_5_5_5.r2);
	    break;
	case 'u': /*  5 bit Unsigned Immediate.(for shift OP) */
	    sprintf(buf2, "%u", insn.i5_5_5_5.r2);
	    break;
	case 'j': /* 12 bit immediate. */
	    sprintf(buf2, "%d(0x%X)", insn.i3_12_5.im, insn.i3_12_5.im);
	    break;
	case 'I': /* 25 bit Immediate. */
	    tmp = (insn.i5_5_25_5.im_u << 7) + insn.i5_5_25_5.im_l;
	    sprintf(buf2, "%d(0x%X)", tmp > 0x0ffffff ? tmp - 0x2000000 : tmp, tmp);
	    break;
	case 'J': /* 32 bit Immediate. */
            sprintf(buf2, "%08.8x", (insn.i3_32_5.im_u << 7) + insn.i3_32_5.im_l, buf2);
	    break;
	case 'r': /* 12 bit PC relative immediate. */
	    tmp = insn.i3_12_5.im;
	    sprintf(buf2, ".+%08.8x", ((tmp > 0x07ff ? tmp - 0x1000 : tmp) << 3) + 8);
	    break;
	case 'R': /* 32 bit PC relative immediate. */
	    sprintf(buf2, ".+%08.8x", (((insn.i3_32_5.im_u << 7) + insn.i3_32_5.im_l) << 3) + 8);
	    break;
	case 's': /* integer/floating state register(for 20 bit OP). */
	    sprintf(buf2, "%s", star0[insn.i3_12_5.r3]);
	    break;
	case 't': /* integer/floating state register(for 40 bit OP). */
	    sprintf(buf2, "%s", star0[insn.i3_32_5.r3]);
	    break;
	case 'c': /* coprocessor state register(for 20 bit OP). */
	    sprintf(buf2, "%s", star1[insn.i3_12_5.r3]);
	    break;
	case 'd': /* coprocessor state register(for 40 bit OP). */
	    sprintf(buf2, "%s", star1[insn.i3_32_5.r3]);
	    break;
	case 'U': /* SRrsr register(for 0-31). */
	    sprintf(buf2, "sr%u", insn.sys_25.r3);
	    break;
	case 'V': /* SRrsr register(for 0-1023). */
	    sprintf(buf2, "sr%u", insn.sys_mov.r2);
	    break;
	case 'X': /* 4 bit unsigned immediate. */
	    sprintf(buf2, "%u", insn.sys_aki.im);
	    break;
	case 'Y': /* 8 bit unsigned immediate. */
	    sprintf(buf2, "%u", insn.sys_svc.im);
	    break;
	case 'x': /* 55 bit immediate(for fwc). */
	    sprintf(buf2, "(%08.8X%08.8X)", insn_u, insn_l);
	    break;
	case 'y': /* rs2 register(for type-B). */
	    sprintf(buf2, "gr%u", (insn.sys_25.r1_u << 2) + insn.sys_25.r1_l);
	    break;
	case 'z': /* 25 bit immediate(for type-B). */
	    tmp = insn.sys_25.im;
	    sprintf(buf2, "%d(0x%X)", tmp > 0x0ffffff ? tmp - 0x2000000 : tmp, tmp);
	    break;

	case 'A': /* VP R1 */
	    sprintf(buf2, "vr%u", (insn.cop.R1_u << 2) + insn.cop.R1_l);
	    break;
	case 'B': /* VP R2 */
	    sprintf(buf2, "vr%u", insn.cop.R2);
	    break;
	case 'C': /* VP R3 */
	    sprintf(buf2, "vr%u", insn.cop.R3);
	    break;
	case 'D': /* VP R4 */
	    sprintf(buf2, "vr%u", insn.cop.R4);
	    break;
	case 'L': /* VP mask R1 */
	    sprintf(buf2, "mr%u", (insn.cop.R1_u << 2) + insn.cop.R1_l);
	    break;
	case 'M': /* VP mask R2 */
	    sprintf(buf2, "mr%u", insn.cop.R2);
	    break;
	case 'N': /* VP mask R3 */
	    sprintf(buf2, "mr%u", insn.cop.R3);
	    break;
	case 'O': /* VP mask R4 */
	    sprintf(buf2, "mr%u", insn.cop.R4);
	    break;
	case '6': /* VP rr1 GR */
	    sprintf(buf2, "gr%u", insn.cop.r1);
	    break;
	case '7': /* VP rr2 GR */
	    sprintf(buf2, "gr%u", ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f);
	    break;
	case '8': /* VP rw1 GR */
	    sprintf(buf2, "gr%u", insn.cop.R2 & 0x1f);
	    break;
	case '9': /* VP rw2 GR */
	    sprintf(buf2, "gr%u", insn.cop.R3 & 0x1f);
	    break;
	case 'E': /* VP rr2 FR */
	    sprintf(buf2, "fr%u", ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f);
	    break;
	case 'F': /* VP rw2 FR */
	    sprintf(buf2, "fr%u", insn.cop.R3 & 0x1f);
	    break;
	case 'P': /* VP vcr R2 */
	    sprintf(buf2, "vcr%u", ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f);
	    break;
	case 'Q': /* VP vcr R3 */
	    sprintf(buf2, "vcr%u", insn.cop.R3 & 0x1f);
	    break;
	case 'S': /* VP vut R2 */
	    sprintf(buf2, "vut%u", ((insn.cop.R1_u << 2) + insn.cop.R1_l) & 0x1f);
	    break;
	case 'T': /* VP vut R3 */
	    sprintf(buf2, "vut%u", insn.cop.R3 & 0x1f);
	    break;
	case 'H': /* VP M */
	    sprintf(buf2, "%u", insn.cop.R4 & 3);
	    break;

	default:
	    return;
	    break;
	}
	strcat(buf, buf2);
    }
}


