/* TaChyon/KAI Instruction simulator      */
/*  Copyright (c) 1989 by FUJITSU LIMITED */
/*            Primary writer: Y.Nakashima */

/*
 * terminal.h - terminal type
 */

static struct termlist
{
	char *name;		   /* termcap entry         */
	char  len;		   /* number of chars       */
	char  terminal;		   /* internal expression   */
	char  has_no_fixed_region; /* has non-scroll region */
				   /* 1:vtem, 2:screen+vtem */
};

static struct termlist termlist[] = {
{ "kterm",	5,	'x',	0 },	/* kterm/X11           */
{ "xterm",	5,	'x',	0 },	/* xterm/X11           */
{ "wterm",	5,	'x',	0 },	/* wterm/X11           */
{ "vt100-64",	8,	'v',	0 },	/* vt100 with 64 LINES */
{ "vt100-54",	8,	'v',	0 },	/* vt100 with 54 LINES */
{ "vt100-44",	8,	'v',	0 },	/* vt100 with 44 LINES */
{ "vt100-34",	8,	'v',	0 },	/* vt100 with 34 LINES */
{ "vt100-24",	8,	'v',	0 },	/* vt100               */
{ "vt100",	5,	'v',	0 },	/* vt100               */
{ "screen",	6,	' ',	1 },	/* screen              */
{ "sun-cmd",	7,	's',	2 },	/* cmdtool             */
{ "sun",	3,	's',	1 },	/* shelltool           */
{ "fmrj",	4,	'r',	2 },	/* FMR with jtv8086    */
{ "fmr",	3,	'r',	2 },	/* FMR with fusion     */
{ "g150",	4,	'g',	2 },	/* G150 with tty       */
};

